!******************************************************************************!
!                                                                              !
!    class_couplings.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   class_couplings.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-16 19:50             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module class_couplings
  use constants_mdl
  use class_particles
  implicit none
  save
  integer, parameter :: n = 169

  logical :: couplings_init = .false.
  logical :: ctcouplings_init = .false.
  complex(dp) :: coupl(546)
  integer, parameter :: nGC_149 = 1
  integer, parameter :: nGC_8110 = 2
  integer, parameter :: nGC_28 = 3
  integer, parameter :: nGC_29 = 4
  integer, parameter :: nGC_8111 = 5
  integer, parameter :: nGC_22 = 6
  integer, parameter :: nGC_23 = 7
  integer, parameter :: nGC_20 = 8
  integer, parameter :: nGC_21 = 9
  integer, parameter :: nGC_26 = 10
  integer, parameter :: nGC_27 = 11
  integer, parameter :: nGC_24 = 12
  integer, parameter :: nGC_25 = 13
  integer, parameter :: nGC_153 = 14
  integer, parameter :: nGC_152 = 15
  integer, parameter :: nGC_151 = 16
  integer, parameter :: nGC_157 = 17
  integer, parameter :: nGC_156 = 18
  integer, parameter :: nGC_155 = 19
  integer, parameter :: nGC_154 = 20
  integer, parameter :: nGC_159 = 21
  integer, parameter :: nGC_158 = 22
  integer, parameter :: nGC_8077 = 23
  integer, parameter :: nGC_8075 = 24
  integer, parameter :: nGC_8073 = 25
  integer, parameter :: nGC_8071 = 26
  integer, parameter :: nGC_8078 = 27
  integer, parameter :: nGC_126 = 28
  integer, parameter :: nGC_127 = 29
  integer, parameter :: nGC_124 = 30
  integer, parameter :: nGC_125 = 31
  integer, parameter :: nGC_120 = 32
  integer, parameter :: nGC_121 = 33
  integer, parameter :: nGC_129 = 34
  integer, parameter :: nGC_3 = 35
  integer, parameter :: nGC_2 = 36
  integer, parameter :: nGC_1 = 37
  integer, parameter :: nGC_7 = 38
  integer, parameter :: nGC_6 = 39
  integer, parameter :: nGC_5 = 40
  integer, parameter :: nGC_4 = 41
  integer, parameter :: nGC_9 = 42
  integer, parameter :: nGC_8 = 43
  integer, parameter :: nGC_1049 = 44
  integer, parameter :: nGC_8039 = 45
  integer, parameter :: nGC_8033 = 46
  integer, parameter :: nGC_8032 = 47
  integer, parameter :: nGC_8031 = 48
  integer, parameter :: nGC_8037 = 49
  integer, parameter :: nGC_8036 = 50
  integer, parameter :: nGC_8035 = 51
  integer, parameter :: nGC_8034 = 52
  integer, parameter :: nGC_53 = 53
  integer, parameter :: nGC_52 = 54
  integer, parameter :: nGC_51 = 55
  integer, parameter :: nGC_50 = 56
  integer, parameter :: nGC_57 = 57
  integer, parameter :: nGC_56 = 58
  integer, parameter :: nGC_55 = 59
  integer, parameter :: nGC_54 = 60
  integer, parameter :: nGC_59 = 61
  integer, parameter :: nGC_58 = 62
  integer, parameter :: nGC_101 = 63
  integer, parameter :: nGC_169 = 64
  integer, parameter :: nGC_160 = 65
  integer, parameter :: nGC_10344 = 66
  integer, parameter :: nGC_10015 = 67
  integer, parameter :: nGC_10014 = 68
  integer, parameter :: nGC_10086 = 69
  integer, parameter :: nGC_835 = 70
  integer, parameter :: nGC_837 = 71
  integer, parameter :: nGC_9864 = 72
  integer, parameter :: nGC_393 = 73
  integer, parameter :: nGC_397 = 74
  integer, parameter :: nGC_150 = 75
  integer, parameter :: nGC_17 = 76
  integer, parameter :: nGC_16 = 77
  integer, parameter :: nGC_15 = 78
  integer, parameter :: nGC_14 = 79
  integer, parameter :: nGC_13 = 80
  integer, parameter :: nGC_12 = 81
  integer, parameter :: nGC_11 = 82
  integer, parameter :: nGC_10 = 83
  integer, parameter :: nGC_19 = 84
  integer, parameter :: nGC_18 = 85
  integer, parameter :: nGC_7891 = 86
  integer, parameter :: nGC_8065 = 87
  integer, parameter :: nGC_8109 = 88
  integer, parameter :: nGC_8108 = 89
  integer, parameter :: nGC_8061 = 90
  integer, parameter :: nGC_8062 = 91
  integer, parameter :: nGC_8063 = 92
  integer, parameter :: nGC_8069 = 93
  integer, parameter :: nGC_413 = 94
  integer, parameter :: nGC_135 = 95
  integer, parameter :: nGC_134 = 96
  integer, parameter :: nGC_137 = 97
  integer, parameter :: nGC_136 = 98
  integer, parameter :: nGC_131 = 99
  integer, parameter :: nGC_130 = 100
  integer, parameter :: nGC_133 = 101
  integer, parameter :: nGC_132 = 102
  integer, parameter :: nGC_2297 = 103
  integer, parameter :: nGC_2025 = 104
  integer, parameter :: nGC_139 = 105
  integer, parameter :: nGC_138 = 106
  integer, parameter :: nGC_1457 = 107
  integer, parameter :: nGC_9919 = 108
  integer, parameter :: nGC_7907 = 109
  integer, parameter :: nGC_7841 = 110
  integer, parameter :: nGC_7846 = 111
  integer, parameter :: nGC_7844 = 112
  integer, parameter :: nGC_7849 = 113
  integer, parameter :: nGC_7848 = 114
  integer, parameter :: nGC_7928 = 115
  integer, parameter :: nGC_7929 = 116
  integer, parameter :: nGC_7926 = 117
  integer, parameter :: nGC_1297 = 118
  integer, parameter :: nGC_7922 = 119
  integer, parameter :: nGC_7923 = 120
  integer, parameter :: nGC_8067 = 121
  integer, parameter :: nGC_817 = 122
  integer, parameter :: nGC_8029 = 123
  integer, parameter :: nGC_7381 = 124
  integer, parameter :: nGC_8027 = 125
  integer, parameter :: nGC_675 = 126
  integer, parameter :: nGC_48 = 127
  integer, parameter :: nGC_49 = 128
  integer, parameter :: nGC_44 = 129
  integer, parameter :: nGC_45 = 130
  integer, parameter :: nGC_46 = 131
  integer, parameter :: nGC_47 = 132
  integer, parameter :: nGC_40 = 133
  integer, parameter :: nGC_41 = 134
  integer, parameter :: nGC_42 = 135
  integer, parameter :: nGC_43 = 136
  integer, parameter :: nGC_10065 = 137
  integer, parameter :: nGC_10066 = 138
  integer, parameter :: nGC_557 = 139
  integer, parameter :: nGC_9892 = 140
  integer, parameter :: nGC_9959 = 141
  integer, parameter :: nGC_9894 = 142
  integer, parameter :: nGC_9895 = 143
  integer, parameter :: nGC_4649 = 144
  integer, parameter :: nGC_4647 = 145
  integer, parameter :: nGC_9874 = 146
  integer, parameter :: nGC_9875 = 147
  integer, parameter :: nGC_9878 = 148
  integer, parameter :: nGC_9879 = 149
  integer, parameter :: nGC_1265 = 150
  integer, parameter :: nGC_1263 = 151
  integer, parameter :: nGC_7887 = 152
  integer, parameter :: nGC_7886 = 153
  integer, parameter :: nGC_7885 = 154
  integer, parameter :: nGC_7883 = 155
  integer, parameter :: nGC_10343 = 156
  integer, parameter :: nGC_7882 = 157
  integer, parameter :: nGC_8047 = 158
  integer, parameter :: nGC_99 = 159
  integer, parameter :: nGC_98 = 160
  integer, parameter :: nGC_97 = 161
  integer, parameter :: nGC_96 = 162
  integer, parameter :: nGC_95 = 163
  integer, parameter :: nGC_94 = 164
  integer, parameter :: nGC_93 = 165
  integer, parameter :: nGC_92 = 166
  integer, parameter :: nGC_91 = 167
  integer, parameter :: nGC_90 = 168
  integer, parameter :: nGC_9909 = 169
  integer, parameter :: nGC_75 = 170
  integer, parameter :: nGC_74 = 171
  integer, parameter :: nGC_77 = 172
  integer, parameter :: nGC_76 = 173
  integer, parameter :: nGC_71 = 174
  integer, parameter :: nGC_70 = 175
  integer, parameter :: nGC_73 = 176
  integer, parameter :: nGC_72 = 177
  integer, parameter :: nGC_79 = 178
  integer, parameter :: nGC_78 = 179
  integer, parameter :: nGC_10016 = 180
  integer, parameter :: nGC_100 = 181
  integer, parameter :: nGC_11219 = 182
  integer, parameter :: nGC_102 = 183
  integer, parameter :: nGC_103 = 184
  integer, parameter :: nGC_104 = 185
  integer, parameter :: nGC_105 = 186
  integer, parameter :: nGC_106 = 187
  integer, parameter :: nGC_107 = 188
  integer, parameter :: nGC_108 = 189
  integer, parameter :: nGC_109 = 190
  integer, parameter :: nGC_10030 = 191
  integer, parameter :: nGC_10424 = 192
  integer, parameter :: nGC_9839 = 193
  integer, parameter :: nGC_2309 = 194
  integer, parameter :: nGC_10427 = 195
  integer, parameter :: nGC_9831 = 196
  integer, parameter :: nGC_9832 = 197
  integer, parameter :: nGC_981 = 198
  integer, parameter :: nGC_7850 = 199
  integer, parameter :: nGC_7851 = 200
  integer, parameter :: nGC_7852 = 201
  integer, parameter :: nGC_7853 = 202
  integer, parameter :: nGC_7857 = 203
  integer, parameter :: nGC_7858 = 204
  integer, parameter :: nGC_7919 = 205
  integer, parameter :: nGC_2415 = 206
  integer, parameter :: nGC_7911 = 207
  integer, parameter :: nGC_7910 = 208
  integer, parameter :: nGC_7912 = 209
  integer, parameter :: nGC_7914 = 210
  integer, parameter :: nGC_8041 = 211
  integer, parameter :: nGC_80 = 212
  integer, parameter :: nGC_81 = 213
  integer, parameter :: nGC_82 = 214
  integer, parameter :: nGC_8045 = 215
  integer, parameter :: nGC_5351 = 216
  integer, parameter :: nGC_8042 = 217
  integer, parameter :: nGC_8043 = 218
  integer, parameter :: nGC_8040 = 219
  integer, parameter :: nGC_437 = 220
  integer, parameter :: nGC_39 = 221
  integer, parameter :: nGC_38 = 222
  integer, parameter :: nGC_31 = 223
  integer, parameter :: nGC_30 = 224
  integer, parameter :: nGC_33 = 225
  integer, parameter :: nGC_32 = 226
  integer, parameter :: nGC_35 = 227
  integer, parameter :: nGC_34 = 228
  integer, parameter :: nGC_37 = 229
  integer, parameter :: nGC_36 = 230
  integer, parameter :: nGC_144 = 231
  integer, parameter :: nGC_145 = 232
  integer, parameter :: nGC_146 = 233
  integer, parameter :: nGC_147 = 234
  integer, parameter :: nGC_140 = 235
  integer, parameter :: nGC_141 = 236
  integer, parameter :: nGC_142 = 237
  integer, parameter :: nGC_148 = 238
  integer, parameter :: nGC_10172 = 239
  integer, parameter :: nGC_10173 = 240
  integer, parameter :: nGC_6185 = 241
  integer, parameter :: nGC_MI = 242
  integer, parameter :: nGC_MC = 243
  integer, parameter :: nGC_MB = 244
  integer, parameter :: nGC_MD = 245
  integer, parameter :: nGC_9840 = 246
  integer, parameter :: nGC_MS = 247
  integer, parameter :: nGC_MU = 248
  integer, parameter :: nGC_MT = 249
  integer, parameter :: nGC_7927 = 250
  integer, parameter :: nGC_7873 = 251
  integer, parameter :: nGC_122 = 252
  integer, parameter :: nGC_123 = 253
  integer, parameter :: nGC_7871 = 254
  integer, parameter :: nGC_7829 = 255
  integer, parameter :: nGC_7828 = 256
  integer, parameter :: nGC_7825 = 257
  integer, parameter :: nGC_7827 = 258
  integer, parameter :: nGC_7826 = 259
  integer, parameter :: nGC_243 = 260
  integer, parameter :: nGC_128 = 261
  integer, parameter :: nGC_8112 = 262
  integer, parameter :: nGC_1419 = 263
  integer, parameter :: nGC_8113 = 264
  integer, parameter :: nGC_88 = 265
  integer, parameter :: nGC_89 = 266
  integer, parameter :: nGC_8048 = 267
  integer, parameter :: nGC_8046 = 268
  integer, parameter :: nGC_2299 = 269
  integer, parameter :: nGC_83 = 270
  integer, parameter :: nGC_84 = 271
  integer, parameter :: nGC_85 = 272
  integer, parameter :: nGC_86 = 273
  integer, parameter :: nGC_87 = 274
  integer, parameter :: nGC_9939 = 275
  integer, parameter :: nGC_10507 = 276
  integer, parameter :: nGC_10506 = 277
  integer, parameter :: nGC_9931 = 278
  integer, parameter :: nGC_10509 = 279
  integer, parameter :: nGC_9932 = 280
  integer, parameter :: nGC_66 = 281
  integer, parameter :: nGC_67 = 282
  integer, parameter :: nGC_64 = 283
  integer, parameter :: nGC_65 = 284
  integer, parameter :: nGC_62 = 285
  integer, parameter :: nGC_63 = 286
  integer, parameter :: nGC_60 = 287
  integer, parameter :: nGC_61 = 288
  integer, parameter :: nGC_68 = 289
  integer, parameter :: nGC_69 = 290
  integer, parameter :: nGC_4195 = 291
  integer, parameter :: nGC_4191 = 292
  integer, parameter :: nGC_4193 = 293
  integer, parameter :: nGC_143 = 294
  integer, parameter :: nGC_10181 = 295
  integer, parameter :: nGC_10180 = 296
  integer, parameter :: nGC_119 = 297
  integer, parameter :: nGC_118 = 298
  integer, parameter :: nGC_117 = 299
  integer, parameter :: nGC_116 = 300
  integer, parameter :: nGC_115 = 301
  integer, parameter :: nGC_114 = 302
  integer, parameter :: nGC_113 = 303
  integer, parameter :: nGC_112 = 304
  integer, parameter :: nGC_111 = 305
  integer, parameter :: nGC_110 = 306
  integer, parameter :: nGC_705 = 307
  integer, parameter :: nGC_9858 = 308
  integer, parameter :: nGC_7856 = 309
  integer, parameter :: nGC_7859 = 310
  integer, parameter :: nGC_7918 = 311
  integer, parameter :: nGC_10601 = 312
  integer, parameter :: nGC_7917 = 313
  integer, parameter :: nGC_7855 = 314
  integer, parameter :: nGC_10603 = 315
  integer, parameter :: nGC_10604 = 316
  integer, parameter :: nGC_891 = 317
  integer, parameter :: nGC_211 = 318
  integer, parameter :: nGC_2445 = 319
  integer, parameter :: nGC_8028 = 320
  integer, parameter :: nGC_7383 = 321
  integer, parameter :: nGC_10136 = 322
  integer, parameter :: nGC_10135 = 323
  integer, parameter :: nGC_10011 = 324
  integer, parameter :: nGC_3033 = 325
  integer, parameter :: nGC_10013 = 326
  integer, parameter :: nGC_10012 = 327
  integer, parameter :: nGC_7869 = 328
  integer, parameter :: nGC_7868 = 329
  integer, parameter :: nGC_9814 = 330
  integer, parameter :: nGC_7901 = 331
  integer, parameter :: nGC_7865 = 332
  integer, parameter :: nGC_7864 = 333
  integer, parameter :: nGC_7866 = 334
  integer, parameter :: nGC_7861 = 335
  integer, parameter :: nGC_7860 = 336
  integer, parameter :: nGC_7908 = 337
  integer, parameter :: nGC_7862 = 338
  integer, parameter :: nGC_8099 = 339
  integer, parameter :: nGC_4589 = 340
  integer, parameter :: nGC_1137 = 341
  integer, parameter :: nGC_11221 = 342
  integer, parameter :: nGC_10087 = 343
  integer, parameter :: nGC_9925 = 344
  integer, parameter :: nGC_10082 = 345
  integer, parameter :: nGC_9813 = 346
  integer, parameter :: nGC_763 = 347
  integer, parameter :: nGC_9928 = 348
  integer, parameter :: nGC_367 = 349
  integer, parameter :: nGC_707 = 350
  integer, parameter :: nGC_703 = 351
  integer, parameter :: nGC_7872 = 352
  integer, parameter :: nGC_7870 = 353
  integer, parameter :: nGC_7876 = 354
  integer, parameter :: nGC_7877 = 355
  integer, parameter :: nGC_7874 = 356
  integer, parameter :: nGC_7875 = 357
  integer, parameter :: nGC_10655 = 358
  integer, parameter :: nGC_7840 = 359
  integer, parameter :: nGC_9861 = 360
  integer, parameter :: nGC_9860 = 361
  integer, parameter :: nGC_4797 = 362
  integer, parameter :: nGC_7913 = 363
  integer, parameter :: nGC_5349 = 364
  integer, parameter :: nGC_559 = 365
  integer, parameter :: nGC_371 = 366
  integer, parameter :: nGC_765 = 367
  integer, parameter :: nGC_7915 = 368
  integer, parameter :: nGC_9924 = 369
  integer, parameter :: nGC_10176 = 370
  integer, parameter :: nGC_4577 = 371
  integer, parameter :: nGC_9958 = 372
  integer, parameter :: nGC_10260 = 373
  integer, parameter :: nGC_10261 = 374
  integer, parameter :: nGC_1715 = 375
  integer, parameter :: nGC_10177 = 376
  integer, parameter :: nGC_555 = 377
  integer, parameter :: nGC_1713 = 378
  integer, parameter :: nGC_5337 = 379
  integer, parameter :: nGC_7809 = 380
  integer, parameter :: nGC_7806 = 381
  integer, parameter :: nGC_7805 = 382
  integer, parameter :: nGC_7804 = 383
  integer, parameter :: nGC_7803 = 384
  integer, parameter :: nGC_7802 = 385
  integer, parameter :: nGC_7801 = 386
  integer, parameter :: nGC_365 = 387
  integer, parameter :: nGC_1355 = 388
  integer, parameter :: nGC_469 = 389
  integer, parameter :: nGC_7884 = 390
  integer, parameter :: nGC_7820 = 391
  integer, parameter :: nGC_7889 = 392
  integer, parameter :: nGC_7888 = 393
  integer, parameter :: nGC_8076 = 394
  integer, parameter :: nGC_4923 = 395
  integer, parameter :: nGC_8074 = 396
  integer, parameter :: nGC_4925 = 397
  integer, parameter :: nGC_8072 = 398
  integer, parameter :: nGC_8070 = 399
  integer, parameter :: nGC_261 = 400
  integer, parameter :: nGC_10510 = 401
  integer, parameter :: nGC_725 = 402
  integer, parameter :: nGC_7818 = 403
  integer, parameter :: nGC_7819 = 404
  integer, parameter :: nGC_9927 = 405
  integer, parameter :: nGC_7814 = 406
  integer, parameter :: nGC_7832 = 407
  integer, parameter :: nGC_7816 = 408
  integer, parameter :: nGC_7817 = 409
  integer, parameter :: nGC_7810 = 410
  integer, parameter :: nGC_7811 = 411
  integer, parameter :: nGC_1667 = 412
  integer, parameter :: nGC_7894 = 413
  integer, parameter :: nGC_7895 = 414
  integer, parameter :: nGC_7896 = 415
  integer, parameter :: nGC_7890 = 416
  integer, parameter :: nGC_977 = 417
  integer, parameter :: nGC_7892 = 418
  integer, parameter :: nGC_7893 = 419
  integer, parameter :: nGC_7899 = 420
  integer, parameter :: nGC_1549 = 421
  integer, parameter :: nGC_8064 = 422
  integer, parameter :: nGC_8066 = 423
  integer, parameter :: nGC_9974 = 424
  integer, parameter :: nGC_2551 = 425
  integer, parameter :: nGC_9976 = 426
  integer, parameter :: nGC_8068 = 427
  integer, parameter :: nGC_2027 = 428
  integer, parameter :: nGC_9973 = 429
  integer, parameter :: nGC_411 = 430
  integer, parameter :: nGC_2207 = 431
  integer, parameter :: nGC_739 = 432
  integer, parameter :: nGC_737 = 433
  integer, parameter :: nGC_2209 = 434
  integer, parameter :: nGC_9911 = 435
  integer, parameter :: nGC_2043 = 436
  integer, parameter :: nGC_983 = 437
  integer, parameter :: nGC_9991 = 438
  integer, parameter :: nGC_9990 = 439
  integer, parameter :: nGC_10600 = 440
  integer, parameter :: nGC_9857 = 441
  integer, parameter :: nGC_9854 = 442
  integer, parameter :: nGC_9855 = 443
  integer, parameter :: nGC_9852 = 444
  integer, parameter :: nGC_9853 = 445
  integer, parameter :: nGC_9851 = 446
  integer, parameter :: nGC_253 = 447
  integer, parameter :: nGC_10656 = 448
  integer, parameter :: nGC_7836 = 449
  integer, parameter :: nGC_7837 = 450
  integer, parameter :: nGC_7834 = 451
  integer, parameter :: nGC_7835 = 452
  integer, parameter :: nGC_621 = 453
  integer, parameter :: nGC_7833 = 454
  integer, parameter :: nGC_7830 = 455
  integer, parameter :: nGC_7831 = 456
  integer, parameter :: nGC_979 = 457
  integer, parameter :: nGC_7906 = 458
  integer, parameter :: nGC_7904 = 459
  integer, parameter :: nGC_7838 = 460
  integer, parameter :: nGC_7839 = 461
  integer, parameter :: nGC_9984 = 462
  integer, parameter :: nGC_1519 = 463
  integer, parameter :: nGC_7905 = 464
  integer, parameter :: nGC_9981 = 465
  integer, parameter :: nGC_9982 = 466
  integer, parameter :: nGC_7916 = 467
  integer, parameter :: nGC_7902 = 468
  integer, parameter :: nGC_9827 = 469
  integer, parameter :: nGC_7903 = 470
  integer, parameter :: nGC_339 = 471
  integer, parameter :: nGC_7900 = 472
  integer, parameter :: nGC_1047 = 473
  integer, parameter :: nGC_333 = 474
  integer, parameter :: nGC_331 = 475
  integer, parameter :: nGC_9815 = 476
  integer, parameter :: nGC_337 = 477
  integer, parameter :: nGC_335 = 478
  integer, parameter :: nGC_10516 = 479
  integer, parameter :: nGC_8044 = 480
  integer, parameter :: nGC_7867 = 481
  integer, parameter :: nGC_7843 = 482
  integer, parameter :: nGC_7842 = 483
  integer, parameter :: nGC_7847 = 484
  integer, parameter :: nGC_7845 = 485
  integer, parameter :: nGC_677 = 486
  integer, parameter :: nGC_9838 = 487
  integer, parameter :: nGC_7863 = 488
  integer, parameter :: nGC_7924 = 489
  integer, parameter :: nGC_7925 = 490
  integer, parameter :: nGC_7909 = 491
  integer, parameter :: nGC_7920 = 492
  integer, parameter :: nGC_7921 = 493
  integer, parameter :: nGC_9837 = 494
  integer, parameter :: nGC_7822 = 495
  integer, parameter :: nGC_7854 = 496
  integer, parameter :: nGC_10178 = 497
  integer, parameter :: nGC_8038 = 498
  integer, parameter :: nGC_8030 = 499
  integer, parameter :: nGC_7821 = 500
  integer, parameter :: nGC_7878 = 501
  integer, parameter :: nGC_7879 = 502
  integer, parameter :: nGC_9908 = 503
  integer, parameter :: nGC_10031 = 504
  integer, parameter :: nGC_9866 = 505
  integer, parameter :: nGC_9845 = 506
  integer, parameter :: nGC_9846 = 507
  integer, parameter :: nGC_10730 = 508
  integer, parameter :: nGC_7815 = 509
  integer, parameter :: nGC_10732 = 510
  integer, parameter :: nGC_10741 = 511
  integer, parameter :: nGC_7812 = 512
  integer, parameter :: nGC_7813 = 513
  integer, parameter :: nGC_9985 = 514
  integer, parameter :: nGC_9828 = 515
  integer, parameter :: nGC_7897 = 516
  integer, parameter :: nGC_7898 = 517
  integer, parameter :: nGC_9979 = 518
  integer, parameter :: nGC_9978 = 519
  integer, parameter :: nGC_9893 = 520
  integer, parameter :: nGC_10179 = 521
  integer, parameter :: nGC_10032 = 522
  integer, parameter :: nGC_9818 = 523
  integer, parameter :: nGC_9819 = 524
  integer, parameter :: nGC_9913 = 525
  integer, parameter :: nGC_9934 = 526
  integer, parameter :: nGC_7808 = 527
  integer, parameter :: nGC_7807 = 528
  integer, parameter :: nGC_7823 = 529
  integer, parameter :: nGC_10428 = 530
  integer, parameter :: nGC_7824 = 531
  integer, parameter :: nGC_10731 = 532
  integer, parameter :: nGC_7881 = 533
  integer, parameter :: nGC_7880 = 534
  integer, parameter :: nGC_10084 = 535
  integer, parameter :: nGC_10085 = 536
  integer, parameter :: nGC_9921 = 537
  integer, parameter :: nGC_9881 = 538
  integer, parameter :: nGC_9880 = 539
  integer, parameter :: nGC_10067 = 540
  integer, parameter :: nGC_9933 = 541
  integer, parameter :: nGC_10068 = 542
  integer, parameter :: nGC_9898 = 543
  integer, parameter :: nGC_9899 = 544
  integer, parameter :: nGC_9820 = 545
  integer, parameter :: nGC_10429 = 546
  contains
  function get_coupling_value_mdl(c_id) result(ret_c)
    integer, intent(in) :: c_id
    complex(dp) :: ret_c
    if (c_id .eq. 0) then
      ret_c = cnul
    else
      ret_c = coupl(c_id)
    end if
  end function get_coupling_value_mdl
end module class_couplings
