!******************************************************************************!
!                                                                              !
!    fill_couplings2.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_couplings2.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-16 19:50             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_couplings2
  use constants_mdl
  use class_couplings
  use class_ctparameters
  implicit none
  contains
  subroutine fill_couplings_mdl2()
    coupl(nGC_68) = -CPWL2*cima*ee**2d0*vev/(4d0*cw)
    coupl(nGC_69) = CWL2*cima*ee**2d0*vev/(4d0*cw)
    coupl(nGC_4195) = -coupl(nGC_122)
    coupl(nGC_4191) = 2d0*coupl(nGC_19)
    coupl(nGC_4193) = -2d0*coupl(nGC_19)
    coupl(nGC_143) = -sqrt(2d0)*ym/2d0
    coupl(nGC_119) = -4d0*CBBL4*cima*cw*qeddim**2d0*sw*vev - CBWL4*cima*cw**2d0&
                     *qeddim**2d0*vev + CBWL4*cima*qeddim**2d0*sw**2d0*vev +   &
                     CWWL4*cima*cw*qeddim**2d0*sw*vev
    coupl(nGC_118) = -4d0*CBBL4*cima*qeddim**2d0*sw**2d0*vev - 2d0*CBWL4*cima* &
                     cw*qeddim**2d0*sw*vev - CWWL4*cima*cw**2d0*qeddim**2d0*vev
    coupl(nGC_117) = -CBL2*cima*ee**2d0*vev/4d0 - CBL2*cima*ee**2d0*sw**2d0*vev&
                     /(4d0*cw**2d0) - CWL2*cima*cw**2d0*ee**2d0*vev/(4d0*sw**  &
                     2d0) - CWL2*cima*ee**2d0*vev/4d0
    coupl(nGC_116) = cima*cw**2d0*ee**2d0*vev/(2d0*sw**2d0) + cima*ee**2d0*vev &
                      + cima*ee**2d0*sw**2d0*vev/(2d0*cw**2d0)
    coupl(nGC_115) = -cima*cw**2d0*ee**2d0*vev/(4d0*sw**2d0) - cima*ee**2d0*vev&
                     /2d0 - cima*ee**2d0*sw**2d0*vev/(4d0*cw**2d0)
    coupl(nGC_114) = -CBL2*cima*cw*ee**2d0*vev/(4d0*sw) - CBL2*cima*ee**2d0*sw*&
                     vev/(4d0*cw) + CWL2*cima*cw*ee**2d0*vev/(4d0*sw) + CWL2*  &
                     cima*ee**2d0*sw*vev/(4d0*cw)
    coupl(nGC_113) = -CPWL2*cima*cw*ee**2d0*vev/(4d0*sw) - CPWL2*cima*ee**2d0* &
                     sw*vev/(4d0*cw)
    coupl(nGC_112) = CBL2*cima*ee**2d0*vev/(4d0*sw) + CWL2*cima*ee**2d0*vev/(  &
                     4d0*sw)
    coupl(nGC_111) = CPWL2*cima*cw**2d0*ee**2d0*vev/(4d0*sw**2d0) + CPWL2*cima*&
                     ee**2d0*vev/4d0
    coupl(nGC_110) = cima*cw*ee**2d0*vev/(4d0*sw**2d0) + cima*ee**2d0*vev/(4d0*&
                     cw)
    coupl(nGC_705) = coupl(nGC_69) + coupl(nGC_85)
    coupl(nGC_891) = -coupl(nGC_42)
    coupl(nGC_211) = -coupl(nGC_36)
    coupl(nGC_2445) = -coupl(nGC_121)
    coupl(nGC_7383) = -coupl(nGC_123)
    coupl(nGC_3033) = -coupl(nGC_29)
    coupl(nGC_4589) = -coupl(nGC_83)
    coupl(nGC_1137) = -coupl(nGC_33)
    coupl(nGC_763) = coupl(nGC_107) + coupl(nGC_108)
    coupl(nGC_367) = -coupl(nGC_113)
    coupl(nGC_707) = coupl(nGC_68) + coupl(nGC_82)
    coupl(nGC_703) = coupl(nGC_67) - coupl(nGC_85)
    coupl(nGC_4797) = -coupl(nGC_117)
    coupl(nGC_5349) = -coupl(nGC_126)
    coupl(nGC_559) = -coupl(nGC_122) + coupl(nGC_97)
    coupl(nGC_371) = -coupl(nGC_16)
    coupl(nGC_765) = coupl(nGC_106) + 2d0*coupl(nGC_107)
    coupl(nGC_4577) = -coupl(nGC_107) - coupl(nGC_108)
    coupl(nGC_1715) = -coupl(nGC_82)
    coupl(nGC_555) = -coupl(nGC_20)
    coupl(nGC_1713) = -coupl(nGC_68) - coupl(nGC_82)
    coupl(nGC_5337) = -coupl(nGC_105)
    coupl(nGC_365) = -coupl(nGC_114)
    coupl(nGC_1355) = -coupl(nGC_41)
    coupl(nGC_469) = -coupl(nGC_112)
    coupl(nGC_4923) = -coupl(nGC_67) + coupl(nGC_85)
    coupl(nGC_4925) = -coupl(nGC_69) - coupl(nGC_85)
    coupl(nGC_261) = -coupl(nGC_39)
    coupl(nGC_725) = -coupl(nGC_88)
    coupl(nGC_1667) = -coupl(nGC_34)
    coupl(nGC_977) = -coupl(nGC_101) - coupl(nGC_99)
    coupl(nGC_1549) = -coupl(nGC_100)
    coupl(nGC_2551) = -coupl(nGC_111)
    coupl(nGC_2027) = -coupl(nGC_54)
    coupl(nGC_411) = 2d0*coupl(nGC_37)
    coupl(nGC_2207) = -coupl(nGC_84)
    coupl(nGC_739) = -coupl(nGC_32)
    coupl(nGC_737) = -coupl(nGC_40)
    coupl(nGC_2209) = -coupl(nGC_80)
    coupl(nGC_2043) = -coupl(nGC_81)
    coupl(nGC_983) = -coupl(nGC_102) - coupl(nGC_98)
    coupl(nGC_253) = -coupl(nGC_147)
    coupl(nGC_621) = -coupl(nGC_30)
    coupl(nGC_979) = -coupl(nGC_103) - coupl(nGC_99)
    coupl(nGC_1519) = -coupl(nGC_96)
    coupl(nGC_339) = coupl(nGC_122) - coupl(nGC_97)
    coupl(nGC_1047) = -coupl(nGC_15)
    coupl(nGC_333) = coupl(nGC_103) + coupl(nGC_99)
    coupl(nGC_331) = coupl(nGC_101) + coupl(nGC_99)
    coupl(nGC_337) = coupl(nGC_122) + coupl(nGC_97)
    coupl(nGC_335) = coupl(nGC_102) + coupl(nGC_98)
    coupl(nGC_677) = -2d0*coupl(nGC_37)
  end subroutine fill_couplings_mdl2
end module fill_couplings2
