!******************************************************************************!
!                                                                              !
!    fill_ctcouplings1.f90                                                     !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_ctcouplings1.f90                          |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-16 19:50             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_ctcouplings1
  use constants_mdl
  use class_couplings
  use class_ctparameters
  implicit none
  contains
  subroutine fill_CTcouplings_mdl1()
    coupl(nGC_8110) = -cima*dMD_QCD2
    coupl(nGC_8111) = -cima*dMC_QCD2
    coupl(nGC_8078) = coupl(nGC_8077)*dyup_QED1_QCD2
    coupl(nGC_8033) = cima*dyup_QED1_QCD2
    coupl(nGC_8032) = cima*dyt_QED1_QCD2
    coupl(nGC_8031) = -cima*dyb_QED1_QCD2
    coupl(nGC_8036) = cima*dyc_QED1_QCD2
    coupl(nGC_8035) = -cima*dys_QED1_QCD2
    coupl(nGC_8034) = -cima*dydo_QED1_QCD2
    coupl(nGC_10344) = coupl(nGC_1)*dZbL_QCD2
    coupl(nGC_10015) = coupl(nGC_2)*dZtR_QCD2
    coupl(nGC_10014) = coupl(nGC_53)*dZcL_QCD2
    coupl(nGC_10086) = coupl(nGC_53)*dZtL_QCD2
    coupl(nGC_9864) = coupl(nGC_151)*(dZtL_QCD2 + dZtR_QCD2)/2d0
    coupl(nGC_7891) = coupl(nGC_149)*coupl(nGC_17)**2d0*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(16d0*pi**2d0*Nc)
    coupl(nGC_8109) = -cima*dMU_QCD2
    coupl(nGC_8108) = -cima*dMT_QCD2
    coupl(nGC_8062) = coupl(nGC_8061)*dyc_QED1_QCD2
    coupl(nGC_9919) = coupl(nGC_133)*(dZcL_QCD2 + dZcR_QCD2)/2d0
    coupl(nGC_7907) = cima*coupl(nGC_17)**3d0*sq2**3d0*(coupl(nGC_1) + coupl(  &
                      nGC_2))/(64d0*pi**2d0)
    coupl(nGC_7841) = cMD*cima*coupl(nGC_17)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(  &
                      32d0*pi**2d0*Nc)
    coupl(nGC_7846) = cMB*cima*coupl(nGC_17)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(  &
                      32d0*pi**2d0*Nc)
    coupl(nGC_7844) = cMS*cima*coupl(nGC_17)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(  &
                      32d0*pi**2d0*Nc)
    coupl(nGC_7849) = coupl(nGC_1)*coupl(nGC_17)**2d0*sq2**2d0*(Nc**2d0 - 1d0  &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_7848) = coupl(nGC_17)**2d0*coupl(nGC_2)*sq2**2d0*(Nc**2d0 - 1d0  &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_7928) = cima*coupl(nGC_17)**4d0*sq2**4d0/(32d0*pi**2d0*Nc**2d0)
    coupl(nGC_7929) = -3d0*cima*coupl(nGC_17)**4d0*sq2**4d0/(32d0*pi**2d0*Nc** &
                      3d0)
    coupl(nGC_7926) = (-8d0*Nc*cima*coupl(nGC_16)**4d0*sq2**4d0 - 24d0*Nc*cima*&
                      coupl(nGC_18)*coupl(nGC_2297) + 3d0*Nc*coupl(nGC_16)**2d0&
                      *coupl(nGC_18)*sq2**2d0 - 39d0*Nc*coupl(nGC_16)**2d0*    &
                      coupl(nGC_2297)*sq2**2d0 + 36d0*cima*coupl(nGC_17)**4d0* &
                      sq2**4d0)/(768d0*pi**2d0)
    coupl(nGC_7922) = (-4d0*Nc*cima*coupl(nGC_16)**4d0*sq2**4d0 - 12d0*Nc*cima*&
                      coupl(nGC_18)*coupl(nGC_2297) + 12d0*Nc*coupl(nGC_16)**  &
                      2d0*coupl(nGC_18)*sq2**2d0 - 9d0*Nc*coupl(nGC_16)**2d0*  &
                      coupl(nGC_2297)*sq2**2d0 + 18d0*cima*coupl(nGC_17)**4d0* &
                      sq2**4d0)/(384d0*pi**2d0)
    coupl(nGC_7923) = (-8d0*Nc*cima*coupl(nGC_16)**4d0*sq2**4d0 + 12d0*Nc*cima*&
                      coupl(nGC_18)**2d0 + 12d0*Nc*cima*coupl(nGC_2297)**2d0 + &
                      39d0*Nc*coupl(nGC_16)**2d0*coupl(nGC_18)*sq2**2d0 - 3d0* &
                      Nc*coupl(nGC_16)**2d0*coupl(nGC_2297)*sq2**2d0 + 36d0*   &
                      cima*coupl(nGC_17)**4d0*sq2**4d0)/(768d0*pi**2d0)
    coupl(nGC_10065) = coupl(nGC_17)*dZbR_QCD2
    coupl(nGC_10066) = coupl(nGC_17)*dZbL_QCD2
    coupl(nGC_9892) = coupl(nGC_130)*(dZbL_QCD2 + dZbR_QCD2)/2d0
    coupl(nGC_9959) = coupl(nGC_149)*dZbL_QCD2/2d0 + coupl(nGC_149)*dZtR_QCD2/ &
                      2d0 + coupl(nGC_8032)
    coupl(nGC_9894) = coupl(nGC_17)*dZuR_QCD2
    coupl(nGC_9895) = coupl(nGC_17)*dZuL_QCD2
    coupl(nGC_9874) = coupl(nGC_159)*(dZuL_QCD2 + dZuR_QCD2)/2d0
    coupl(nGC_9875) = coupl(nGC_8078) + coupl(nGC_9874)
    coupl(nGC_9878) = coupl(nGC_17)*dZcR_QCD2
    coupl(nGC_9879) = coupl(nGC_17)*dZcL_QCD2
    coupl(nGC_7887) = coupl(nGC_129)*coupl(nGC_17)**2d0*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(16d0*pi**2d0*Nc)
    coupl(nGC_7886) = coupl(nGC_17)**2d0*coupl(nGC_397)*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(16d0*pi**2d0*Nc)
    coupl(nGC_7885) = coupl(nGC_130)*coupl(nGC_17)**2d0*sq2**2d0*(Nc**2d0 - 1d0&
                      )/(16d0*pi**2d0*Nc)
    coupl(nGC_7883) = sq2**3d0*(11d0*Nc*cima*coupl(nGC_16)**3d0 + 48d0*coupl(  &
                      nGC_17)**3d0)/(768d0*pi**2d0)
    coupl(nGC_10343) = coupl(nGC_1)*dZbR_QCD2
    coupl(nGC_7882) = sq2**3d0*(-11d0*Nc*cima*coupl(nGC_16)**3d0 - 48d0*coupl( &
                      nGC_17)**3d0)/(768d0*pi**2d0)
    coupl(nGC_9909) = coupl(nGC_132)*dZcL_QCD2/2d0 + coupl(nGC_132)*dZcR_QCD2/ &
                      2d0 + coupl(nGC_8062)
    coupl(nGC_10016) = coupl(nGC_2)*dZtL_QCD2
    coupl(nGC_11219) = -coupl(nGC_7882)
  end subroutine fill_CTcouplings_mdl1
end module fill_ctcouplings1
