!******************************************************************************!
!                                                                              !
!    fill_ctcouplings2.f90                                                     !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_ctcouplings2.f90                          |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-16 19:50             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_ctcouplings2
  use constants_mdl
  use class_couplings
  use class_ctparameters
  implicit none
  contains
  subroutine fill_CTcouplings_mdl2()
    coupl(nGC_10030) = coupl(nGC_129)*(dZbL_QCD2 + dZbR_QCD2)/2d0
    coupl(nGC_10424) = coupl(nGC_17)*dZsL_QCD2
    coupl(nGC_9839) = coupl(nGC_52)*dZsL_QCD2
    coupl(nGC_10427) = coupl(nGC_17)*dZsR_QCD2
    coupl(nGC_9831) = coupl(nGC_1)*dZsR_QCD2
    coupl(nGC_9832) = coupl(nGC_1)*dZsL_QCD2
    coupl(nGC_7850) = coupl(nGC_17)**2d0*coupl(nGC_53)*sq2**2d0*(Nc**2d0 - 1d0 &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_7851) = coupl(nGC_17)**2d0*coupl(nGC_49)*sq2**2d0*(Nc**2d0 - 1d0 &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_7852) = coupl(nGC_17)**2d0*coupl(nGC_52)*sq2**2d0*(Nc**2d0 - 1d0 &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_7853) = coupl(nGC_17)**2d0*coupl(nGC_48)*sq2**2d0*(Nc**2d0 - 1d0 &
                      )/(32d0*pi**2d0*Nc)
    coupl(nGC_7857) = coupl(nGC_17)*sq2*(-coupl(nGC_157)**2d0 - coupl(nGC_158)*&
                      coupl(nGC_160) - coupl(nGC_159)**2d0 - 4d0*coupl(nGC_2)**&
                      2d0 - 4d0*coupl(nGC_49)**2d0)/(64d0*pi**2d0*Nc)
    coupl(nGC_7858) = coupl(nGC_17)**2d0*sq2**3d0*(Nc**2d0*cima*coupl(nGC_16   &
                      ) + coupl(nGC_17))/(64d0*pi**2d0*Nc**2d0)
    coupl(nGC_7919) = (-5d0*cima*coupl(nGC_16)**4d0*sq2**4d0 + 3d0*cima*coupl( &
                      nGC_18)**2d0 - 6d0*cima*coupl(nGC_18)*coupl(nGC_2297) +  &
                      3d0*cima*coupl(nGC_2297)**2d0 + 9d0*coupl(nGC_16)**2d0*  &
                      coupl(nGC_18)*sq2**2d0 - 6d0*coupl(nGC_16)**2d0*coupl(   &
                      nGC_2297)*sq2**2d0)/(96d0*pi**2d0)
    coupl(nGC_7911) = cima*coupl(nGC_17)**3d0*sq2**3d0*(-coupl(nGC_48) - coupl(&
                      nGC_49) - coupl(nGC_52) - coupl(nGC_53))/(64d0*pi**2d0*Nc&
                      )
    coupl(nGC_7910) = cima*coupl(nGC_17)**3d0*sq2**3d0*(coupl(nGC_48) + coupl( &
                      nGC_49) + coupl(nGC_52) + coupl(nGC_53))/(128d0*pi**2d0)
    coupl(nGC_7912) = cima*coupl(nGC_17)**3d0*sq2**3d0*(coupl(nGC_48) + coupl( &
                      nGC_49) + coupl(nGC_52) + coupl(nGC_53))/(32d0*pi**2d0*Nc&
                      **2d0)
    coupl(nGC_7914) = (-8d0*Nc*cima*coupl(nGC_16)**4d0*sq2**4d0 + 12d0*Nc*cima*&
                      coupl(nGC_18)**2d0 + 12d0*Nc*cima*coupl(nGC_2297)**2d0 + &
                      21d0*Nc*coupl(nGC_16)**2d0*coupl(nGC_18)*sq2**2d0 - 21d0*&
                      Nc*coupl(nGC_16)**2d0*coupl(nGC_2297)*sq2**2d0 + 36d0*   &
                      cima*coupl(nGC_17)**4d0*sq2**4d0)/(768d0*pi**2d0)
    coupl(nGC_8042) = coupl(nGC_8041)*dys_QED1_QCD2
    coupl(nGC_8040) = coupl(nGC_8039)*dydo_QED1_QCD2
    coupl(nGC_10172) = coupl(nGC_52)*dZbL_QCD2
    coupl(nGC_10173) = coupl(nGC_48)*dZbR_QCD2
    coupl(nGC_9840) = coupl(nGC_48)*dZsR_QCD2
    coupl(nGC_7927) = (-4d0*Nc*cima*coupl(nGC_16)**4d0*sq2**4d0 - 12d0*Nc*cima*&
                      coupl(nGC_18)*coupl(nGC_2297) + 9d0*Nc*coupl(nGC_16)**2d0&
                      *coupl(nGC_18)*sq2**2d0 - 12d0*Nc*coupl(nGC_16)**2d0*    &
                      coupl(nGC_2297)*sq2**2d0 + 18d0*cima*coupl(nGC_17)**4d0* &
                      sq2**4d0)/(384d0*pi**2d0)
    coupl(nGC_7873) = coupl(nGC_17)*sq2*(coupl(nGC_131)**2d0 + coupl(nGC_132)* &
                      coupl(nGC_134) + coupl(nGC_133)**2d0 + 4d0*coupl(nGC_2)**&
                      2d0 + 4d0*coupl(nGC_49)**2d0)/(64d0*pi**2d0)
    coupl(nGC_7871) = coupl(nGC_17)*sq2*(-coupl(nGC_131)**2d0 - coupl(nGC_132)*&
                      coupl(nGC_134) - coupl(nGC_133)**2d0 - 4d0*coupl(nGC_2)**&
                      2d0 - 4d0*coupl(nGC_49)**2d0)/(64d0*pi**2d0*Nc)
    coupl(nGC_7829) = cMM*cima*(-coupl(nGC_4)**2d0 - coupl(nGC_50)*coupl(nGC_54&
                      ))/(8d0*pi**2d0)
    coupl(nGC_7828) = cima*(-coupl(nGC_4)**2d0 - coupl(nGC_50)**2d0)/(16d0*pi**&
                      2d0)
    coupl(nGC_7825) = cima*(-coupl(nGC_31)**2d0 - coupl(nGC_55)**2d0)/(16d0*pi &
                      **2d0)
    coupl(nGC_7827) = cME*cima*(-coupl(nGC_4)**2d0 - coupl(nGC_50)*coupl(nGC_54&
                      ))/(8d0*pi**2d0)
    coupl(nGC_7826) = cima*(-coupl(nGC_31)**2d0 - coupl(nGC_4)**2d0 - coupl(   &
                      nGC_54)**2d0)/(16d0*pi**2d0)
    coupl(nGC_8112) = -cima*dMS_QCD2
    coupl(nGC_8113) = -cima*dMB_QCD2
    coupl(nGC_8048) = coupl(nGC_8047)*dys_QED1_QCD2
    coupl(nGC_8046) = coupl(nGC_8045)*dydo_QED1_QCD2
    coupl(nGC_9939) = coupl(nGC_31)*(dZdL_QCD2 + dZuL_QCD2)/2d0
    coupl(nGC_10507) = coupl(nGC_MU)*(dZuL_QCD2 + dZuR_QCD2)/2d0
    coupl(nGC_10506) = coupl(nGC_MI)*dZuL_QCD2
    coupl(nGC_9931) = coupl(nGC_17)*dZdL_QCD2
    coupl(nGC_10509) = coupl(nGC_MI)*dZuR_QCD2
    coupl(nGC_9932) = coupl(nGC_17)*dZdR_QCD2
    coupl(nGC_10181) = coupl(nGC_53)*dZuL_QCD2
    coupl(nGC_10180) = coupl(nGC_49)*dZuR_QCD2
    coupl(nGC_9858) = coupl(nGC_MB)*(dZbL_QCD2 + dZbR_QCD2)/2d0
    coupl(nGC_7856) = coupl(nGC_17)*sq2*(-coupl(nGC_135)**2d0 - coupl(nGC_158)*&
                      coupl(nGC_160) - coupl(nGC_159)**2d0 - 4d0*coupl(nGC_2)**&
                      2d0 - 4d0*coupl(nGC_31)**2d0 - 4d0*coupl(nGC_53)**2d0)/( &
                      64d0*pi**2d0*Nc)
    coupl(nGC_7859) = coupl(nGC_17)*sq2*(coupl(nGC_135)**2d0 + coupl(nGC_158)* &
                      coupl(nGC_160) + coupl(nGC_159)**2d0 + 4d0*coupl(nGC_2)**&
                      2d0 + 4d0*coupl(nGC_31)**2d0 + 4d0*coupl(nGC_53)**2d0)/( &
                      64d0*pi**2d0)
    coupl(nGC_7918) = (-20d0*cima*coupl(nGC_16)**4d0*sq2**4d0 + 12d0*cima*coupl&
                      (nGC_2299)**2d0 + 3d0*coupl(nGC_16)**2d0*coupl(nGC_18)*  &
                      sq2**2d0 + 3d0*coupl(nGC_16)**2d0*coupl(nGC_2297)*sq2**  &
                      2d0 + 33d0*coupl(nGC_16)**2d0*coupl(nGC_2299)*sq2**2d0 + &
                      3d0*coupl(nGC_16)**2d0*coupl(nGC_2309)*sq2**2d0)/(384d0* &
                      pi**2d0)
    coupl(nGC_10601) = coupl(nGC_MT)*(dZtL_QCD2 + dZtR_QCD2)/2d0
    coupl(nGC_7917) = (10d0*Nc*cima*coupl(nGC_16)**4d0*sq2**4d0 - 6d0*Nc*cima* &
                      coupl(nGC_18)*coupl(nGC_2299) + 6d0*Nc*cima*coupl(       &
                      nGC_2297)*coupl(nGC_2299) - 9d0*Nc*coupl(nGC_16)**2d0*   &
                      coupl(nGC_18)*sq2**2d0 + 9d0*Nc*coupl(nGC_16)**2d0*coupl(&
                      nGC_2297)*sq2**2d0 - 9d0*Nc*coupl(nGC_16)**2d0*coupl(    &
                      nGC_2299)*sq2**2d0 - 3d0*Nc*coupl(nGC_16)**2d0*coupl(    &
                      nGC_2309)*sq2**2d0 - 6d0*cima*coupl(nGC_17)**4d0*sq2**4d0&
                      )/(384d0*pi**2d0*Nc)
    coupl(nGC_7855) = coupl(nGC_17)**2d0*sq2**2d0*(cMB*coupl(nGC_130) + cMC*   &
                      coupl(nGC_133) + cMD*coupl(nGC_137) + cMS*coupl(nGC_148  &
                      ) + cMT*coupl(nGC_151) + cMU*coupl(nGC_159))/(16d0*pi**  &
                      2d0*Nc)
    coupl(nGC_10603) = coupl(nGC_MI)*dZtR_QCD2
  end subroutine fill_CTcouplings_mdl2
end module fill_ctcouplings2
