!******************************************************************************!
!                                                                              !
!    fill_ctcouplings3.f90                                                     !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_ctcouplings3.f90                          |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-16 19:50             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_ctcouplings3
  use constants_mdl
  use class_couplings
  use class_ctparameters
  implicit none
  contains
  subroutine fill_CTcouplings_mdl3()
    coupl(nGC_10604) = coupl(nGC_10601) + coupl(nGC_8108)
    coupl(nGC_8028) = coupl(nGC_8027)*dZgs_QCD2
    coupl(nGC_10136) = coupl(nGC_1)*dZdR_QCD2
    coupl(nGC_10135) = coupl(nGC_1)*dZdL_QCD2
    coupl(nGC_10011) = coupl(nGC_148)*(dZsL_QCD2 + dZsR_QCD2)/2d0
    coupl(nGC_10013) = coupl(nGC_49)*dZcR_QCD2
    coupl(nGC_10012) = coupl(nGC_10011) + coupl(nGC_8048)
    coupl(nGC_7869) = coupl(nGC_17)*sq2*(4d0*coupl(nGC_1)**2d0 + coupl(nGC_1297&
                      )*coupl(nGC_136) + coupl(nGC_135)**2d0 + coupl(nGC_137)**&
                      2d0 + 4d0*coupl(nGC_48)**2d0)/(64d0*pi**2d0)
    coupl(nGC_7868) = coupl(nGC_17)*sq2*(4d0*coupl(nGC_1)**2d0 + coupl(nGC_1297&
                      )*coupl(nGC_136) + coupl(nGC_137)**2d0 + coupl(nGC_157)**&
                      2d0 + 4d0*coupl(nGC_31)**2d0 + 4d0*coupl(nGC_52)**2d0)/( &
                      64d0*pi**2d0)
    coupl(nGC_9814) = coupl(nGC_17)*dZtR_QCD2
    coupl(nGC_7901) = cima*coupl(nGC_17)**2d0*sq2**2d0*(-coupl(nGC_128)**2d0 - &
                      coupl(nGC_131)**2d0 - coupl(nGC_135)**2d0 - coupl(nGC_146&
                      )**2d0 - coupl(nGC_149)**2d0 - coupl(nGC_157)**2d0)/(32d0&
                      *pi**2d0)
    coupl(nGC_7865) = coupl(nGC_17)*sq2*(coupl(nGC_149)**2d0 + coupl(nGC_150)* &
                      coupl(nGC_152) + coupl(nGC_151)**2d0 + 4d0*coupl(nGC_2)**&
                      2d0 + 4d0*coupl(nGC_49)**2d0)/(64d0*pi**2d0)
    coupl(nGC_7864) = coupl(nGC_17)*sq2*(coupl(nGC_128)**2d0 + coupl(nGC_150)* &
                      coupl(nGC_152) + coupl(nGC_151)**2d0 + 4d0*coupl(nGC_2)**&
                      2d0 + 4d0*coupl(nGC_31)**2d0 + 4d0*coupl(nGC_53)**2d0)/( &
                      64d0*pi**2d0)
    coupl(nGC_7866) = coupl(nGC_17)*sq2*(-4d0*coupl(nGC_1)**2d0 - coupl(       &
                      nGC_1297)*coupl(nGC_136) - coupl(nGC_137)**2d0 - coupl(  &
                      nGC_157)**2d0 - 4d0*coupl(nGC_31)**2d0 - 4d0*coupl(nGC_52&
                      )**2d0)/(64d0*pi**2d0*Nc)
    coupl(nGC_7861) = coupl(nGC_17)**2d0*sq2**3d0*(-Nc**2d0*cima*coupl(nGC_16  &
                      ) - coupl(nGC_17))/(64d0*pi**2d0*Nc)
    coupl(nGC_7860) = coupl(nGC_17)*sq2*(coupl(nGC_157)**2d0 + coupl(nGC_158)* &
                      coupl(nGC_160) + coupl(nGC_159)**2d0 + 4d0*coupl(nGC_2)**&
                      2d0 + 4d0*coupl(nGC_49)**2d0)/(64d0*pi**2d0)
    coupl(nGC_7908) = cima*coupl(nGC_17)**3d0*sq2**3d0*(-coupl(nGC_1) - coupl( &
                      nGC_2))/(32d0*pi**2d0*Nc)
    coupl(nGC_7862) = coupl(nGC_17)*sq2*(-coupl(nGC_128)**2d0 - coupl(nGC_150)*&
                      coupl(nGC_152) - coupl(nGC_151)**2d0 - 4d0*coupl(nGC_2)**&
                      2d0 - 4d0*coupl(nGC_31)**2d0 - 4d0*coupl(nGC_53)**2d0)/( &
                      64d0*pi**2d0*Nc)
    coupl(nGC_8099) = coupl(nGC_169)*dZgs_QCD2
    coupl(nGC_11221) = -coupl(nGC_7883)
    coupl(nGC_10087) = coupl(nGC_49)*dZtR_QCD2
    coupl(nGC_9925) = coupl(nGC_MS)*(dZsL_QCD2 + dZsR_QCD2)/2d0
    coupl(nGC_10082) = coupl(nGC_136)*(dZdL_QCD2 + dZdR_QCD2)/2d0
    coupl(nGC_9813) = coupl(nGC_31)*(dZbL_QCD2 + dZtL_QCD2)/2d0
    coupl(nGC_9928) = coupl(nGC_8112) + coupl(nGC_9925)
    coupl(nGC_7872) = coupl(nGC_17)*sq2*(coupl(nGC_132)*coupl(nGC_134) + coupl(&
                      nGC_133)**2d0 + coupl(nGC_146)**2d0 + 4d0*coupl(nGC_2)** &
                      2d0 + 4d0*coupl(nGC_31)**2d0 + 4d0*coupl(nGC_53)**2d0)/( &
                      64d0*pi**2d0)
    coupl(nGC_7870) = coupl(nGC_17)*sq2*(-coupl(nGC_132)*coupl(nGC_134) - coupl&
                      (nGC_133)**2d0 - coupl(nGC_146)**2d0 - 4d0*coupl(nGC_2)**&
                      2d0 - 4d0*coupl(nGC_31)**2d0 - 4d0*coupl(nGC_53)**2d0)/( &
                      64d0*pi**2d0*Nc)
    coupl(nGC_7876) = coupl(nGC_17)*sq2*(4d0*coupl(nGC_1)**2d0 + coupl(nGC_129 &
                      )*coupl(nGC_397) + coupl(nGC_130)**2d0 + coupl(nGC_149)**&
                      2d0 + 4d0*coupl(nGC_31)**2d0 + 4d0*coupl(nGC_52)**2d0)/( &
                      64d0*pi**2d0)
    coupl(nGC_7877) = coupl(nGC_17)*sq2*(4d0*coupl(nGC_1)**2d0 + coupl(nGC_128 &
                      )**2d0 + coupl(nGC_129)*coupl(nGC_397) + coupl(nGC_130)**&
                      2d0 + 4d0*coupl(nGC_48)**2d0)/(64d0*pi**2d0)
    coupl(nGC_7874) = coupl(nGC_17)*sq2*(-4d0*coupl(nGC_1)**2d0 - coupl(nGC_129&
                      )*coupl(nGC_397) - coupl(nGC_130)**2d0 - coupl(nGC_149)**&
                      2d0 - 4d0*coupl(nGC_31)**2d0 - 4d0*coupl(nGC_52)**2d0)/( &
                      64d0*pi**2d0*Nc)
    coupl(nGC_7875) = coupl(nGC_17)*sq2*(-4d0*coupl(nGC_1)**2d0 - coupl(nGC_128&
                      )**2d0 - coupl(nGC_129)*coupl(nGC_397) - coupl(nGC_130)**&
                      2d0 - 4d0*coupl(nGC_48)**2d0)/(64d0*pi**2d0*Nc)
    coupl(nGC_10655) = coupl(nGC_MI)*dZg_QCD2
    coupl(nGC_7840) = cima*(-coupl(nGC_1)**2d0 - coupl(nGC_31)**2d0 - coupl(   &
                      nGC_52)**2d0)/(16d0*pi**2d0)
    coupl(nGC_9861) = coupl(nGC_8113) + coupl(nGC_9858)
    coupl(nGC_9860) = coupl(nGC_MI)*dZbR_QCD2
    coupl(nGC_7913) = sq2**2d0*(-2d0*Nc*cima*coupl(nGC_16)**4d0*sq2**2d0 - 3d0*&
                      Nc*coupl(nGC_16)**2d0*coupl(nGC_2299) + 3d0*Nc*coupl(    &
                      nGC_16)**2d0*coupl(nGC_2309) - 30d0*cima*coupl(nGC_17)** &
                      4d0*sq2**2d0)/(384d0*pi**2d0)
    coupl(nGC_7915) = (20d0*Nc*cima*coupl(nGC_16)**4d0*sq2**4d0 - 12d0*Nc*cima*&
                      coupl(nGC_18)*coupl(nGC_2299) + 12d0*Nc*cima*coupl(      &
                      nGC_2297)*coupl(nGC_2299) - 21d0*Nc*coupl(nGC_16)**2d0*  &
                      coupl(nGC_18)*sq2**2d0 + 15d0*Nc*coupl(nGC_16)**2d0*coupl&
                      (nGC_2297)*sq2**2d0 - 15d0*Nc*coupl(nGC_16)**2d0*coupl(  &
                      nGC_2299)*sq2**2d0 - 3d0*Nc*coupl(nGC_16)**2d0*coupl(    &
                      nGC_2309)*sq2**2d0 - 12d0*cima*coupl(nGC_17)**4d0*sq2**  &
                      4d0)/(768d0*pi**2d0*Nc)
    coupl(nGC_9924) = coupl(nGC_MI)*dZsL_QCD2
    coupl(nGC_10176) = coupl(nGC_MI)*dZdL_QCD2
    coupl(nGC_9958) = coupl(nGC_128)*dZbR_QCD2/2d0 + coupl(nGC_128)*dZtL_QCD2/ &
                      2d0 + coupl(nGC_8031)
    coupl(nGC_10260) = coupl(nGC_2)*dZcR_QCD2
    coupl(nGC_10261) = coupl(nGC_2)*dZcL_QCD2
    coupl(nGC_10177) = coupl(nGC_MD)*(dZdL_QCD2 + dZdR_QCD2)/2d0
    coupl(nGC_7809) = cima*(-2d0*Nc*coupl(nGC_31)**2d0 - coupl(nGC_211)**2d0 - &
                      coupl(nGC_3)**2d0 - 2d0*coupl(nGC_31)**2d0 - coupl(nGC_36&
                      )**2d0 - coupl(nGC_437)**2d0)/(32d0*pi**2d0)
    coupl(nGC_7806) = cima*coupl(nGC_17)**2d0*sq2**2d0*(-cMB**2d0 - cMC**2d0 - &
                      cMD**2d0 - cMS**2d0 - cMT**2d0 - cMU**2d0)/(16d0*pi**2d0*&
                      Nc)
    coupl(nGC_7805) = cima*coupl(nGC_16)**2d0*sq2**2d0/(96d0*pi**2d0)
    coupl(nGC_7804) = cima*sq2**2d0*(-Nc*coupl(nGC_16)**2d0 + 4d0*coupl(nGC_17 &
                      )**2d0)/(64d0*pi**2d0*Nc)
    coupl(nGC_7803) = cima*coupl(nGC_17)**2d0*sq2**2d0*(cMB**2d0 + cMC**2d0 +  &
                      cMD**2d0 + cMS**2d0 + cMT**2d0 + cMU**2d0)/(16d0*pi**2d0)
    coupl(nGC_7802) = -Nc*cima*coupl(nGC_16)**2d0*sq2**2d0/(96d0*pi**2d0)
    coupl(nGC_7801) = cima*sq2**2d0*(Nc*coupl(nGC_16)**2d0 - 4d0*coupl(nGC_17  &
                      )**2d0)/(64d0*pi**2d0)
  end subroutine fill_CTcouplings_mdl3
end module fill_ctcouplings3
