!******************************************************************************!
!                                                                              !
!    tcSVV.f90                                                                 !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSVV.f90                                      |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-16 19:50             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSVV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113, x114, x115, x116, x117,  &
                  x118, x119, x120, x121, x122, x123, x124, x125, x126, x127,  &
                  x128, x129, x130, x131, x132, x133, x134, x135, x136, x137,  &
                  x138, x139, x140, x141, x142, x143, x144, x145, x146, x147,  &
                  x148, x149, x150, x151, x152, x153, x154, x155, x156, x157,  &
                  x158, x159, x160, x161, x162, x163, x164, x165, x166, x167,  &
                  x168, x169, x170, x171, x172, x173, x174, x175, x176, x177,  &
                  x178, x179, x180, x181, x182, x183, x184, x185, x186, x187,  &
                  x188, x189, x190, x191, x192, x193, x194, x195, x196, x197,  &
                  x198, x199, x200, x201, x202, x203, x204, x205, x206, x207,  &
                  x208, x209, x210, x211, x212, x213, x214, x215, x216, x217,  &
                  x218, x219, x220, x221, x222, x223, x224, x225, x226, x227,  &
                  x228, x229, x230, x231, x232, x233, x234, x235, x236, x237,  &
                  x238, x239, x240, x241, x242, x243, x244, x245, x246, x247,  &
                  x248, x249, x250, x251, x252, x253, x254, x255, x256, x257,  &
                  x258, x259, x260, x261, x262, x263, x264, x265, x266, x267,  &
                  x268, x269, x270, x271, x272, x273, x274, x275, x276, x277,  &
                  x278, x279, x280, x281, x282, x283, x284, x285, x286, x287,  &
                  x288, x289, x290, x291, x292, x293, x294, x295, x296, x297,  &
                  x298, x299, x300, x301, x302, x303, x304, x305, x306, x307,  &
                  x308, x309, x310, x311, x312, x313, x314, x315, x316, x317,  &
                  x318, x319, x320, x321, x322, x323, x324, x325, x326, x327,  &
                  x328, x329, x330, x331, x332, x333, x334, x335, x336, x337,  &
                  x338, x339, x340, x341, x342, x343, x344, x345, x346, x347,  &
                  x348, x349, x350, x351, x352, x353, x354, x355, x356, x357,  &
                  x358, x359, x360, x361, x362, x363, x364, x365, x366, x367,  &
                  x368, x369, x370, x371, x372, x373, x374, x375, x376, x377,  &
                  x378, x379, x380, x381, x382, x383, x384, x385, x386, x387,  &
                  x388, x389, x390, x391, x392, x393, x394
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec
  contains
    subroutine treeSVV(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,   &
    VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SVV0)
!       P(2,3)*P(3,1)*c0
!       Metric(2,3)*P(-1,1)*P(-1,3)*c1
!       Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*c2
        if (last) VB_last = .true.
        x0 = P1(2)*w2(3)
        x1 = P1(3)*w2(2)
        x2 = x0 - x1
        x3 = P1(1)*co(2)
        x4 = P2(2)*w2(3)
        x5 = -P2(3)*w2(2) + x4
        x6 = P1(1)*w2(2)
        x7 = P1(2)*w2(1)
        x8 = x6 - x7
        x9 = P1(3)*co(2)
        x10 = P2(1)*w2(2) - P2(2)*w2(1)
        x11 = P1(0)**2
        x12 = w2(0)*x11
        x13 = P1(1)*w2(3)
        x14 = P1(3)*w2(1)
        x15 = x13 - x14
        x16 = P1(2)*co(2)
        x17 = P2(1)*w2(3)
        x18 = P2(3)*w2(1)
        x19 = x17 - x18
        x20 = P1(1)**2
        x21 = co(1)*w2(0)
        x22 = P1(2)**2
        x23 = P1(3)**2
        x24 = P2(0)*co(0)
        x25 = P1(0)*co(0)*w2(1)
        x26 = P1(0)*w2(2)
        x27 = P1(2)*co(0)
        x28 = P1(0)*co(0)*w2(3)
        x29 = P2(2)*co(0)
        x30 = P1(1)*w2(0)
        x31 = P2(1)*co(1)
        x32 = P2(2)*w2(0)
        x33 = P1(2)*co(1)
        x34 = P1(3)*w2(0)
        x35 = P2(3)*co(1)
        x36 = P1(0)*co(2)
        x37 = -P1(2)*w2(0) + x26
        x38 = P2(0)*w2(2) - x32
        x39 = co(1)*x11
        x40 = P1(0)*w2(3)
        x41 = -x34 + x40
        x42 = P2(0)*w2(3) - P2(3)*w2(0)
        x43 = co(0)*w2(1)
        x44 = co(1)*w2(1)
        x45 = P1(0)*co(0)
        x46 = P2(0)*w2(1)
        x47 = P1(3)*co(0)
        x48 = P1(1)*P2(1)
        x49 = P2(3)*co(0)
        x50 = P1(0)*w2(1) - x30
        x51 = -P2(1)*w2(0) + x46
        x52 = w2(2)*x22
        x53 = co(1)*w2(2)
        x54 = P1(2)*co(0)*w2(0)
        x55 = P2(0)*co(1)
        x56 = P1(1)*co(0)
        x57 = P2(1)*co(0)
        x58 = co(0)*w2(3)
        x59 = co(1)*w2(3)
        x60 = P1(3)*P2(3)
        wout(0) = w1(0)*(P1(0)*P2(0)*x21 + P1(0)*w2(0)*x24 - P1(1)*x25 - P1(3)*&
                  x28 - P2(1)*x25 - P2(3)*x28 + co(0)*x12 + co(1)*x12 + x10*x9 &
                   - x15*x16 - x16*x19 + x2*x3 - x20*x21 - x21*x22 - x21*x23 - &
                  x26*x27 - x26*x29 + x3*x5 - x30*x31 - x32*x33 - x34*x35 + x8*&
                  x9)
        wout(1) = w1(0)*(P1(0)*co(1)*x46 - P1(3)*co(1)*x18 - P2(2)*co(1)*x7 +  &
                  w2(1)*x39 - x13*x47 - x13*x49 - x16*x41 - x16*x42 + x2*x36 - &
                  x20*x43 - x20*x44 - x22*x44 - x23*x44 + x24*x30 - x27*x6 -   &
                  x29*x6 + x30*x45 + x36*x5 + x37*x9 + x38*x9 - x43*x48 - x44* &
                  x48)
        wout(2) = w1(0)*(P1(0)*x54 - P1(2)*P2(2)*x53 - P1(2)*w2(2)*x29 + P2(0)*&
                  x54 - co(0)*x52 - co(1)*x52 + w2(2)*x39 - x0*x47 - x0*x49 -  &
                  x1*x35 - x15*x36 - x19*x36 - x20*x53 - x23*x53 + x26*x55 + x3&
                  *x41 + x3*x42 - x31*x6 - x50*x9 - x51*x9 - x56*x7 - x57*x7)
        wout(3) = w1(0)*(-P1(1)*co(1)*x17 + w2(3)*x39 - x1*x27 - x1*x29 + x10* &
                  x36 - x14*x56 - x14*x57 + x16*x50 + x16*x51 - x20*x59 - x22* &
                  x59 - x23*x58 - x23*x59 + x24*x34 - x3*x37 - x3*x38 - x33*x4 &
                   + x34*x45 + x36*x8 + x40*x55 - x58*x60 - x59*x60)
      case(SVV1)
!       Metric(2,3)*c0
        if (last) VB_last = .true.
        wout = -co(0)*w1(0)*w2(:)
      case(SVV2)
!       c0*(-P(-1,1)*P(-1,2)*P(2,3)*P(3,1) - P(-1,1)*P(-1,3)*P(2,1)*P(3,2) + P(-1
!       ,2)*P(-1,3)*P(2,1)*P(3,1))
!       Metric(2,3)*P(-1,1)**2*P(-1,2)*P(-1,3)*c1
!       c2*(-Epsilon(-1,-2,-3,3)*P(-1,1)*P(-2,2)*P(-3,3)*P(2,1) - Epsilon(-2,-3,2
!       ,3)*P(-1,1)*P(-1,2)*P(-2,1)*P(-3,3))
!       c3*(Epsilon(-1,-2,-3,2)*P(-1,1)*P(-2,2)*P(-3,3)*P(3,1) + Epsilon(-2,-3,2,
!       3)*P(-1,1)*P(-1,3)*P(-2,1)*P(-3,2))
        if (last) VB_last = .true.
        x0 = P2(2)*w2(3) - P2(3)*w2(2)
        x1 = P2(1)*w2(2) - P2(2)*w2(1)
        x2 = P2(1)*w2(3) - P2(3)*w2(1)
        x3 = P1(1)*x0 - P1(2)*x2 + P1(3)*x1
        x4 = P1(0)**2
        x5 = co(3)*x4
        x6 = P1(2)*w2(3) - P1(3)*w2(2)
        x7 = P1(1)*w2(2) - P1(2)*w2(1)
        x8 = P1(1)*w2(3) - P1(3)*w2(1)
        x9 = P2(1)*x6 - P2(2)*x8 + P2(3)*x7
        x10 = P2(1)*x0 - P2(2)*x2 + P2(3)*x1
        x11 = P1(1)**2
        x12 = co(3)*x11
        x13 = P1(2)**2
        x14 = co(3)*x13
        x15 = P1(3)**2
        x16 = co(3)*x15
        x17 = P1(0)*w2(2) - P1(2)*w2(0)
        x18 = P1(0)*w2(3) - P1(3)*w2(0)
        x19 = P2(0)*x6 - P2(2)*x18 + P2(3)*x17
        x20 = P1(0)*P1(1)*co(3)
        x21 = P2(0)*w2(2) - P2(2)*w2(0)
        x22 = P2(0)*w2(3) - P2(3)*w2(0)
        x23 = P2(0)*x0 - P2(2)*x22 + P2(3)*x21
        x24 = P1(0)*w2(1) - P1(1)*w2(0)
        x25 = P2(0)*x7 - P2(1)*x17 + P2(2)*x24
        x26 = P1(0)*P1(3)*co(3)
        x27 = P2(0)*w2(1) - P2(1)*w2(0)
        x28 = P2(0)*x1 - P2(1)*x21 + P2(2)*x27
        x29 = P1(0)*P2(0)*co(3)
        x30 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x31 = P1(0)*x30
        x32 = P2(1)**2
        x33 = P2(2)**2
        x34 = co(0)*x30*x33
        x35 = P2(3)**2
        x36 = co(0)*x35
        x37 = P1(1)*x6 - P1(2)*x8 + P1(3)*x7
        x38 = P1(1)*P2(1)*co(2)
        x39 = P1(2)*P2(2)*co(2)
        x40 = P1(1)*P2(3) - P1(3)*P2(1)
        x41 = P1(2)*co(2)*x30
        x42 = P1(3)*P2(3)*co(2)
        x43 = P2(0)*co(0)*x4
        x44 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x45 = P2(0)**2
        x46 = x32 + x33 + x35 - x45
        x47 = co(1)*w2(0)*x46
        x48 = P1(1)*P2(1)
        x49 = P1(2)*P2(2)
        x50 = P1(3)*P2(3)
        x51 = P1(0)*P2(0)
        x52 = x48 + x49 + x50 - x51
        x53 = co(1)*w2(0)*x52
        x54 = P2(0)*x8 - P2(1)*x18 + P2(3)*x24
        x55 = P1(0)*P1(2)*co(3)
        x56 = P2(0)*x2 - P2(1)*x22 + P2(3)*x27
        x57 = P1(2)*x56
        x58 = P1(0)*P2(0)*co(2)
        x59 = P1(1)*P2(1)*co(3)
        x60 = co(2)*(P1(2)*P2(3) - P1(3)*P2(2))
        x61 = P1(1)*x30
        x62 = P1(2)*P2(2)*co(3)
        x63 = P1(3)*P2(3)*co(3)
        x64 = P1(1)*P2(2)
        x65 = -P1(2)*P2(1) + x64
        x66 = P1(3)*co(2)*x30
        x67 = co(0)*x11
        x68 = P2(0)*x30
        x69 = co(0)*x13
        x70 = co(0)*x15
        x71 = P1(0)*co(0)*x44
        x72 = P2(0)*co(0)*x30
        x73 = P1(3)*P2(3)*co(0)
        x74 = P1(0)*x0 - P1(2)*x22 + P1(3)*x21
        x75 = P1(1)*P1(3)*co(3)
        x76 = P1(0)*x6 - P1(2)*x18 + P1(3)*x17
        x77 = P1(2)*P2(2)*x74
        x78 = P1(3)*P2(0)
        x79 = co(2)*x30*(P1(0)*P2(3) - x78)
        x80 = P2(1)*x30
        x81 = co(1)*x11*x46
        x82 = co(1)*w2(1)*x52
        x83 = co(1)*x46
        x84 = w2(1)*x13
        x85 = co(1)*x52
        x86 = w2(1)*x15
        x87 = P1(1)*P1(2)*co(3)
        x88 = P1(0)*P2(2)
        x89 = -P1(2)*P2(0) + x88
        x90 = co(1)*x4*x46
        x91 = P1(1)*co(0)*x44
        x92 = P1(0)*P2(1)
        x93 = P1(2)*co(0)*x44
        x94 = P1(0)*x2 - P1(1)*x22 + P1(3)*x27
        x95 = P1(0)*x8 - P1(1)*x18 + P1(3)*x24
        x96 = P1(0)*co(2)*x30
        x97 = P1(2)*P1(3)*co(3)
        x98 = co(0)*x30*x32
        x99 = -P1(1)*P2(0) + x92
        x100 = co(0)*x30*x4
        x101 = co(1)*w2(2)*x52
        x102 = w2(2)*x15
        x103 = co(0)*x30*x45
        x104 = P2(2)*x30
        x105 = P2(2)*co(0)*x13
        x106 = P1(0)*x1 - P1(1)*x21 + P1(2)*x27
        x107 = P1(0)*x7 - P1(1)*x17 + P1(2)*x24
        x108 = co(1)*w2(3)*x52
        x109 = co(1)*w2(3)*x46
        x110 = P2(3)*x30
        x111 = P2(3)*co(0)*x15
        x112 = P2(3)*co(0)*x30
        x113 = P1(3)*co(0)*x44
        wout(0) = w1(0)*(-P1(0)*co(3)*x57 + P1(0)*x34 + co(0)*x31*x32 - x10*x5 &
                   + x11*x47 + x11*x53 - x12*x3 + x13*x47 + x13*x53 - x14*x3 + &
                  x15*x47 + x15*x53 - x16*x3 + x19*x20 + x20*x23 + x25*x26 +   &
                  x26*x28 + x29*x3 + x3*x38 + x3*x39 + x3*x42 + x3*x5 - x3*x58 &
                   - x3*x59 - x3*x62 - x3*x63 + x30*x43 + x31*x36 + x37*x38 +  &
                  x37*x39 + x37*x42 - x37*x58 - x4*x47 - x4*x53 + x40*x41 + x43&
                  *x44 - x48*x71 - x48*x72 - x49*x71 - x49*x72 - x5*x9 - x50*  &
                  x71 - x54*x55 - x60*x61 - x65*x66 - x67*x68 - x68*x69 - x68* &
                  x70 - x68*x73)
        wout(1) = w1(0)*(-P1(1)*co(3)*x57 + P1(1)*x34 - P1(2)*P2(2)*co(0)*x80  &
                   + P1(2)*x79 - P2(1)*x44*x67 + co(0)*x4*x80 - co(0)*x45*x61  &
                   + co(2)*x77 - co(3)*x77 + w2(1)*x81 - w2(1)*x90 - x10*x20 + &
                  x11*x82 + x12*x19 + x12*x23 - x12*x74 - x14*x74 - x16*x74 -  &
                  x20*x9 + x25*x75 + x28*x75 + x29*x74 - x31*x60 + x36*x61 +   &
                  x38*x74 + x38*x76 + x39*x76 - x4*x82 + x42*x74 + x42*x76 + x5&
                  *x74 - x50*x91 + x51*x91 - x54*x87 - x58*x74 - x58*x76 - x59*&
                  x74 - x63*x74 - x64*x93 - x66*x89 - x67*x80 - x69*x80 - x70* &
                  x80 + x72*x92 - x73*x80 + x83*x84 + x83*x86 + x84*x85 + x85* &
                  x86)
        wout(2) = w1(0)*(-P1(1)*P2(1)*co(0)*x104 - P1(1)*x79 - P1(2)*x103 + P1(&
                  2)*x30*x36 + P1(2)*x98 + P2(2)*x100 + w2(2)*x13*x83 + w2(2)* &
                  x81 - w2(2)*x90 - x10*x55 + x101*x11 + x101*x13 - x101*x4 +  &
                  x102*x83 + x102*x85 - x104*x67 - x104*x70 - x104*x73 - x105* &
                  x30 - x105*x44 + x12*x94 - x14*x54 - x14*x56 + x14*x94 + x16*&
                  x94 + x19*x87 + x23*x87 + x25*x97 + x28*x97 - x29*x94 - x38* &
                  x94 - x38*x95 - x39*x94 - x39*x95 + x40*x96 - x42*x94 - x42* &
                  x95 - x48*x93 - x5*x94 - x50*x93 + x51*x93 - x55*x9 + x58*x94&
                   + x58*x95 + x59*x94 + x62*x94 + x63*x94 + x66*x99 + x72*x88)
        wout(3) = w1(0)*(P1(1)*co(2)*x30*x89 - P1(3)*co(3)*x57 - P1(3)*x103 +  &
                  P1(3)*x34 + P1(3)*x98 + P2(3)*x100 + w2(3)*x81 - x10*x26 -   &
                  x106*x12 - x106*x14 - x106*x16 + x106*x29 + x106*x38 + x106* &
                  x39 + x106*x42 + x106*x5 - x106*x58 - x106*x59 - x106*x62 -  &
                  x106*x63 + x107*x38 + x107*x39 + x107*x42 - x107*x58 + x108* &
                  x11 + x108*x13 + x108*x15 - x108*x4 + x109*x13 + x109*x15 -  &
                  x109*x4 - x110*x67 - x110*x69 - x111*x30 - x111*x44 - x112*  &
                  x48 - x112*x49 + x112*x51 - x113*x48 - x113*x49 + x16*x25 +  &
                  x16*x28 + x19*x75 + x23*x75 - x26*x9 - x41*x99 - x54*x97 -   &
                  x65*x96 + x71*x78)
      case(SVV3)
!       P(2,1)*P(3,2)*c0
!       P(2,3)*P(3,1)*c1
!       -Metric(2,3)*P(-1,1)*P(-1,2)*c2
!       -Metric(2,3)*P(-1,1)*P(-1,3)*c3
!       -Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,2)*c4
!       -Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*c5
        if (last) VB_last = .true.
        x0 = P2(2)*w2(3)
        x1 = P2(3)*w2(2)
        x2 = x0 - x1
        x3 = co(4)*x2
        x4 = P1(1)*w2(3)
        x5 = P1(3)*w2(1)
        x6 = x4 - x5
        x7 = P1(2)*co(5)
        x8 = P2(1)*w2(3)
        x9 = P2(3)*w2(1)
        x10 = x8 - x9
        x11 = P2(1)*w2(2)
        x12 = P2(2)*w2(1)
        x13 = x11 - x12
        x14 = co(4)*x13
        x15 = P1(0)**2
        x16 = co(1)*w2(0)
        x17 = P1(1)**2
        x18 = co(3)*x17
        x19 = P1(2)**2
        x20 = co(3)*x19
        x21 = P1(3)**2
        x22 = co(3)*x21
        x23 = P1(2)*w2(3)
        x24 = P1(3)*w2(2)
        x25 = x23 - x24
        x26 = P1(1)*co(5)
        x27 = co(4)*x10
        x28 = P1(1)*w2(2)
        x29 = P1(2)*w2(1)
        x30 = x28 - x29
        x31 = P1(3)*co(5)
        x32 = co(3)*x15
        x33 = P1(0)*P2(0)*w2(0)
        x34 = P2(0)*w2(1)
        x35 = P1(1)*co(0)
        x36 = P1(1)*P2(1)*w2(0)
        x37 = P2(0)*w2(2)
        x38 = P1(2)*co(0)
        x39 = P1(2)*P2(2)*w2(0)
        x40 = P2(0)*w2(3)
        x41 = P1(3)*co(0)
        x42 = P2(3)*w2(0)
        x43 = P1(3)*co(3)
        x44 = P1(0)*w2(1)
        x45 = P1(1)*co(1)
        x46 = P1(0)*w2(2)
        x47 = P1(2)*co(1)
        x48 = P1(0)*w2(3)
        x49 = P1(3)*co(1)
        x50 = P2(1)*co(1)
        x51 = P2(2)*co(1)
        x52 = P2(3)*co(1)
        x53 = P1(3)*co(2)
        x54 = P1(3)*w2(0)
        x55 = x48 - x54
        x56 = x40 - x42
        x57 = P2(2)*w2(0)
        x58 = x37 - x57
        x59 = co(4)*x58
        x60 = P1(0)*co(5)
        x61 = co(4)*x56
        x62 = P1(2)*w2(0)
        x63 = x46 - x62
        x64 = co(1)*w2(1)
        x65 = P1(1)*w2(0)
        x66 = P1(0)*co(1)
        x67 = P1(0)*P2(0)*w2(1)
        x68 = P2(0)*co(1)
        x69 = P1(1)*P2(1)*w2(1)
        x70 = P1(2)*P2(2)*w2(1)
        x71 = P2(1)*w2(0)
        x72 = P1(0)*co(0)
        x73 = x44 - x65
        x74 = x34 - x71
        x75 = co(4)*x74
        x76 = co(1)*w2(2)
        x77 = P2(0)*co(2)
        x78 = P1(1)*co(3)
        x79 = P1(2)*P2(2)*w2(2)
        x80 = P2(3)*co(3)
        x81 = P2(0)*co(3)
        x82 = P1(1)*co(2)
        x83 = P2(3)*co(2)
        x84 = w2(3)*x21
        x85 = P1(2)*P2(2)*w2(3)
        x86 = P1(3)*w2(3)
        wout(0) = w1(0)*(P1(0)*P2(0)*x16 + P1(1)*x3 - P1(2)*x27 + P1(3)*x14 -  &
                  co(0)*x33 + co(2)*x33 - co(2)*x36 - co(2)*x39 - co(3)*x33 +  &
                  co(3)*x36 + co(3)*x39 + w2(0)*x18 + w2(0)*x20 + w2(0)*x22 -  &
                  w2(0)*x32 + x10*x7 - x13*x31 + x15*x16 - x2*x26 - x25*x26 -  &
                  x30*x31 + x34*x35 + x37*x38 + x40*x41 + x42*x43 - x42*x53 -  &
                  x44*x45 - x44*x50 - x46*x47 - x46*x51 - x48*x49 - x48*x52 +  &
                  x6*x7)
        wout(1) = w1(0)*(P1(0)*x3 - P1(1)*P2(1)*x64 - P1(2)*x61 + P1(3)*x59 +  &
                  co(0)*x69 + co(2)*x67 - co(2)*x69 - co(2)*x70 - co(3)*x67 +  &
                  co(3)*x69 + co(3)*x70 + w2(1)*x18 + w2(1)*x20 + w2(1)*x22 -  &
                  w2(1)*x32 + x11*x38 - x17*x64 - x2*x60 - x25*x60 - x28*x47 - &
                  x28*x51 - x31*x58 - x31*x63 - x4*x49 - x4*x52 + x41*x8 + x43*&
                  x9 - x53*x9 + x55*x7 + x56*x7 + x65*x66 + x65*x68 - x71*x72)
        wout(2) = w1(0)*(-P1(0)*x27 + P1(1)*x61 - P1(2)*P2(2)*x76 - P1(3)*x75  &
                   + P2(2)*w2(2)*x38 - co(2)*x79 + co(3)*x79 + w2(2)*x18 + w2(2&
                  )*x20 + w2(2)*x22 - w2(2)*x32 + x0*x41 + x10*x60 + x11*x78 - &
                  x11*x82 + x12*x35 - x19*x76 - x23*x49 - x23*x52 + x24*x80 -  &
                  x24*x83 - x26*x55 - x26*x56 - x29*x45 - x29*x50 + x31*x73 +  &
                  x31*x74 + x46*x77 - x46*x81 - x57*x72 + x6*x60 + x62*x66 +   &
                  x62*x68)
        wout(3) = w1(0)*(P1(0)*x14 - P1(1)*x59 + P1(2)*x75 + P2(3)*w2(3)*x41 - &
                  co(1)*x84 - co(2)*x85 + co(3)*x84 + co(3)*x85 + w2(3)*x18 +  &
                  w2(3)*x20 - w2(3)*x32 + x1*x38 - x13*x60 - x24*x47 - x24*x51 &
                   + x26*x58 + x26*x63 - x30*x60 + x35*x9 - x42*x72 - x45*x5 + &
                  x48*x77 - x48*x81 - x5*x50 - x52*x86 + x54*x66 + x54*x68 - x7&
                  *x73 - x7*x74 + x78*x8 - x8*x82 + x80*x86 - x83*x86)
      case(SVV4)
!       c0*(-P(-1,1)*P(-1,2)*P(2,3)*P(3,1) - P(-1,1)*P(-1,3)*P(2,1)*P(3,2) + P(-1
!       ,2)*P(-1,3)*P(2,1)*P(3,1))
!       Metric(2,3)*P(-1,1)**2*P(-1,2)*P(-1,3)*c1
        if (last) VB_last = .true.
        x0 = P2(1)**2
        x1 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x0vec = P1(:)*co(0)*x1
        x2 = P2(2)**2
        x3 = P2(3)**2
        x4 = P1(0)**2
        x1vec = P2(:)*co(0)*x1
        x5 = P2(0)**2
        x6 = x0 + x2 + x3 - x5
        x7 = P1(1)**2
        x2vec = co(1)*w2(:)*x7
        x8 = P1(1)*P2(1)
        x9 = P1(2)*P2(2)
        x10 = P1(3)*P2(3)
        x11 = P1(0)*P2(0)
        x12 = x10 - x11 + x8 + x9
        x13 = P1(2)**2
        x3vec = co(1)*w2(:)*x6
        x4vec = co(1)*w2(:)*x12
        x14 = P1(3)**2
        x5vec = P1(:)*co(0)*(-P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)* &
        w2(3))
        wout = w1(0)*(x0*x0vec + x0vec*x2 + x0vec*x3 - x0vec*x5 - x10*x1vec -  &
               x10*x5vec + x11*x1vec + x11*x5vec + x12*x2vec - x13*x1vec + x13*&
               x3vec + x13*x4vec - x14*x1vec + x14*x3vec + x14*x4vec + x1vec*x4&
                - x1vec*x7 - x1vec*x8 - x1vec*x9 + x2vec*x6 - x3vec*x4 - x4*   &
               x4vec - x5vec*x8 - x5vec*x9)
      case(SVV5)
!       P(2,1)*P(3,2)*c0
!       Metric(2,3)*P(-1,1)*P(-1,2)*c1
!       Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,2)*c2
        if (last) VB_last = .true.
        x0 = P2(1)*w2(3)
        x1 = P2(3)*w2(1)
        x2 = x0 - x1
        x3 = P1(2)*co(2)
        x4 = P2(2)*w2(3)
        x5 = P2(3)*w2(2)
        x6 = x4 - x5
        x7 = P1(1)*co(2)
        x8 = P2(1)*w2(2)
        x9 = P2(2)*w2(1)
        x10 = x8 - x9
        x11 = P1(3)*co(2)
        x12 = P2(0)*w2(1)
        x13 = P1(1)*co(0)
        x14 = P2(1)*w2(0)
        x15 = P1(1)*co(1)
        x16 = P2(0)*w2(2)
        x17 = P1(2)*co(0)
        x18 = P2(2)*w2(0)
        x19 = P1(2)*co(1)
        x20 = P2(0)*w2(3)
        x21 = P1(3)*co(0)
        x22 = P2(3)*w2(0)
        x23 = P1(3)*co(1)
        x24 = P1(0)*co(0)
        x25 = P2(0)*w2(0)
        x26 = P1(0)*co(1)
        x27 = co(2)*(x20 - x22)
        x28 = P1(0)*co(2)
        x29 = x16 - x18
        x30 = P2(1)*w2(1)
        x31 = x12 - x14
        x32 = P2(2)*w2(2)
        x33 = P2(3)*w2(3)
        wout(0) = w1(0)*(-x10*x11 + x12*x13 + x14*x15 + x16*x17 + x18*x19 + x2*&
                  x3 + x20*x21 + x22*x23 - x24*x25 - x25*x26 - x6*x7)
        wout(1) = w1(0)*(P1(2)*x27 + x0*x21 + x1*x23 - x11*x29 - x12*x26 + x13*&
                  x30 - x14*x24 + x15*x30 + x17*x8 + x19*x9 - x28*x6)
        wout(2) = w1(0)*(-P1(1)*x27 + x11*x31 + x13*x9 + x15*x8 - x16*x26 + x17&
                  *x32 - x18*x24 + x19*x32 + x2*x28 + x21*x4 + x23*x5)
        wout(3) = w1(0)*(x0*x15 + x1*x13 - x10*x28 + x17*x5 + x19*x4 - x20*x26 &
                   + x21*x33 - x22*x24 + x23*x33 + x29*x7 - x3*x31)
      end select 
    end subroutine treeSVV
end module tcSVV
