!******************************************************************************!
!                                                                              !
!    tcVSV.f90                                                                 !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVSV.f90                                      |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-16 19:50             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVSV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113, x114, x115, x116, x117,  &
                  x118, x119, x120, x121, x122, x123, x124, x125, x126, x127,  &
                  x128, x129, x130, x131, x132, x133, x134, x135, x136, x137,  &
                  x138, x139, x140, x141, x142, x143, x144, x145, x146, x147,  &
                  x148, x149, x150, x151, x152, x153, x154, x155, x156, x157,  &
                  x158, x159, x160, x161, x162, x163, x164, x165, x166, x167,  &
                  x168, x169, x170, x171, x172, x173, x174, x175, x176, x177,  &
                  x178, x179, x180, x181, x182, x183, x184, x185, x186, x187,  &
                  x188, x189, x190, x191, x192, x193, x194, x195, x196, x197,  &
                  x198, x199, x200, x201, x202, x203, x204, x205, x206, x207,  &
                  x208, x209, x210, x211, x212, x213, x214, x215, x216, x217,  &
                  x218, x219, x220, x221, x222, x223, x224, x225, x226, x227,  &
                  x228, x229, x230, x231, x232, x233, x234, x235, x236, x237,  &
                  x238, x239, x240, x241, x242, x243, x244, x245, x246, x247,  &
                  x248, x249, x250, x251, x252, x253, x254, x255, x256, x257,  &
                  x258, x259, x260, x261, x262, x263, x264, x265, x266, x267,  &
                  x268, x269, x270, x271, x272, x273, x274, x275, x276, x277,  &
                  x278, x279, x280, x281, x282, x283, x284, x285, x286, x287,  &
                  x288, x289, x290, x291, x292, x293, x294, x295, x296, x297,  &
                  x298, x299, x300, x301, x302, x303, x304, x305, x306, x307,  &
                  x308, x309, x310, x311, x312, x313, x314, x315, x316, x317,  &
                  x318, x319, x320, x321, x322, x323, x324, x325, x326, x327,  &
                  x328, x329, x330, x331, x332, x333, x334, x335, x336, x337,  &
                  x338, x339, x340, x341, x342, x343, x344, x345, x346, x347,  &
                  x348, x349, x350, x351, x352, x353, x354, x355, x356, x357,  &
                  x358, x359, x360, x361, x362, x363, x364, x365, x366, x367,  &
                  x368, x369, x370, x371, x372, x373, x374, x375, x376, x377,  &
                  x378, x379, x380, x381, x382, x383, x384, x385, x386, x387,  &
                  x388, x389, x390, x391, x392, x393, x394
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec
  contains
    subroutine treeVSV(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,   &
    VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VSV0)
!       P(1,3)*P(3,2)*c0
!       P(1,2)*P(3,1)*c1
!       Metric(1,3)*P(-1,2)*P(-1,3)*c2
!       Metric(1,3)*P(-1,1)*P(-1,2)*c3
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*c4
!       Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*c5
        if (last) VB_last = .true.
        x0 = P2(1)*w1(3)
        x1 = P2(3)*w1(1)
        x2 = x0 - x1
        x3 = P1(2)*co(5)
        x4 = P1(2)*w1(3)
        x5 = P1(3)*w1(2)
        x6 = x4 - x5
        x7 = P2(1)*co(4)
        x8 = P2(2)*w1(3)
        x9 = P2(3)*w1(2)
        x10 = x8 - x9
        x11 = P1(1)*w1(2)
        x12 = P1(2)*w1(1)
        x13 = x11 - x12
        x14 = P2(3)*co(4)
        x15 = P2(1)*w1(2)
        x16 = P2(2)*w1(1)
        x17 = x15 - x16
        x18 = P2(0)**2
        x19 = w1(0)*x18
        x20 = co(5)*x10
        x21 = P1(3)*co(5)
        x22 = P1(1)*w1(3)
        x23 = P1(3)*w1(1)
        x24 = x22 - x23
        x25 = P2(2)*co(4)
        x26 = P2(1)**2
        x27 = co(2)*x26
        x28 = P2(2)**2
        x29 = co(2)*x28
        x30 = P2(3)**2
        x31 = co(2)*x30
        x32 = P1(0)*w1(0)
        x33 = P2(0)*co(0)
        x34 = P2(0)*co(2)
        x35 = P1(0)*w1(1)
        x36 = P2(1)*co(1)
        x37 = P1(0)*w1(2)
        x38 = P2(2)*co(1)
        x39 = P1(0)*w1(3)
        x40 = P2(3)*co(1)
        x41 = P1(1)*w1(0)
        x42 = P2(1)*co(3)
        x43 = P2(2)*w1(0)
        x44 = P1(2)*co(3)
        x45 = P2(3)*w1(0)
        x46 = P1(3)*co(3)
        x47 = P2(0)*co(1)
        x48 = P2(0)*co(3)
        x49 = P2(0)*w1(1)
        x50 = P1(1)*co(0)
        x51 = P2(0)*w1(2)
        x52 = P1(2)*co(0)
        x53 = P1(2)*co(2)
        x54 = P2(0)*w1(3)
        x55 = P1(3)*co(0)
        x56 = P1(3)*co(2)
        x57 = P2(1)*co(0)
        x58 = P2(2)*co(0)
        x59 = P2(3)*co(0)
        x60 = -x45 + x54
        x61 = P2(0)*co(4)
        x62 = P1(2)*w1(0)
        x63 = x37 - x62
        x64 = -x43 + x51
        x65 = co(2)*x18
        x66 = P1(3)*w1(0)
        x67 = x39 - x66
        x68 = co(0)*w1(1)
        x69 = P1(0)*P2(0)*w1(1)
        x70 = P2(1)*w1(0)
        x71 = P1(0)*co(0)
        x72 = P1(1)*P2(1)*w1(1)
        x73 = P1(0)*co(5)
        x74 = x49 - x70
        x75 = P1(1)*co(5)
        x76 = x35 - x41
        x77 = co(0)*w1(2)
        x78 = P1(1)*P2(1)*w1(2)
        x79 = P2(2)*w1(2)
        x80 = P2(2)*co(0)*w1(3)
        x81 = co(0)*w1(3)
        x82 = P1(1)*P2(1)*w1(3)
        x83 = P2(3)*w1(3)
        wout(0) = w2(0)*(-P1(1)*x20 - P2(1)*co(2)*x41 + co(0)*x19 + co(2)*x19  &
                   - w1(0)*x27 - w1(0)*x29 - w1(0)*x31 + x10*x7 + x13*x14 + x14&
                  *x17 - x17*x21 - x2*x25 + x2*x3 - x24*x25 + x32*x33 + x32*x34&
                   - x32*x47 - x32*x48 + x35*x36 + x37*x38 + x39*x40 + x41*x42 &
                   + x43*x44 - x43*x53 + x45*x46 - x45*x56 - x49*x50 - x49*x57 &
                   - x51*x52 - x51*x58 - x54*x55 - x54*x59 + x6*x7)
        wout(1) = w2(0)*(-P1(0)*x20 - P1(1)*P2(1)*x68 + P1(1)*w1(1)*x42 + co(1 &
                  )*x72 + co(2)*x69 - co(2)*x72 - co(3)*x69 - w1(1)*x27 - w1(1 &
                  )*x29 - w1(1)*x31 + w1(1)*x65 - x0*x55 - x0*x59 + x1*x46 - x1&
                  *x56 + x10*x61 + x11*x38 + x14*x63 + x14*x64 - x15*x52 - x15*&
                  x58 + x16*x44 - x16*x53 - x21*x64 + x22*x40 - x25*x60 - x25* &
                  x67 - x26*x68 + x3*x60 + x33*x70 - x41*x47 + x6*x61 + x70*x71&
                  )
        wout(2) = w2(0)*(-P1(2)*P2(2)*x77 + P1(2)*w1(2)*x38 - P1(3)*x80 - P2(3 &
                  )*x80 - co(2)*x78 + co(3)*x78 - w1(2)*x27 - w1(2)*x29 - w1(2 &
                  )*x31 + w1(2)*x65 + x12*x36 - x14*x74 - x14*x76 - x16*x50 -  &
                  x16*x57 - x2*x61 + x2*x73 + x21*x74 - x24*x61 - x28*x77 + x33&
                  *x43 + x34*x37 - x37*x48 + x4*x40 + x43*x71 + x44*x79 + x46* &
                  x9 - x47*x62 - x53*x79 - x56*x9 + x60*x7 - x60*x75 + x67*x7)
        wout(3) = w2(0)*(-P1(3)*P2(3)*x81 + P1(3)*w1(3)*x40 - co(2)*x82 + co(3 &
                  )*x82 - w1(3)*x27 - w1(3)*x29 - w1(3)*x31 + w1(3)*x65 - x1*  &
                  x50 - x1*x57 + x13*x61 + x17*x61 - x17*x73 + x23*x36 + x25*  &
                  x74 + x25*x76 - x3*x74 - x30*x81 + x33*x45 + x34*x39 + x38*x5&
                   - x39*x48 + x44*x8 + x45*x71 + x46*x83 - x47*x66 - x52*x9 - &
                  x53*x8 - x56*x83 - x58*x9 - x63*x7 - x64*x7 + x64*x75)
      case(VSV1)
!       Metric(1,3)*c0
        if (last) VB_last = .true.
        wout = -co(0)*w1(:)*w2(0)
      case(VSV2)
!       P(1,2)*P(3,1)*c0
!       Metric(1,3)*P(-1,1)*P(-1,2)*c1
!       Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*c2
        if (last) VB_last = .true.
        x0 = P2(1)*w1(3)
        x1 = P2(3)*w1(1)
        x2 = x0 - x1
        x3 = P2(2)*w1(3)
        x4 = P2(3)*w1(2)
        x5 = x3 - x4
        x6 = P1(1)*co(2)
        x7 = P2(1)*w1(2)
        x8 = P2(2)*w1(1)
        x9 = co(2)*(x7 - x8)
        x10 = P2(1)*co(0)*w1(1)
        x11 = P2(2)*co(0)*w1(2)
        x12 = P2(3)*co(0)*w1(3)
        x13 = P2(1)*w1(0)
        x14 = P1(1)*co(1)
        x15 = P2(2)*w1(0)
        x16 = P1(2)*co(1)
        x17 = P2(3)*w1(0)
        x18 = P1(3)*co(1)
        x19 = P2(0)*co(0)*w1(0)
        x20 = P1(0)*co(1)
        x21 = P2(0)*w1(3)
        x22 = co(2)*(-x17 + x21)
        x23 = P1(0)*co(2)
        x24 = P2(0)*w1(2)
        x25 = -x15 + x24
        x26 = P2(0)*w1(1)
        x27 = co(2)*(-x13 + x26)
        wout(0) = w2(0)*(P1(0)*x10 + P1(0)*x11 + P1(0)*x12 - P1(0)*x19 + P1(2)*&
                  co(2)*x2 - P1(3)*x9 - P2(0)*w1(0)*x20 + x13*x14 + x15*x16 +  &
                  x17*x18 - x5*x6)
        wout(1) = w2(0)*(P1(1)*x10 + P1(1)*x11 + P1(1)*x12 - P1(1)*x19 + P1(2)*&
                  x22 - P1(3)*co(2)*x25 + P2(1)*w1(1)*x14 + x1*x18 + x16*x8 -  &
                  x20*x26 - x23*x5)
        wout(2) = w2(0)*(-P1(1)*x22 + P1(2)*x10 + P1(2)*x11 + P1(2)*x12 - P1(2 &
                  )*x19 + P1(3)*x27 + P2(2)*w1(2)*x16 + x14*x7 + x18*x4 + x2*  &
                  x23 - x20*x24)
        wout(3) = w2(0)*(-P1(0)*x9 - P1(2)*x27 + P1(3)*x10 + P1(3)*x11 + P1(3)*&
                  x12 - P1(3)*x19 + P2(3)*w1(3)*x18 + x0*x14 + x16*x3 - x20*x21&
                   + x25*x6)
      case(VSV3)
!       c0*(-P(-1,1)*P(-1,2)*P(1,3)*P(3,2) + P(-1,1)*P(-1,3)*P(1,2)*P(3,2) - P(-1
!       ,2)*P(-1,3)*P(1,2)*P(3,1))
!       Metric(1,3)*P(-1,1)*P(-1,2)**2*P(-1,3)*c1
!       c2*(Epsilon(-1,-2,-3,3)*P(-1,1)*P(-2,2)*P(-3,3)*P(1,2) - Epsilon(-2,-3,1,
!       3)*P(-1,1)*P(-1,2)*P(-2,2)*P(-3,3))
!       c3*(-Epsilon(-1,-2,-3,1)*P(-1,1)*P(-2,2)*P(-3,3)*P(3,2) - Epsilon(-1,-2,1
!       ,3)*P(-1,1)*P(-2,2)*P(-3,2)*P(-3,3))
        if (last) VB_last = .true.
        x0 = P1(2)*w1(3) - P1(3)*w1(2)
        x1 = P1(1)*w1(2) - P1(2)*w1(1)
        x2 = P1(1)*w1(3) - P1(3)*w1(1)
        x3 = P2(1)*x0 - P2(2)*x2 + P2(3)*x1
        x4 = P1(0)*P2(0)*co(3)
        x5 = P2(3)*w1(2)
        x6 = P2(2)*w1(3) - x5
        x7 = P2(1)*w1(2) - P2(2)*w1(1)
        x8 = P2(1)*w1(3) - P2(3)*w1(1)
        x9 = P2(1)*x6 - P2(2)*x8 + P2(3)*x7
        x10 = P2(0)**2
        x11 = -P1(0)*w1(0) + P1(1)*w1(1) + P1(2)*w1(2) + P1(3)*w1(3)
        x12 = co(0)*x11
        x13 = P2(3)*w1(3)
        x14 = -P2(0)*w1(0) + P2(1)*w1(1) + P2(2)*w1(2) + x13
        x15 = co(0)*x10*x14
        x16 = P1(1)*P2(1)*co(2)
        x17 = P1(2)*P2(3)
        x18 = P1(3)*P2(2)
        x19 = x17 - x18
        x20 = P1(1)*co(2)*x14
        x21 = P2(1)**2
        x22 = P2(2)**2
        x23 = P2(3)**2
        x24 = -x10 + x21 + x22 + x23
        x25 = P1(1)*co(3)*x24
        x26 = P1(1)*P2(1)
        x27 = P1(2)*P2(2)
        x28 = P1(3)*P2(3)
        x29 = P1(0)*P2(0)
        x30 = x26 + x27 + x28 - x29
        x31 = P1(1)*co(3)*x30
        x32 = P1(0)*w1(1) - P1(1)*w1(0)
        x33 = P1(0)*w1(3) - P1(3)*w1(0)
        x34 = P2(0)*x2 - P2(1)*x33 + P2(3)*x32
        x35 = P1(2)*P2(0)*co(3)
        x36 = P2(0)*w1(1)
        x37 = -P2(1)*w1(0) + x36
        x38 = P2(0)*w1(3)
        x39 = -P2(3)*w1(0) + x38
        x40 = P2(0)*x8 - P2(1)*x39 + P2(3)*x37
        x41 = P1(2)*P2(2)*co(2)
        x42 = P1(3)*P2(3)*co(2)
        x43 = P1(1)*P2(2)
        x44 = P1(2)*P2(1)
        x45 = x43 - x44
        x46 = P1(3)*co(2)*x14
        x47 = P1(3)*co(3)*x24
        x48 = P1(3)*co(3)*x30
        x49 = P1(1)**2*co(0)*x14
        x50 = P1(2)**2
        x51 = P2(0)*co(0)*x14
        x52 = P1(3)**2
        x53 = P1(0)*P2(0)*co(2)
        x54 = co(0)*x14*x21
        x55 = co(0)*x14*x22
        x56 = co(0)*x14*x23
        x57 = P1(1)*P2(0)
        x58 = P1(0)*w1(2) - P1(2)*w1(0)
        x59 = P2(0)*x0 - P2(2)*x33 + P2(3)*x58
        x60 = co(3)*x59
        x61 = P2(0)*w1(2)
        x62 = -P2(2)*w1(0) + x61
        x63 = P2(0)*x6 - P2(2)*x39 + P2(3)*x62
        x64 = co(3)*x63
        x65 = P1(1)*P2(3)
        x66 = P1(3)*P2(1)
        x67 = x65 - x66
        x68 = P1(2)*co(2)*x14
        x69 = P1(2)*co(3)*x24
        x70 = P1(2)*co(3)*x30
        x71 = P1(3)*P2(0)
        x72 = P2(0)*x1 - P2(1)*x58 + P2(2)*x32
        x73 = co(3)*x72
        x74 = P2(0)*x7 - P2(1)*x62 + P2(2)*x37
        x75 = co(3)*x74
        x76 = P1(1)*P2(1)*co(1)*x24
        x77 = P1(1)*P2(1)*co(1)*x30
        x78 = co(1)*w1(0)*x24
        x79 = co(1)*w1(0)*x30
        x80 = P1(0)*co(0)*x14
        x81 = co(1)*x24
        x82 = P1(0)*P2(0)*w1(0)
        x83 = co(1)*x30
        x84 = P1(1)*P2(1)*co(0)*x11
        x85 = P2(0)*co(0)*x11
        x86 = P1(3)*P2(3)*co(0)*x11
        x87 = P1(0)*P2(1)*co(3)
        x88 = P1(0)*co(2)*x14
        x89 = P1(0)*co(3)*x24
        x90 = P1(0)*co(3)*x30
        x91 = co(3)*x34
        x92 = co(3)*x40
        x93 = co(2)*x59
        x94 = P1(0)*P2(2) - P1(2)*P2(0)
        x95 = P2(1)*co(0)*x14
        x96 = P1(0)*P2(3) - x71
        x97 = P1(0)**2
        x98 = P1(1)*co(0)*x14
        x99 = P1(0)*P2(1)
        x100 = P1(2)*P2(2)*w1(1)
        x101 = P1(3)*P2(3)*w1(1)
        x102 = P1(0)*co(1)*x24
        x103 = P1(0)*co(1)*x30
        x104 = P1(2)*co(0)*x14
        x105 = P1(2)*P2(2)*co(0)*x11
        x106 = P1(0)*P2(2)*co(3)
        x107 = P2(2)*co(0)*x14
        x108 = P1(2)*x22
        x109 = -x57 + x99
        x110 = P1(0)*P2(0)*co(0)*x11
        x111 = P1(2)*P2(2)*w1(2)
        x112 = P1(3)*co(1)*x24
        x113 = P1(3)*co(1)*x30
        x114 = P1(0)*P2(3)*co(3)
        x115 = P1(0)*x7
        x116 = co(2)*x72
        x117 = P2(3)*co(0)*x14
        x118 = P1(3)*P2(3)*co(3)
        x119 = P1(2)*P2(2)*w1(3)
        x120 = P1(3)*co(0)*x14
        wout(0) = w2(0)*(P1(0)*x10*x12 + P1(0)*x15 - P1(0)*x54 - P1(0)*x55 - P1&
                  (0)*x56 + P2(0)*x49 - P2(0)*x84 - P2(0)*x86 + w1(0)*x76 + w1(&
                  0)*x77 + x16*x3 + x16*x9 + x19*x20 + x25*x6 - x26*x80 + x27* &
                  x78 + x27*x79 - x27*x80 - x27*x85 + x28*x78 + x28*x79 - x28* &
                  x80 + x3*x4 + x3*x41 + x3*x42 - x3*x53 + x31*x6 + x34*x35 +  &
                  x35*x40 + x4*x9 + x41*x9 + x42*x9 + x45*x46 + x47*x7 + x48*x7&
                   + x50*x51 + x51*x52 - x53*x9 - x57*x60 - x57*x64 - x67*x68  &
                   - x69*x8 - x70*x8 - x71*x73 - x71*x75 - x81*x82 - x82*x83)
        wout(1) = w2(0)*(-P1(1)*co(0)*x11*x21 + P1(1)*x15 - P1(1)*x54 - P1(1)* &
                  x55 - P1(1)*x56 - P2(1)*x105 - P2(1)*x86 + w1(1)*x76 + w1(1)*&
                  x77 + x100*x81 + x100*x83 + x101*x81 + x101*x83 - x102*x36 - &
                  x103*x36 - x104*x43 + x16*x59 + x16*x63 + x19*x88 - x26*x60  &
                   - x26*x64 + x27*x93 + x28*x93 - x28*x98 - x29*x93 + x29*x98 &
                   + x3*x87 - x39*x69 - x39*x70 + x41*x63 + x42*x63 + x44*x91  &
                   + x44*x92 + x46*x94 + x47*x62 + x48*x62 + x50*x95 + x52*x95 &
                   - x53*x63 + x6*x89 + x6*x90 - x66*x73 - x66*x75 - x68*x96 + &
                  x85*x99 + x87*x9 - x95*x97)
        wout(2) = w2(0)*(P1(2)*x15 - P1(2)*x54 - P1(2)*x56 + P2(2)*x110 + P2(2 &
                  )*x49 - P2(2)*x84 - P2(2)*x86 - co(0)*x108*x14 + w1(2)*x76 + &
                  w1(2)*x77 - x102*x61 - x103*x61 - x104*x26 - x104*x28 + x104*&
                  x29 + x106*x3 + x106*x9 + x107*x52 - x107*x97 - x108*x12 -   &
                  x109*x46 + x111*x81 + x111*x83 + x112*x5 + x113*x5 - x16*x34 &
                   - x16*x40 - x18*x73 - x18*x75 + x20*x96 + x25*x39 + x27*x91 &
                   + x27*x92 + x31*x39 - x34*x41 - x34*x42 + x34*x53 - x37*x47 &
                   - x37*x48 - x40*x41 - x40*x42 + x40*x53 - x43*x60 - x43*x64 &
                   - x67*x88 - x8*x89 - x8*x90)
        wout(3) = w2(0)*(-P1(3)*x12*x23 + P1(3)*x15 - P1(3)*x54 - P1(3)*x55 -  &
                  P1(3)*x56 - P2(3)*x105 + P2(3)*x110 + P2(3)*x49 - P2(3)*x84  &
                   + co(3)*x115*x24 + co(3)*x115*x30 + w1(3)*x76 + w1(3)*x77 - &
                  x102*x38 - x103*x38 + x109*x68 + x112*x13 + x113*x13 + x114* &
                  x3 + x114*x9 + x116*x27 + x116*x28 - x116*x29 + x117*x50 -   &
                  x117*x97 - x118*x72 - x118*x74 + x119*x81 + x119*x83 - x120* &
                  x26 - x120*x27 + x16*x72 + x16*x74 + x17*x91 + x17*x92 - x20*&
                  x94 - x25*x62 - x31*x62 + x37*x69 + x37*x70 + x41*x74 + x42* &
                  x74 + x45*x88 - x53*x74 - x60*x65 - x64*x65 + x71*x80)
      case(VSV4)
!       P(1,3)*P(3,2)*c0
!       Metric(1,3)*P(-1,2)*P(-1,3)*c1
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*c2
        if (last) VB_last = .true.
        x0 = P1(2)*w1(3) - P1(3)*w1(2)
        x1 = P2(1)*co(2)
        x2 = P2(2)*w1(3)
        x3 = P2(3)*w1(2)
        x4 = x2 - x3
        x5 = P1(1)*w1(2) - P1(2)*w1(1)
        x6 = P2(3)*co(2)
        x7 = P2(1)*w1(2)
        x8 = P2(2)*w1(1)
        x9 = x7 - x8
        x10 = P2(0)**2
        x11 = w1(0)*x10
        x12 = P1(1)*w1(3) - P1(3)*w1(1)
        x13 = P2(2)*co(2)
        x14 = P2(1)*w1(3)
        x15 = P2(3)*w1(1)
        x16 = x14 - x15
        x17 = P2(1)**2
        x18 = co(1)*x17
        x19 = P2(2)**2
        x20 = co(1)*w1(0)
        x21 = P2(3)**2
        x22 = co(1)*x21
        x23 = P1(0)*co(0)
        x24 = P2(0)*w1(1)
        x25 = P1(1)*co(0)
        x26 = P1(1)*w1(0)
        x27 = P2(0)*w1(2)
        x28 = P1(2)*co(0)
        x29 = P2(2)*w1(0)
        x30 = P1(2)*co(1)
        x31 = P2(0)*w1(3)
        x32 = P1(3)*co(0)
        x33 = P1(3)*w1(0)
        x34 = P2(1)*co(0)
        x35 = P2(2)*co(0)
        x36 = P2(3)*co(0)
        x37 = P2(0)*co(2)
        x38 = P1(0)*w1(2)
        x39 = -P1(2)*w1(0) + x38
        x40 = x27 - x29
        x41 = co(1)*w1(1)
        x42 = P1(0)*w1(3)
        x43 = -x33 + x42
        x44 = P2(3)*w1(0)
        x45 = x31 - x44
        x46 = co(0)*w1(1)
        x47 = P2(1)*w1(0)
        x48 = P2(0)*co(0)
        x49 = P1(1)*P2(1)
        x50 = P1(3)*co(1)
        x51 = co(1)*w1(2)
        x52 = P1(0)*w1(1) - x26
        x53 = x24 - x47
        x54 = w1(2)*x19
        x55 = P2(0)*co(1)
        x56 = P1(1)*co(1)
        x57 = P2(2)*co(0)*w1(1)
        x58 = P2(2)*co(0)*w1(3)
        x59 = co(1)*w1(3)
        x60 = co(0)*w1(3)
        x61 = P1(3)*P2(3)
        wout(0) = w2(0)*(P1(0)*P2(0)*x20 + P2(0)*w1(0)*x23 - P2(1)*co(1)*x26 - &
                  P2(3)*co(1)*x33 + co(0)*x11 + co(1)*x11 - w1(0)*x18 - w1(0)* &
                  x22 + x0*x1 + x1*x4 - x12*x13 - x13*x16 - x19*x20 - x24*x25  &
                   - x24*x34 - x27*x28 - x27*x35 - x29*x30 - x31*x32 - x31*x36 &
                   + x5*x6 + x6*x9)
        wout(1) = w2(0)*(P1(0)*co(1)*x24 - w1(1)*x18 - w1(1)*x22 + x0*x37 + x10&
                  *x41 - x13*x43 - x13*x45 - x14*x32 - x14*x36 - x15*x50 - x17*&
                  x46 - x19*x41 + x23*x47 - x28*x7 - x30*x8 - x35*x7 + x37*x4  &
                   + x39*x6 + x40*x6 - x41*x49 - x46*x49 + x47*x48)
        wout(2) = w2(0)*(-P1(1)*x57 - P1(2)*P2(2)*x51 - P1(2)*w1(2)*x35 - P1(3 &
                  )*x58 - P2(1)*x57 - P2(3)*x58 - co(0)*x54 - co(1)*x54 - w1(2 &
                  )*x18 - w1(2)*x22 + x1*x43 + x1*x45 + x10*x51 - x12*x37 - x16&
                  *x37 + x23*x29 + x29*x48 - x3*x50 + x38*x55 - x52*x6 - x53*x6&
                   - x56*x7)
        wout(3) = w2(0)*(-w1(3)*x18 - x1*x39 - x1*x40 + x10*x59 + x13*x52 + x13&
                  *x53 - x14*x56 - x15*x25 - x15*x34 - x19*x59 - x2*x30 - x21* &
                  x59 - x21*x60 + x23*x44 - x28*x3 - x3*x35 + x37*x5 + x37*x9  &
                   + x42*x55 + x44*x48 - x59*x61 - x60*x61)
      case(VSV5)
!       c0*(-P(-1,1)*P(-1,2)*P(1,3)*P(3,2) + P(-1,1)*P(-1,3)*P(1,2)*P(3,2) - P(-1
!       ,2)*P(-1,3)*P(1,2)*P(3,1))
!       Metric(1,3)*P(-1,1)*P(-1,2)**2*P(-1,3)*c1
        if (last) VB_last = .true.
        x0 = P2(0)**2
        x1 = -P2(0)*w1(0) + P2(1)*w1(1) + P2(2)*w1(2) + P2(3)*w1(3)
        x0vec = P1(:)*co(0)*x1
        x1vec = P2(:)*co(0)*x1
        x2 = P2(1)**2
        x3 = P2(2)**2
        x4 = P2(3)**2
        x5 = P1(0)*P2(0)
        x2vec = P2(:)*co(0)*(-P1(0)*w1(0) + P1(1)*w1(1) + P1(2)*w1(2) + P1(3)* &
        w1(3))
        x6 = P1(1)*P2(1)
        x7 = -x0 + x2 + x3 + x4
        x3vec = co(1)*w1(:)*x7
        x8 = P1(2)*P2(2)
        x9 = P1(3)*P2(3)
        x10 = -x5 + x6 + x8 + x9
        x4vec = co(1)*w1(:)*x10
        x5vec = P1(2)*P2(2)*co(1)*w1(:)
        wout = w2(0)*(-P1(0)**2*x1vec + P1(1)**2*x1vec + P1(2)**2*x1vec + P1(3 &
               )**2*x1vec + x0*x0vec - x0vec*x2 - x0vec*x3 - x0vec*x4 + x0vec* &
               x5 - x0vec*x6 - x0vec*x8 - x0vec*x9 + x10*x5vec + x2vec*x5 -    &
               x2vec*x6 - x2vec*x8 - x2vec*x9 - x3vec*x5 + x3vec*x6 + x3vec*x9 &
                - x4vec*x5 + x4vec*x6 + x4vec*x9 + x5vec*x7)
      end select 
    end subroutine treeVSV
end module tcVSV
