!******************************************************************************!
!                                                                              !
!    tcVVS.f90                                                                 !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVVS.f90                                      |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-16 19:50             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113, x114, x115, x116, x117,  &
                  x118, x119, x120, x121, x122, x123, x124, x125, x126, x127,  &
                  x128, x129, x130, x131, x132, x133, x134, x135, x136, x137,  &
                  x138, x139, x140, x141, x142, x143, x144, x145, x146, x147,  &
                  x148, x149, x150, x151, x152, x153, x154, x155, x156, x157,  &
                  x158, x159, x160, x161, x162, x163, x164, x165, x166, x167,  &
                  x168, x169, x170, x171, x172, x173, x174, x175, x176, x177,  &
                  x178, x179, x180, x181, x182, x183, x184, x185, x186, x187,  &
                  x188, x189, x190, x191, x192, x193, x194, x195, x196, x197,  &
                  x198, x199, x200, x201, x202, x203, x204, x205, x206, x207,  &
                  x208, x209, x210, x211, x212, x213, x214, x215, x216, x217,  &
                  x218, x219, x220, x221, x222, x223, x224, x225, x226, x227,  &
                  x228, x229, x230, x231, x232, x233, x234, x235, x236, x237,  &
                  x238, x239, x240, x241, x242, x243, x244, x245, x246, x247,  &
                  x248, x249, x250, x251, x252, x253, x254, x255, x256, x257,  &
                  x258, x259, x260, x261, x262, x263, x264, x265, x266, x267,  &
                  x268, x269, x270, x271, x272, x273, x274, x275, x276, x277,  &
                  x278, x279, x280, x281, x282, x283, x284, x285, x286, x287,  &
                  x288, x289, x290, x291, x292, x293, x294, x295, x296, x297,  &
                  x298, x299, x300, x301, x302, x303, x304, x305, x306, x307,  &
                  x308, x309, x310, x311, x312, x313, x314, x315, x316, x317,  &
                  x318, x319, x320, x321, x322, x323, x324, x325, x326, x327,  &
                  x328, x329, x330, x331, x332, x333, x334, x335, x336, x337,  &
                  x338, x339, x340, x341, x342, x343, x344, x345, x346, x347,  &
                  x348, x349, x350, x351, x352, x353, x354, x355, x356, x357,  &
                  x358, x359, x360, x361, x362, x363, x364, x365, x366, x367,  &
                  x368, x369, x370, x371, x372, x373, x374, x375, x376, x377,  &
                  x378, x379, x380, x381, x382, x383, x384, x385, x386, x387,  &
                  x388, x389, x390, x391, x392, x393, x394
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec
  contains
    subroutine treeVVS(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,   &
    VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VVS0)
!       c0*(P(-1,1)*P(-1,2)*P(1,3)*P(2,3) - P(-1,1)*P(-1,3)*P(1,2)*P(2,3) - P(-1,
!       2)*P(-1,3)*P(1,3)*P(2,1))
!       Metric(1,2)*P(-1,1)*P(-1,2)*P(-1,3)**2*c1
!       c2*(Epsilon(-1,-2,-3,1)*P(-1,1)*P(-2,2)*P(-3,3)*P(2,3) - Epsilon(-1,-3,1,
!       2)*P(-1,1)*P(-2,2)*P(-2,3)*P(-3,3))
!       c3*(-Epsilon(-1,-2,-3,2)*P(-1,1)*P(-2,2)*P(-3,3)*P(1,3) + Epsilon(-2,-3,1
!       ,2)*P(-1,1)*P(-1,3)*P(-2,2)*P(-3,3))
        x0 = P1(1)**2
        x1 = w1(2)*w2(3) - w1(3)*w2(2)
        x2 = P1(1)*x1
        x3 = w1(1)*w2(2) - w1(2)*w2(1)
        x4 = P1(3)*x3
        x5 = w1(1)*w2(3) - w1(3)*w2(1)
        x6 = P1(2)*x5
        x7 = x2 + x4 - x6
        x8 = w1(0)*w2(1) - w1(1)*w2(0)
        x9 = w1(0)*w2(3) - w1(3)*w2(0)
        x10 = P1(0)*x5 - P1(1)*x9 + P1(3)*x8
        x11 = P2(2)*x10
        x12 = P1(0)*x1
        x13 = w1(0)*w2(2) - w1(2)*w2(0)
        x14 = P1(3)*x13
        x15 = P1(2)*x9
        x16 = x12 + x14 - x15
        x17 = P1(0)*x3
        x18 = P1(2)*x8
        x19 = P1(1)*x13
        x20 = x17 + x18 - x19
        x21 = co(3)*(P2(0)*x7 - P2(1)*x16 - P2(3)*x20 + x11)
        x22 = P2(1)*x1
        x23 = P2(3)*x3
        x24 = P2(2)*x5
        x25 = x22 + x23 - x24
        x26 = P2(0)*x5 - P2(1)*x9 + P2(3)*x8
        x27 = P2(2)*x26
        x28 = P2(0)*x1
        x29 = P2(3)*x13
        x30 = P2(2)*x9
        x31 = x28 + x29 - x30
        x32 = P2(0)*x3
        x33 = P2(2)*x8
        x34 = P2(1)*x13
        x35 = x32 + x33 - x34
        x36 = co(3)*(P2(0)*x25 - P2(1)*x31 - P2(3)*x35 + x27)
        x37 = P1(2)**2
        x38 = P1(3)**2
        x39 = P2(0)**2
        x40 = -x2 - x4 + x6
        x41 = P2(1)**2
        x42 = P2(2)**2
        x43 = P2(3)**2
        x44 = P1(0)*co(2)
        x45 = -x22 - x23 + x24
        x46 = P2(0)*x40
        x47 = P1(1)*P2(1)
        x48 = P1(2)*P2(2)
        x49 = P1(3)*P2(3)
        x50 = P2(0)*x45
        x51 = P2(1)*(-x12 - x14 + x15) + P2(3)*(-x17 - x18 + x19) + x11 - x46
        x52 = P1(0)**2
        x53 = co(3)*x52
        x54 = P2(1)*(-x28 - x29 + x30) + P2(3)*(-x32 - x33 + x34) + x27 - x50
        x55 = -x39 + x41 + x42 + x43
        x56 = P1(1)*co(2)*x16
        x57 = P1(0)*P2(0)
        x58 = x47 + x48 + x49 - x57
        x59 = P1(1)*co(2)*x31
        x60 = P1(0)*w1(3) - P1(3)*w1(0)
        x61 = P1(2)*w1(3) - P1(3)*w1(2)
        x62 = P1(0)*w1(2) - P1(2)*w1(0)
        x63 = -P2(0)*x61 + P2(2)*x60 - P2(3)*x62
        x64 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x65 = P1(1)*co(2)*x64
        x66 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x67 = P1(1)*co(2)*x66
        x68 = P2(0)*w1(3) - P2(3)*w1(0)
        x69 = P2(2)*w1(3) - P2(3)*w1(2)
        x70 = P2(0)*w1(2) - P2(2)*w1(0)
        x71 = -P2(0)*x69 + P2(2)*x68 - P2(3)*x70
        x72 = P1(2)*w2(3) - P1(3)*w2(2)
        x73 = P1(0)*w2(2) - P1(2)*w2(0)
        x74 = P1(0)*w2(3) - P1(3)*w2(0)
        x75 = P2(0)*x72 - P2(2)*x74 + P2(3)*x73
        x76 = -P1(0)*w1(0) + P1(1)*w1(1) + P1(2)*w1(2) + P1(3)*w1(3)
        x77 = P1(1)*co(3)*x76
        x78 = -P2(0)*w1(0) + P2(1)*w1(1) + P2(2)*w1(2) + P2(3)*w1(3)
        x79 = P1(1)*co(3)*x78
        x80 = P2(2)*w2(3) - P2(3)*w2(2)
        x81 = P2(0)*w2(2) - P2(2)*w2(0)
        x82 = P2(0)*w2(3) - P2(3)*w2(0)
        x83 = P2(0)*x80 - P2(2)*x82 + P2(3)*x81
        x84 = x39 - x41 - x42 - x43
        x85 = P1(2)*co(2)*x10
        x86 = -x47 - x48 - x49 + x57
        x87 = P1(1)*w1(3) - P1(3)*w1(1)
        x88 = P1(0)*w1(1) - P1(1)*w1(0)
        x89 = P1(2)*co(2)*(P2(0)*x87 - P2(1)*x60 + P2(3)*x88)
        x90 = P2(1)*w1(3) - P2(3)*w1(1)
        x91 = P2(0)*w1(1) - P2(1)*w1(0)
        x92 = P1(2)*co(2)*(P2(0)*x90 - P2(1)*x68 + P2(3)*x91)
        x93 = P1(2)*co(2)*x26
        x94 = P1(1)*w2(3) - P1(3)*w2(1)
        x95 = P1(0)*w2(1) - P1(1)*w2(0)
        x96 = -P2(0)*x94 + P2(1)*x74 - P2(3)*x95
        x97 = P1(2)*co(3)*x76
        x98 = P1(2)*co(3)*x78
        x99 = P2(1)*w2(3) - P2(3)*w2(1)
        x100 = P2(0)*w2(1) - P2(1)*w2(0)
        x101 = -P2(0)*x99 + P2(1)*x82 - P2(3)*x100
        x102 = P1(3)*co(2)*x20
        x103 = P1(3)*co(2)*x35
        x104 = P1(1)*w1(2) - P1(2)*w1(1)
        x105 = P1(3)*co(2)*(-P2(0)*x104 + P2(1)*x62 - P2(2)*x88)
        x106 = P2(1)*w1(2) - P2(2)*w1(1)
        x107 = P1(3)*co(2)*(-P2(0)*x106 + P2(1)*x70 - P2(2)*x91)
        x108 = P1(1)*w2(2) - P1(2)*w2(1)
        x109 = P2(0)*x108 - P2(1)*x73 + P2(2)*x95
        x110 = P1(3)*co(3)*x76
        x111 = P1(3)*co(3)*x78
        x112 = P2(1)*w2(2) - P2(2)*w2(1)
        x113 = P2(0)*x112 - P2(1)*x81 + P2(2)*x100
        x114 = co(0)*x64*x78
        x115 = co(0)*x66*x78
        x116 = co(0)*x64*x76
        x117 = P1(0)*P2(0)*co(3)
        x118 = P1(0)*co(2)*(-P2(1)*x61 + P2(2)*x87 - P2(3)*x104)
        x119 = P1(0)*co(2)*(-P2(1)*x69 + P2(2)*x90 - P2(3)*x106)
        x120 = co(3)*x76
        x121 = P1(0)*(P2(1)*x72 - P2(2)*x94 + P2(3)*x108)
        x122 = co(3)*x78
        x123 = P1(0)*(P2(1)*x80 - P2(2)*x99 + P2(3)*x112)
        x124 = co(0)*x66*x76
        x125 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x126 = co(1)*x125*(x0 + x37 + x38 - x52)
        x127 = co(1)*x125*x55
        x128 = 2*co(1)*x125*x58
        wout(0) = x0*x114 + x0*x115 + x0*x21 + x0*x36 + x101*x97 + x101*x98 +  &
                  x102*x55 + x102*x58 + x103*x55 + x103*x58 + x105*x64 + x105* &
                  x66 + x107*x64 + x107*x66 + x109*x110 + x109*x111 + x110*x113&
                   + x111*x113 + x114*x37 + x114*x38 - x114*x39 + x114*x41 +   &
                  x114*x42 + x114*x43 + x114*x47 + x114*x48 + x114*x49 - x114* &
                  x52 - x114*x57 + x115*x37 + x115*x38 - x115*x52 - x116*x39 + &
                  x116*x41 + x116*x42 + x116*x43 - x117*x51 - x117*x54 - x118* &
                  x64 - x118*x66 - x119*x64 - x119*x66 - x120*x121 - x120*x123 &
                   - x121*x122 - x122*x123 - x124*x47 - x124*x48 - x124*x49 +  &
                  x124*x57 - x126*x47 - x126*x48 - x126*x49 + x126*x57 - x127* &
                  x47 - x127*x48 - x127*x49 + x127*x57 - x128*x47 - x128*x48 - &
                  x128*x49 + x128*x57 + x21*x37 + x21*x38 + x21*x47 + x21*x48  &
                   + x21*x49 + x36*x37 + x36*x38 + x36*x47 + x36*x48 + x36*x49 &
                   - x44*(P1(0)*x46 + x47*x7 + x48*x7 + x49*x7) - x44*(P1(0)*  &
                  x50 + x25*x47 + x25*x48 + x25*x49) - x44*(x25*x41 + x25*x42  &
                   + x25*x43 + x39*x45) - x44*(x39*x40 + x41*x7 + x42*x7 + x43*&
                  x7) - x51*x53 - x53*x54 + x55*x56 + x55*x59 + x56*x58 + x58* &
                  x59 + x63*x65 + x63*x67 + x64*x89 + x64*x92 + x65*x71 + x66* &
                  x89 + x66*x92 + x67*x71 + x75*x77 + x75*x79 + x77*x83 + x79* &
                  x83 + x84*x85 + x84*x93 + x85*x86 + x86*x93 + x96*x97 + x96* &
                  x98
        wout(1:3) = cnul
      case(VVS1)
!       P(1,2)*P(2,3)*c0
!       P(1,3)*P(2,1)*c1
!       Metric(1,2)*P(-1,2)*P(-1,3)*c2
!       Metric(1,2)*P(-1,1)*P(-1,3)*c3
!       Epsilon(-1,-2,1,2)*P(-1,2)*P(-2,3)*c4
!       Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*c5
        x0 = w1(2)*w2(3) - w1(3)*w2(2)
        x1 = w1(1)*w2(2) - w1(2)*w2(1)
        x2 = w1(1)*w2(3) - w1(3)*w2(1)
        x3 = P1(1)*x0 - P1(2)*x2 + P1(3)*x1
        x4 = P1(0)*co(5)
        x5 = P2(1)*x0 - P2(2)*x2 + P2(3)*x1
        x6 = w1(0)*w2(1) - w1(1)*w2(0)
        x7 = w1(0)*w2(3) - w1(3)*w2(0)
        x8 = P1(0)*x2 - P1(1)*x7 + P1(3)*x6
        x9 = P1(2)*co(5)
        x10 = P2(0)*x2 - P2(1)*x7 + P2(3)*x6
        x11 = P2(0)*co(4)
        x12 = P2(2)*co(4)
        x13 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x14 = co(2)*x13
        x15 = co(3)*x13
        x16 = w1(0)*w2(2) - w1(2)*w2(0)
        x17 = P1(0)*x0 - P1(2)*x7 + P1(3)*x16
        x18 = P1(1)*co(5)
        x19 = P2(0)*x0 - P2(2)*x7 + P2(3)*x16
        x20 = P1(0)*x1 - P1(1)*x16 + P1(2)*x6
        x21 = P1(3)*co(5)
        x22 = P2(0)*x1 - P2(1)*x16 + P2(2)*x6
        x23 = P2(1)*co(4)
        x24 = P2(3)*co(4)
        x25 = P1(0)*P2(0)
        x26 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x27 = co(1)*w1(0)*x26
        x28 = P2(0)*w1(0)
        x29 = co(0)*x26
        x30 = co(0)*(-P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3))
        x31 = P1(1)*P2(1)
        x32 = co(1)*w1(1)*x26
        x33 = P1(2)*P2(2)
        x34 = co(1)*w1(2)*x26
        x35 = P1(3)*P2(3)
        x36 = co(1)*w1(3)*x26
        x37 = P2(1)*w1(1)
        x38 = P2(2)*w1(2)
        x39 = P2(3)*w1(3)
        wout(0) = P1(0)**2*x15 + P1(0)*x27 - P1(1)**2*x15 - P1(1)*x32 - P1(2)**&
                  2*x15 - P1(2)*x34 - P1(3)**2*x15 - P1(3)*x36 + P2(0)**2*x14  &
                   + P2(0)*x27 - P2(1)**2*x14 - P2(1)*x32 - P2(2)**2*x14 - P2(2&
                  )*x34 - P2(3)**2*x14 - P2(3)*x36 + x10*x12 + x10*x9 + x11*x3 &
                   + x11*x5 + x12*x8 + x14*x25 - x14*x31 - x14*x33 - x14*x35 + &
                  x15*x25 - x15*x31 - x15*x33 - x15*x35 - x17*x18 - x17*x23 -  &
                  x18*x19 - x19*x23 - x20*x21 - x20*x24 - x21*x22 - x22*x24 +  &
                  x28*x29 + x28*x30 - x29*x37 - x29*x38 - x29*x39 + x3*x4 - x30&
                  *x37 - x30*x38 - x30*x39 + x4*x5 + x8*x9
        wout(1:3) = cnul
      case(VVS2)
!       Metric(1,2)*c0
        wout(0) = co(0)*(w1(0)*w2(0) - w1(1)*w2(1) - w1(2)*w2(2) - w1(3)*w2(3))
        wout(1:3) = cnul
      case(VVS3)
!       P(1,3)*P(2,1)*c0
!       Metric(1,2)*P(-1,1)*P(-1,3)*c1
!       Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*c2
        x0 = w1(2)*w2(3) - w1(3)*w2(2)
        x1 = w1(1)*w2(2) - w1(2)*w2(1)
        x2 = w1(1)*w2(3) - w1(3)*w2(1)
        x3 = P1(0)*co(2)
        x4 = w1(0)*w2(1) - w1(1)*w2(0)
        x5 = w1(0)*w2(3) - w1(3)*w2(0)
        x6 = P1(2)*co(2)
        x7 = co(1)*(-w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3))
        x8 = w1(0)*w2(2) - w1(2)*w2(0)
        x9 = P1(1)*co(2)
        x10 = P1(3)*co(2)
        x11 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x12 = co(0)*w1(0)*x11
        x13 = co(0)*w1(1)*x11
        x14 = co(0)*w1(2)*x11
        x15 = co(0)*w1(3)*x11
        wout(0) = P1(0)**2*x7 + P1(0)*P2(0)*x7 + P1(0)*x12 - P1(1)**2*x7 - P1(1&
                  )*P2(1)*x7 - P1(1)*x13 - P1(2)**2*x7 - P1(2)*P2(2)*x7 - P1(2 &
                  )*x14 - P1(3)**2*x7 - P1(3)*P2(3)*x7 - P1(3)*x15 + P2(0)*x12 &
                   - P2(1)*x13 - P2(2)*x14 - P2(3)*x15 - x10*(P1(0)*x1 - P1(1)*&
                  x8 + P1(2)*x4) - x10*(P2(0)*x1 - P2(1)*x8 + P2(2)*x4) + x3*( &
                  P1(1)*x0 - P1(2)*x2 + P1(3)*x1) + x3*(P2(1)*x0 - P2(2)*x2 +  &
                  P2(3)*x1) + x6*(P1(0)*x2 - P1(1)*x5 + P1(3)*x4) + x6*(P2(0)* &
                  x2 - P2(1)*x5 + P2(3)*x4) - x9*(P1(0)*x0 - P1(2)*x5 + P1(3)* &
                  x8) - x9*(P2(0)*x0 - P2(2)*x5 + P2(3)*x8)
        wout(1:3) = cnul
      case(VVS4)
!       P(1,2)*P(2,3)*c0
!       Metric(1,2)*P(-1,2)*P(-1,3)*c1
!       Epsilon(-1,-2,1,2)*P(-1,2)*P(-2,3)*c2
        x0 = w1(2)*w2(3) - w1(3)*w2(2)
        x1 = w1(1)*w2(2) - w1(2)*w2(1)
        x2 = w1(1)*w2(3) - w1(3)*w2(1)
        x3 = P2(0)*co(2)
        x4 = w1(0)*w2(1) - w1(1)*w2(0)
        x5 = w1(0)*w2(3) - w1(3)*w2(0)
        x6 = P2(2)*co(2)
        x7 = co(1)*(-w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3))
        x8 = w1(0)*w2(2) - w1(2)*w2(0)
        x9 = P2(1)*co(2)
        x10 = P2(3)*co(2)
        x11 = P2(0)*w1(0)
        x12 = co(0)*(-P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3))
        x13 = co(0)*(-P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3))
        x14 = P2(1)*w1(1)
        x15 = P2(2)*w1(2)
        x16 = P2(3)*w1(3)
        wout(0) = P1(0)*P2(0)*x7 - P1(1)*P2(1)*x7 - P1(2)*P2(2)*x7 - P1(3)*P2(3&
                  )*x7 + P2(0)**2*x7 - P2(1)**2*x7 - P2(2)**2*x7 - P2(3)**2*x7 &
                   - x10*(P1(0)*x1 - P1(1)*x8 + P1(2)*x4) - x10*(P2(0)*x1 - P2(&
                  1)*x8 + P2(2)*x4) + x11*x12 + x11*x13 - x12*x14 - x12*x15 -  &
                  x12*x16 - x13*x14 - x13*x15 - x13*x16 + x3*(P1(1)*x0 - P1(2)*&
                  x2 + P1(3)*x1) + x3*(P2(1)*x0 - P2(2)*x2 + P2(3)*x1) + x6*(P1&
                  (0)*x2 - P1(1)*x5 + P1(3)*x4) + x6*(P2(0)*x2 - P2(1)*x5 + P2(&
                  3)*x4) - x9*(P1(0)*x0 - P1(2)*x5 + P1(3)*x8) - x9*(P2(0)*x0  &
                   - P2(2)*x5 + P2(3)*x8)
        wout(1:3) = cnul
      case(VVS5)
!       c0*(P(-1,1)*P(-1,2)*P(1,3)*P(2,3) - P(-1,1)*P(-1,3)*P(1,2)*P(2,3) - P(-1,
!       2)*P(-1,3)*P(1,3)*P(2,1))
!       Metric(1,2)*P(-1,1)*P(-1,2)*P(-1,3)**2*c1
        x0 = P1(1)**2
        x1 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x2 = -P2(0)*w1(0) + P2(1)*w1(1) + P2(2)*w1(2) + P2(3)*w1(3)
        x3 = co(0)*x1*x2
        x4 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x5 = co(0)*x2*x4
        x6 = P1(2)**2
        x7 = P1(3)**2
        x8 = -P1(0)*w1(0) + P1(1)*w1(1) + P1(2)*w1(2) + P1(3)*w1(3)
        x9 = P2(1)**2
        x10 = co(0)*x1*x9
        x11 = P2(2)**2
        x12 = co(0)*x1*x8
        x13 = P2(3)**2
        x14 = P1(0)**2
        x15 = P2(0)**2
        x16 = P1(0)*P2(0)
        x17 = co(0)*x4*x8
        x18 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x19 = co(1)*x18*(x0 - x14 + x6 + x7)
        x20 = co(1)*x18*(x11 + x13 - x15 + x9)
        x21 = P1(1)*P2(1)
        x22 = P1(2)*P2(2)
        x23 = P1(3)*P2(3)
        x24 = 2*co(1)*x18*(-x16 + x21 + x22 + x23)
        wout(0) = x0*x3 + x0*x5 + x10*x2 + x10*x8 + x11*x12 + x11*x3 + x12*x13 &
                   - x12*x15 + x13*x3 - x14*x3 - x14*x5 - x15*x3 + x16*x17 +   &
                  x16*x19 + x16*x20 + x16*x24 - x16*x3 - x17*x21 - x17*x22 -   &
                  x17*x23 - x19*x21 - x19*x22 - x19*x23 - x20*x21 - x20*x22 -  &
                  x20*x23 - x21*x24 + x21*x3 - x22*x24 + x22*x3 - x23*x24 + x23&
                  *x3 + x3*x6 + x3*x7 + x5*x6 + x5*x7
        wout(1:3) = cnul
      end select 
    end subroutine treeVVS
end module tcVVS
