!******************************************************************************!
!                                                                              !
!    tcVVV.f90                                                                 !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVVV.f90                                      |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: M. Chiesa, J.N. Lang                   |            !
!        | `---' | UFO date: No date                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-10-16 19:50             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVVV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102, x103, x104, x105, x106, x107,    &
                  x108, x109, x110, x111, x112, x113, x114, x115, x116, x117,  &
                  x118, x119, x120, x121, x122, x123, x124, x125, x126, x127,  &
                  x128, x129, x130, x131, x132, x133, x134, x135, x136, x137,  &
                  x138, x139, x140, x141, x142, x143, x144, x145, x146, x147,  &
                  x148, x149, x150, x151, x152, x153, x154, x155, x156, x157,  &
                  x158, x159, x160, x161, x162, x163, x164, x165, x166, x167,  &
                  x168, x169, x170, x171, x172, x173, x174, x175, x176, x177,  &
                  x178, x179, x180, x181, x182, x183, x184, x185, x186, x187,  &
                  x188, x189, x190, x191, x192, x193, x194, x195, x196, x197,  &
                  x198, x199, x200, x201, x202, x203, x204, x205, x206, x207,  &
                  x208, x209, x210, x211, x212, x213, x214, x215, x216, x217,  &
                  x218, x219, x220, x221, x222, x223, x224, x225, x226, x227,  &
                  x228, x229, x230, x231, x232, x233, x234, x235, x236, x237,  &
                  x238, x239, x240, x241, x242, x243, x244, x245, x246, x247,  &
                  x248, x249, x250, x251, x252, x253, x254, x255, x256, x257,  &
                  x258, x259, x260, x261, x262, x263, x264, x265, x266, x267,  &
                  x268, x269, x270, x271, x272, x273, x274, x275, x276, x277,  &
                  x278, x279, x280, x281, x282, x283, x284, x285, x286, x287,  &
                  x288, x289, x290, x291, x292, x293, x294, x295, x296, x297,  &
                  x298, x299, x300, x301, x302, x303, x304, x305, x306, x307,  &
                  x308, x309, x310, x311, x312, x313, x314, x315, x316, x317,  &
                  x318, x319, x320, x321, x322, x323, x324, x325, x326, x327,  &
                  x328, x329, x330, x331, x332, x333, x334, x335, x336, x337,  &
                  x338, x339, x340, x341, x342, x343, x344, x345, x346, x347,  &
                  x348, x349, x350, x351, x352, x353, x354, x355, x356, x357,  &
                  x358, x359, x360, x361, x362, x363, x364, x365, x366, x367,  &
                  x368, x369, x370, x371, x372, x373, x374, x375, x376, x377,  &
                  x378, x379, x380, x381, x382, x383, x384, x385, x386, x387,  &
                  x388, x389, x390, x391, x392, x393, x394
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec
  contains
    subroutine treeVVV(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,   &
    VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VVV0)
!       P(1,2)*P(2,3)*P(3,1)*c0
!       P(1,3)*P(2,1)*P(3,2)*c1
!       Metric(1,2)*P(-1,2)*P(-1,3)*P(3,1)*c2
!       Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3)*c3
!       Metric(2,3)*P(-1,1)*P(-1,3)*P(1,2)*c4
!       Metric(1,3)*P(-1,2)*P(-1,3)*P(2,1)*c5
!       Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3)*c6
!       Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2)*c7
!       -Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3)*c8
!       Epsilon(-1,-2,-3,3)*Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3)*c9
!       Epsilon(-1,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3)*c10
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1)*c11
!       Epsilon(-1,-2,1,2)*P(-1,2)*P(-2,3)*P(3,1)*c12
!       Epsilon(-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2,3)*c13
!       Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2)*c14
!       Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2)*c15
!       Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2)*c16
!       Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,2)*P(1,3)*c17
!       Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3)*c18
!       Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*P(-2,3)*c19
!       c20*(Metric(1,2)*P(3,1) - Metric(1,3)*P(2,1))
!       c21*(Metric(1,3)*P(2,3) - Metric(2,3)*P(1,3))
!       c22*(-Metric(1,2)*P(3,2) + Metric(2,3)*P(1,2))
!       c23*(Metric(1,2)*P(3,3) - Metric(2,3)*P(1,1))
!       Epsilon(-1,1,2,3)*P(-1,1)*c24
!       Epsilon(-1,1,2,3)*P(-1,2)*c25
!       Epsilon(-1,1,2,3)*P(-1,3)*c26
        if (last) VB_last = .true.
        x0 = w1(3)*w2(3)
        x1 = w1(0)*w2(0)
        x2 = w1(1)*w2(1) + w1(2)*w2(2) + x0 - x1
        x3 = co(23)*x2
        x4 = w1(2)*w2(3)
        x5 = w1(3)*w2(2)
        x6 = x4 - x5
        x7 = P1(1)*x6
        x8 = w1(1)*w2(3)
        x9 = w1(3)*w2(1)
        x10 = x8 - x9
        x11 = P1(2)*x10
        x12 = w1(1)*w2(2)
        x13 = w1(2)*w2(1)
        x14 = x12 - x13
        x15 = P1(3)*x14
        x16 = co(22)*x2
        x17 = P2(1)*x6
        x18 = P2(2)*x10
        x19 = P2(3)*x14
        x20 = P1(1)**2
        x21 = x17 - x18 + x19
        x22 = co(14)*x21
        x23 = P1(2)**2
        x24 = P1(3)**2
        x25 = co(20)*x2
        x26 = P1(0)**2
        x27 = P1(0)*P2(0)
        x28 = -x11 + x15 + x7
        x29 = co(12)*x28
        x30 = co(12)*x21
        x31 = co(16)*x28
        x32 = co(16)*x21
        x33 = P1(0)*P2(2)
        x34 = P1(0)*x10
        x35 = w1(0)*w2(1)
        x36 = -w1(1)*w2(0) + x35
        x37 = P1(3)*x36
        x38 = w1(0)*w2(3)
        x39 = w1(3)*w2(0)
        x40 = x38 - x39
        x41 = P1(1)*x40
        x42 = x34 + x37 - x41
        x43 = co(12)*x42
        x44 = P2(0)*x10
        x45 = P2(3)*x36
        x46 = P2(1)*x40
        x47 = x44 + x45 - x46
        x48 = co(12)*x47
        x49 = P1(0)*w1(0)
        x50 = P1(2)*w2(3)
        x51 = P1(3)*w2(2)
        x52 = x50 - x51
        x53 = P1(1)*w2(2)
        x54 = P1(2)*w2(1)
        x55 = x53 - x54
        x56 = P1(1)*w2(3)
        x57 = P1(3)*w2(1)
        x58 = x56 - x57
        x59 = co(10)*(P2(1)*x52 - P2(2)*x58 + P2(3)*x55)
        x60 = P2(2)*w2(3) - P2(3)*w2(2)
        x61 = P2(1)*w2(2) - P2(2)*w2(1)
        x62 = P2(1)*w2(3)
        x63 = -P2(3)*w2(1) + x62
        x64 = co(10)*(P2(1)*x60 - P2(2)*x63 + P2(3)*x61)
        x65 = co(2)*x2
        x66 = P2(0)**2
        x67 = P1(0)*x66
        x68 = co(7)*x2
        x69 = P1(1)*P2(1)
        x70 = P1(1)*P2(1)*co(19)
        x71 = P2(1)**2
        x72 = P2(2)**2
        x73 = P2(3)**2
        x74 = co(13)*(-x66 + x71 + x72 + x73)
        x75 = P1(2)*P2(2)
        x76 = P1(3)*P2(3)
        x77 = co(13)*(-x27 + x69 + x75 + x76)
        x78 = P2(1)*w1(1)
        x79 = P2(2)*w1(2)
        x80 = P2(3)*w1(3)
        x81 = P2(0)*w1(0)
        x82 = x78 + x79 + x80 - x81
        x83 = P1(1)*co(15)*x82
        x84 = P1(1)*w1(1)
        x85 = P1(2)*w1(2)
        x86 = P1(3)*w1(3)
        x87 = -x49 + x84 + x85 + x86
        x88 = P1(1)*co(17)
        x89 = P1(1)*co(17)*x82
        x90 = P2(2)*w1(3)
        x91 = P2(3)*w1(2)
        x92 = x90 - x91
        x93 = P1(1)*w2(1)
        x94 = P1(2)*w2(2)
        x95 = P1(3)*w2(3)
        x96 = P1(0)*w2(0)
        x97 = x93 + x94 + x95 - x96
        x98 = P1(1)*co(18)*x97
        x99 = P2(1)*w2(1)
        x100 = P2(0)*w2(0)
        x101 = P2(2)*w2(2) + P2(3)*w2(3) - x100 + x99
        x102 = co(18)*x101*x92
        x103 = P1(1)*co(20)
        x104 = P1(1)*co(21)
        x105 = P1(1)*w2(0)
        x106 = P1(2)*w1(3)
        x107 = P1(3)*w1(2)
        x108 = x106 - x107
        x109 = P2(0)*x108
        x110 = P1(0)*w1(2)
        x111 = P1(2)*w1(0)
        x112 = x110 - x111
        x113 = P2(3)*x112
        x114 = P1(0)*w1(3)
        x115 = P1(3)*w1(0)
        x116 = x114 - x115
        x117 = P2(2)*x116
        x118 = co(8)*(x109 + x113 - x117)
        x119 = P2(0)*x92
        x120 = P2(2)*w1(0)
        x121 = P2(0)*w1(2) - x120
        x122 = P2(3)*x121
        x123 = P2(0)*w1(3) - P2(3)*w1(0)
        x124 = P2(2)*x123
        x125 = co(8)*(x119 + x122 - x124)
        x126 = P1(2)*P2(0)
        x127 = co(16)*x42
        x128 = co(16)*x47
        x129 = P1(2)*P2(2)*co(19)
        x130 = P1(0)*w2(1)
        x131 = -x105 + x130
        x132 = P1(0)*w2(3)
        x133 = -P1(3)*w2(0) + x132
        x134 = co(10)*(P2(0)*x58 - P2(1)*x133 + P2(3)*x131)
        x135 = P2(1)*w2(0)
        x136 = P2(0)*w2(1) - x135
        x137 = P2(3)*w2(0)
        x138 = P2(0)*w2(3) - x137
        x139 = co(10)*(P2(0)*x63 - P2(1)*x138 + P2(3)*x136)
        x140 = P1(2)*w1(0)*w2(2)
        x141 = P1(2)*w2(0)
        x142 = P1(1)*P2(3)
        x143 = P1(3)*P2(1)
        x144 = x142 - x143
        x145 = P1(2)*co(9)*x2
        x146 = P1(3)*P2(3)*co(19)
        x147 = P1(3)*co(15)*x82
        x148 = P1(3)*co(17)
        x149 = co(17)*x61*x82
        x150 = P2(1)*w1(2)
        x151 = -P2(2)*w1(1) + x150
        x152 = P1(3)*co(18)*x97
        x153 = co(18)*x101*x151
        x154 = P1(3)*w1(0)*w2(3)
        x155 = P1(3)*co(23)*w1(3)
        x156 = P1(1)*w1(2)
        x157 = P1(2)*w1(1)
        x158 = x156 - x157
        x159 = P2(0)*x158
        x160 = P1(0)*w1(1)
        x161 = P1(1)*w1(0)
        x162 = x160 - x161
        x163 = P2(2)*x162
        x164 = P2(1)*x112
        x165 = x159 + x163 - x164
        x166 = P1(3)*co(8)*w2(0)
        x167 = P2(0)*x151
        x168 = P2(0)*w1(1)
        x169 = P2(1)*w1(0)
        x170 = x168 - x169
        x171 = P2(2)*x170
        x172 = P2(1)*x121
        x173 = x167 + x171 - x172
        x174 = P2(0)*x26
        x175 = P2(0)*co(22)
        x176 = P2(1)*x108
        x177 = co(11)*x97
        x178 = P2(1)*x92
        x179 = co(21)*w2(2)
        x180 = P2(3)*x158
        x181 = P2(3)*x151
        x182 = P2(3)*co(21)
        x183 = co(1)*w1(0)*x97
        x184 = co(4)*x26*x82
        x185 = co(5)*x66*x97
        x186 = P1(0)*P2(0)*co(19)
        x187 = P1(0)*P2(1)
        x188 = P1(0)*x6
        x189 = w1(0)*w2(2)
        x190 = -w1(2)*w2(0) + x189
        x191 = P1(3)*x190
        x192 = P1(2)*x40
        x193 = x188 + x191 - x192
        x194 = co(12)*x193
        x195 = P2(0)*x6
        x196 = P2(3)*x190
        x197 = P2(2)*x40
        x198 = x195 + x196 - x197
        x199 = co(12)*x198
        x200 = P1(0)*P2(3)
        x201 = P1(0)*x14
        x202 = P1(2)*x36
        x203 = P1(1)*x190
        x204 = x201 + x202 - x203
        x205 = co(12)*x204
        x206 = P2(0)*x14
        x207 = P2(2)*x36
        x208 = P2(1)*x190
        x209 = x206 + x207 - x208
        x210 = co(12)*x209
        x211 = co(2)*x2*x71
        x212 = co(2)*x2*x72
        x213 = P1(0)*co(2)*x2
        x214 = co(20)*w2(0)
        x215 = P1(0)*co(23)*w1(0)
        x216 = P1(1)*w1(3)
        x217 = P1(3)*w1(1)
        x218 = x216 - x217
        x219 = P2(2)*x218
        x220 = co(8)*(x176 + x180 - x219)
        x221 = P2(3)*w1(1)
        x222 = P2(1)*w1(3) - x221
        x223 = P2(2)*x222
        x224 = co(8)*(x178 + x181 - x223)
        x225 = P1(1)*P2(0)
        x226 = co(16)*x193
        x227 = co(16)*x198
        x228 = P1(0)*w2(2)
        x229 = -x141 + x228
        x230 = co(10)*(P2(0)*x52 - P2(2)*x133 + P2(3)*x229)
        x231 = P2(0)*w2(2) - P2(2)*w2(0)
        x232 = co(10)*(P2(0)*x60 - P2(2)*x138 + P2(3)*x231)
        x233 = co(21)*w1(1)
        x234 = P1(2)*P2(3)
        x235 = P1(3)*P2(2)
        x236 = co(9)*x2*(x234 - x235)
        x237 = co(15)*x58*x82
        x238 = P1(2)*co(15)*x82
        x239 = P1(2)*co(17)*x87
        x240 = P1(2)*co(17)*x82
        x241 = co(18)*x97
        x242 = co(18)*x101*x222
        x243 = co(21)*w1(2)
        x244 = P2(0)*x218
        x245 = P2(3)*x162
        x246 = P2(1)*x116
        x247 = co(8)*(x244 + x245 - x246)
        x248 = P2(0)*x222
        x249 = P2(3)*x170
        x250 = P2(1)*x123
        x251 = co(8)*(x248 + x249 - x250)
        x252 = P1(3)*P2(0)
        x253 = co(16)*x204
        x254 = co(16)*x209
        x255 = co(10)*(P2(0)*x55 - P2(1)*x229 + P2(2)*x131)
        x256 = co(10)*(P2(0)*x61 - P2(1)*x231 + P2(2)*x136)
        x257 = co(21)*w2(0)
        x258 = P1(1)*P2(2)
        x259 = P1(2)*P2(1)
        x260 = x258 - x259
        x261 = P1(3)*co(9)*x2
        x262 = P2(0)*co(7)*x2
        x263 = co(22)*w1(1)
        x264 = P2(2)*co(22)*w1(2)
        x265 = co(21)*w1(3)
        x266 = co(4)*w2(0)*x82
        x267 = co(4)*x24*x82
        x268 = co(5)*x71*x97
        x269 = co(5)*x72*x97
        x270 = co(5)*x73*x97
        x271 = w1(0)*x97
        x272 = P1(0)*P2(0)*co(0)
        x273 = w1(0)*x101
        x274 = P1(0)*P2(0)*co(3)*x87
        x275 = P1(0)*P2(0)*co(3)*x82
        x276 = co(5)*w1(0)*x97
        x277 = P1(0)*P2(0)*co(6)
        x278 = P1(3)*co(2)*x2
        x279 = co(0)*x97
        x280 = P1(0)*P2(1)*w1(1)
        x281 = co(0)*x101
        x282 = P2(2)*co(0)*w1(2)*x97
        x283 = P2(2)*co(0)*w1(2)*x101
        x284 = P1(0)*P2(3)*w1(3)
        x285 = P2(0)*co(1)*w1(1)*x97
        x286 = P1(1)*P2(1)*w2(0)
        x287 = co(3)*x87
        x288 = co(3)*x82
        x289 = co(4)*x82
        x290 = P1(1)*P2(1)*co(6)
        x291 = co(1)*w1(2)*x97
        x292 = P1(2)*P2(2)*co(3)*x87
        x293 = P1(2)*P2(2)*co(3)*x82
        x294 = P1(2)*P2(2)*co(6)
        x295 = P2(3)*co(7)*x2
        x296 = P2(0)*co(1)*x97
        x297 = P1(3)*P2(3)*w2(0)
        x298 = co(5)*x97
        x299 = P1(3)*P2(3)*co(6)*w1(0)
        x300 = co(14)*x198
        x301 = P1(0)*co(15)*x82
        x302 = P1(0)*co(17)*x87
        x303 = P1(0)*co(17)*x82
        x304 = P1(0)*co(18)*x97
        x305 = co(21)*w2(1)
        x306 = co(19)*x193
        x307 = P1(1)*co(2)*x2
        x308 = P1(1)*w1(1)*w2(1)
        x309 = P1(2)*co(20)*w2(2)
        x310 = P1(2)*w1(2)*w2(1)
        x311 = x200 - x252
        x312 = x231*x87
        x313 = co(17)*x231*x82
        x314 = co(18)*x101
        x315 = P1(3)*co(20)
        x316 = P1(3)*co(21)
        x317 = co(8)*x165
        x318 = co(8)*x173
        x319 = P2(0)*co(21)
        x320 = P2(1)*co(7)*x2
        x321 = co(21)*w1(1)*w2(2)
        x322 = co(4)*w2(1)*x82
        x323 = P1(0)*co(20)*w2(0)
        x324 = P1(1)*P2(3)*co(12)
        x325 = x138*x87
        x326 = co(18)*x123*x97
        x327 = -x126 + x33
        x328 = P2(3)*co(22)
        x329 = co(1)*x97
        x330 = w1(1)*x71
        x331 = P1(0)*P2(0)*w1(1)
        x332 = co(6)*x97
        x333 = co(6)*x101
        x334 = P2(1)*co(1)*x97
        x335 = P2(1)*co(0)*x97
        x336 = P2(1)*co(0)*x101
        x337 = P1(1)*P2(1)*w2(1)
        x338 = P1(1)*P2(1)*co(6)*w1(1)
        x339 = P1(1)*P2(3)*w1(3)
        x340 = P1(2)*co(1)*x97
        x341 = P1(2)*P2(2)*co(6)*x97
        x342 = P1(3)*P2(3)*w2(1)
        x343 = P1(3)*P2(3)*w1(1)
        x344 = P2(2)*co(1)*x97
        x345 = co(14)*x47
        x346 = co(21)*w1(0)
        x347 = P1(0)*co(9)*x2
        x348 = P1(1)*co(18)*x101
        x349 = P1(2)*co(2)*x2
        x350 = P1(2)*w1(2)*w2(2)
        x351 = P1(3)*co(23)
        x352 = co(9)*x2*(x187 - x225)
        x353 = P2(2)*co(7)*x2
        x354 = co(21)*w2(3)
        x355 = co(5)*w1(2)*x97
        x356 = co(23)*w1(0)
        x357 = co(19)*x47
        x358 = P1(1)*co(9)*x2
        x359 = P1(3)*x136
        x360 = P1(3)*x170
        x361 = P2(2)*x23
        x362 = co(4)*w2(2)*x82
        x363 = P1(0)*P2(0)*w2(2)
        x364 = P2(0)*co(4)*x82
        x365 = P1(0)*P2(0)*w1(2)
        x366 = P1(2)*P2(0)*w1(0)
        x367 = co(3)*w2(2)*x87
        x368 = P1(1)*P2(1)*w1(2)
        x369 = P1(2)*P2(2)*w1(2)
        x370 = P1(2)*P2(3)*w1(3)
        x371 = P2(2)*co(1)*w1(3)*x97
        x372 = P1(3)*P2(3)*w2(2)
        x373 = P1(3)*P2(3)*w1(2)
        x374 = co(14)*x209
        x375 = P1(2)*x170
        x376 = P1(2)*w1(2)*w2(3)
        x377 = co(4)*w2(3)*x82
        x378 = P1(3)*x73
        x379 = w1(3)*x73
        x380 = P1(0)*P2(0)*w2(3)
        x381 = P1(0)*P2(0)*w1(3)
        x382 = P2(3)*co(1)*x97
        x383 = P1(3)*P2(0)*w1(0)
        x384 = P1(1)*P2(1)*w2(3)
        x385 = P1(1)*P2(1)*co(6)*w1(3)
        x386 = P1(2)*P2(2)*w1(3)
        x387 = P1(3)*P2(3)*w1(3)
        x388 = P1(3)*P2(3)*w2(3)
        wout(0) = -P1(0)*x211 - P1(0)*x212 - P1(0)*x25 - P1(0)*x282 - P1(0)*   &
                  x283 + P1(0)*x3 + P1(1)*x102 - P1(1)*x236 - P1(1)*x285 - P1(2&
                  )*x222*x241 - P1(2)*x237 - P1(2)*x242 - P1(3)*P2(3)*w1(0)*   &
                  x298 + P1(3)*x149 + P1(3)*x153 + P2(0)*x16 + P2(0)*x3 + P2(1 &
                  )*co(21)*x35 - P2(1)*x285 + co(20)*x140 + co(20)*x154 + co(21&
                  )*x140 + co(21)*x154 - co(22)*w1(3)*x137 + co(23)*w1(1)*x105 &
                   + co(23)*w1(2)*x141 - co(24)*x11 + co(24)*x15 + co(24)*x7 + &
                  co(25)*x17 - co(25)*x18 + co(25)*x19 + co(26)*x11 - co(26)*  &
                  x15 - co(26)*x17 + co(26)*x18 - co(26)*x19 - co(26)*x7 + w1(0&
                  )*x185 - w1(0)*x268 - w1(0)*x269 - w1(0)*x270 + w2(0)*x155 + &
                  w2(0)*x184 - w2(0)*x215 - w2(0)*x264 - w2(0)*x267 + w2(0)*   &
                  x274 + w2(0)*x275 - w2(0)*x292 - w2(0)*x293 + x1*x175 - x101*&
                  x299 + x103*x35 + x104*x35 + x105*x118 + x105*x125 - x105*   &
                  x233 - x11*x74 - x11*x77 + x111*x134 + x111*x139 - x115*x255 &
                   - x115*x256 + x120*x179 + x126*x127 + x126*x128 - x126*x291 &
                   + x129*x21 + x129*x28 - x135*x233 - x135*x263 - x137*x265 - &
                  x141*x243 - x141*x247 - x141*x251 + x144*x145 + x146*x21 +   &
                  x146*x28 + x147*x55 + x147*x61 + x148*x61*x87 + x15*x74 + x15&
                  *x77 + x151*x152 - x161*x230 - x161*x232 + x165*x166 + x166* &
                  x173 + x174*x65 + x174*x68 + x176*x177 + x177*x178 + x177*   &
                  x180 + x177*x181 - x177*x219 - x177*x223 + x182*x38 + x183*  &
                  x27 + x183*x66 - x186*x21 - x186*x28 - x187*x194 - x187*x199 &
                   + x20*x22 - x20*x262 - x20*x266 - x200*x205 - x200*x210 -   &
                  x200*x278 + x21*x70 - x213*x69 - x213*x73 - x213*x75 - x214* &
                  x49 + x22*x23 + x22*x24 - x22*x26 - x22*x27 + x22*x69 + x22* &
                  x75 + x22*x76 - x220*x96 - x224*x96 - x225*x226 - x225*x227  &
                   - x23*x262 - x23*x266 - x238*x63 - x239*x63 - x24*x262 -    &
                  x240*x63 - x252*x253 - x252*x254 - x252*x295 - x257*x79 -    &
                  x257*x86 - x260*x261 - x262*x69 - x262*x75 + x266*x27 - x266*&
                  x75 + x27*x276 + x27*x29 + x27*x30 + x27*x31 + x27*x32 + x271&
                  *x272 + x271*x277 - x271*x290 - x271*x294 + x272*x273 + x273*&
                  x277 - x273*x290 - x273*x294 - x276*x69 - x276*x75 - x279*   &
                  x280 - x279*x284 + x28*x70 - x280*x281 - x281*x284 - x286*   &
                  x287 - x286*x288 - x286*x289 - x287*x297 - x288*x297 - x289* &
                  x297 - x296*x79 - x296*x80 - x296*x86 - x299*x97 + x33*x43 + &
                  x33*x48 + x49*x59 + x49*x64 + x52*x83 + x60*x83 + x60*x87*x88&
                   + x60*x89 + x65*x67 + x67*x68 + x7*x74 + x7*x77 + x92*x98
        wout(1) = P1(0)*x102 - P1(0)*x236 + P1(1)*P2(0)*co(0)*x271 + P1(1)*P2(0&
                  )*w1(0)*x281 - P1(1)*P2(1)*w1(1)*x298 - P1(1)*x211 - P1(1)*  &
                  x212 - P1(1)*x25 - P1(1)*x282 - P1(1)*x283 + P1(1)*x3 - P1(1 &
                  )*x68*x71 - P1(2)*P2(2)*w1(1)*x298 - P1(2)*co(17)*x325 - P1(2&
                  )*x123*x314 - P1(2)*x326 + P1(3)*x121*x314 + P1(3)*x313 + P2(&
                  1)*x16 - P2(1)*x20*x65 + P2(1)*x3 + P2(2)*x321 + co(20)*x308 &
                   - co(21)*x310 + co(23)*x308 + co(23)*x310 + co(24)*x188 + co&
                  (24)*x191 - co(24)*x192 + co(25)*x195 + co(25)*x196 - co(25)*&
                  x197 - co(26)*x188 - co(26)*x191 + co(26)*x192 - co(26)*x195 &
                   - co(26)*x196 + co(26)*x197 - w1(1)*x101*x294 + w1(1)*x185  &
                   - w1(1)*x269 - w1(1)*x270 + w1(1)*x309 - w1(1)*x323 - w1(1)*&
                  x341 + w2(1)*x155 - w2(1)*x215 - w2(1)*x264 + w2(1)*x274 + w2&
                  (1)*x275 - w2(1)*x292 - w2(1)*x293 - x101*x338 + x109*x177 + &
                  x113*x177 - x117*x177 + x118*x93 + x119*x177 + x121*x152 +   &
                  x122*x177 - x124*x177 + x125*x93 + x127*x259 + x128*x259 +   &
                  x129*x198 - x130*x220 - x130*x224 - x133*x238 + x134*x157 -  &
                  x138*x238 - x138*x240 + x139*x157 - x143*x253 - x143*x254 -  &
                  x143*x295 + x145*x311 + x146*x198 + x147*x229 + x147*x231 +  &
                  x148*x312 - x150*x340 - x150*x344 + x160*x59 + x160*x64 -    &
                  x168*x257 + x169*x296 + x175*x35 + x182*x8 - x182*x9 - x186* &
                  x198 + x187*x31 + x187*x32 + x188*x74 + x188*x77 + x191*x74  &
                   + x191*x77 - x192*x74 - x192*x77 - x194*x69 + x198*x70 -    &
                  x199*x69 + x20*x300 - x20*x320 - x20*x322 - x204*x324 - x209*&
                  x324 - x217*x255 - x217*x256 + x225*x29 + x225*x30 - x226*x69&
                   - x227*x69 + x23*x300 - x23*x320 - x23*x322 - x230*x84 -    &
                  x232*x84 + x233*x94 - x233*x96 + x24*x300 - x24*x320 - x24*  &
                  x322 - x247*x54 - x251*x54 + x258*x43 + x258*x48 - x26*x300  &
                   + x26*x320 + x26*x322 - x261*x327 - x263*x99 - x27*x300 -   &
                  x27*x306 + x27*x307 + x27*x320 + x27*x322 - x279*x339 - x281*&
                  x339 - x287*x337 - x287*x342 - x288*x337 - x288*x342 - x289* &
                  x337 - x289*x342 - x298*x330 + x298*x331 - x298*x343 + x300* &
                  x69 + x300*x75 + x300*x76 + x301*x52 + x301*x60 + x302*x60 + &
                  x303*x60 + x304*x92 + x305*x49 - x305*x79 - x305*x86 + x306* &
                  x69 + x306*x75 + x306*x76 + x307*x66 - x307*x73 - x307*x75 - &
                  x307*x76 + x315*x8 + x316*x8 + x317*x57 + x318*x57 + x319*x35&
                   - x320*x75 - x322*x75 - x328*x9 - x329*x330 + x331*x332 +   &
                  x331*x333 - x332*x343 - x333*x343 + x334*x49 - x334*x80 -    &
                  x334*x84 - x334*x86 - x335*x84 - x336*x84 - x338*x97
        wout(2) = -P1(0)*x237 - P1(0)*x242 - P1(1)*P2(1)*w2(2)*x288 + P1(1)*   &
                  x326 - P1(2)*x212 - P1(2)*x25 + P1(2)*x3 - P1(2)*x68*x72 + P1&
                  (3)*x352 - P1(3)*x371 - P2(1)*co(22)*x12 - P2(1)*x321 + P2(2 &
                  )*x16 + P2(2)*x3 - P2(3)*x371 - co(15)*x359*x82 - co(17)*x359&
                  *x82 - co(17)*x359*x87 + co(20)*x350 + co(23)*w2(2)*x84 + co(&
                  23)*x350 - co(24)*x34 - co(24)*x37 + co(24)*x41 - co(25)*x44 &
                   - co(25)*x45 + co(25)*x46 + co(26)*x34 + co(26)*x37 - co(26 &
                  )*x41 + co(26)*x44 + co(26)*x45 - co(26)*x46 - w1(2)*x323 -  &
                  w1(2)*x341 + w2(2)*x184 - w2(2)*x264 - w2(2)*x267 - w2(2)*   &
                  x293 - x100*x243 + x103*x13 + x104*x13 - x107*x255 - x107*   &
                  x256 + x110*x59 + x110*x64 + x118*x53 + x120*x296 + x123*x348&
                   + x125*x53 + x126*x29 + x126*x30 + x127*x75 + x128*x75 -    &
                  x129*x42 - x131*x147 + x133*x83 + x134*x85 + x138*x83 + x138*&
                  x89 + x139*x85 + x144*x347 - x146*x42 - x146*x47 + x150*x305 &
                   - x156*x230 - x156*x232 - x157*x335 - x157*x336 + x175*x189 &
                   - x177*x244 - x177*x245 + x177*x246 - x177*x248 - x177*x249 &
                   + x177*x250 - x179*x84 - x182*x5 + x186*x42 + x186*x47 +    &
                  x189*x319 - x194*x259 - x199*x259 - x20*x345 - x20*x353 - x20&
                  *x362 - x205*x234 - x210*x234 - x220*x228 - x222*x304 - x224*&
                  x228 - x226*x258 - x227*x258 + x228*x346 - x228*x356 + x228* &
                  x364 - x23*x345 - x23*x362 - x234*x278 - x235*x253 - x235*   &
                  x254 - x24*x345 - x24*x353 - x241*x360 - x243*x96 - x247*x94 &
                   - x251*x94 + x26*x345 + x26*x353 + x27*x345 + x27*x349 + x27&
                  *x353 + x27*x355 + x279*x366 - x279*x369 - x279*x370 + x281* &
                  x366 - x281*x369 - x281*x370 + x287*x363 - x287*x372 + x288* &
                  x363 - x288*x372 - x289*x372 - x291*x72 - x291*x75 - x298*   &
                  x368 - x298*x373 - x301*x63 - x302*x63 - x303*x63 + x31*x33  &
                   - x311*x358 - x314*x360 + x315*x4 + x316*x4 - x316*x5 + x317&
                  *x51 + x318*x51 + x32*x33 + x325*x88 - x328*x5 + x332*x365 - &
                  x332*x368 - x332*x373 + x333*x365 - x333*x368 - x333*x369 -  &
                  x333*x373 - x34*x74 - x34*x77 + x344*x49 - x344*x78 - x344*  &
                  x84 - x345*x69 - x345*x75 - x345*x76 + x349*x66 - x349*x69 - &
                  x349*x71 - x349*x73 + x351*x5 - x353*x69 - x353*x76 + x354*  &
                  x91 + x355*x66 - x355*x71 - x355*x72 - x355*x73 - x355*x75 - &
                  x357*x69 - x357*x75 - x361*x65 - x361*x68 - x362*x69 - x362* &
                  x75 - x367*x69 - x367*x75 - x37*x74 - x37*x77 + x41*x74 + x41&
                  *x77 - x42*x70 + x43*x75 + x48*x75
        wout(3) = P1(0)*x149 + P1(0)*x153 - P1(1)*P2(1)*w1(3)*x298 + P1(1)*co( &
                  23)*x8 - P1(1)*x313 - P1(2)*x352 - P1(3)*x211 - P1(3)*x212 - &
                  P1(3)*x25 - P1(3)*x282 - P1(3)*x283 + P1(3)*x3 + P2(3)*x16 - &
                  P2(3)*x24*x65 + P2(3)*x3 - co(21)*x376 + co(23)*x376 + co(24 &
                  )*x201 + co(24)*x202 - co(24)*x203 + co(25)*x206 + co(25)*   &
                  x207 - co(25)*x208 - co(26)*x201 - co(26)*x202 + co(26)*x203 &
                   - co(26)*x206 - co(26)*x207 + co(26)*x208 + w1(3)*x185 - w1(&
                  3)*x268 - w1(3)*x269 + w1(3)*x309 - w2(3)*x264 - w2(3)*x267  &
                   - w2(3)*x292 - w2(3)*x293 + x0*x315 - x0*x328 + x0*x351 -   &
                  x101*x385 + x103*x9 - x104*x8 + x104*x9 + x106*x134 + x106*  &
                  x139 - x114*x214 - x114*x257 + x114*x59 + x114*x64 + x118*x56&
                   - x121*x348 - x121*x98 + x125*x56 + x127*x234 + x128*x234 + &
                  x129*x204 + x129*x209 + x131*x238 - x132*x220 - x132*x224 +  &
                  x132*x346 - x132*x356 + x132*x364 + x136*x238 + x136*x239 +  &
                  x136*x240 - x142*x226 - x142*x227 - x143*x194 - x143*x199 +  &
                  x146*x204 + x146*x209 + x151*x304 + x159*x177 + x163*x177 -  &
                  x164*x177 + x167*x177 + x171*x177 - x172*x177 + x175*x38 +   &
                  x179*x90 - x186*x204 - x186*x209 - x20*x295 + x20*x374 - x20*&
                  x377 + x200*x31 + x200*x32 + x201*x74 + x201*x77 + x202*x74  &
                   + x202*x77 - x203*x74 - x203*x77 + x204*x70 - x205*x76 +    &
                  x209*x70 - x210*x76 - x216*x230 - x216*x232 - x217*x335 -    &
                  x217*x336 - x221*x334 - x229*x83 - x23*x295 + x23*x374 - x23*&
                  x377 - x231*x83 - x233*x62 + x235*x43 + x235*x48 - x24*x295  &
                   + x24*x374 + x241*x375 - x247*x50 - x251*x50 + x252*x29 +   &
                  x252*x30 - x253*x76 - x254*x76 - x255*x86 - x256*x86 + x26*  &
                  x295 - x26*x374 + x26*x377 - x260*x347 - x263*x62 + x265*x94 &
                   + x265*x99 + x27*x278 + x27*x295 - x27*x374 + x278*x66 -    &
                  x278*x69 - x278*x75 + x279*x383 - x279*x387 + x281*x383 -    &
                  x281*x387 + x287*x380 - x287*x384 - x287*x388 + x288*x380 -  &
                  x288*x384 - x288*x388 - x289*x384 - x289*x388 - x295*x69 -   &
                  x295*x75 - x298*x379 + x298*x381 - x298*x386 - x298*x387 +   &
                  x301*x55 + x301*x61 + x302*x61 - x312*x88 + x314*x375 + x317*&
                  x95 + x318*x95 + x319*x38 - x319*x39 + x327*x358 - x329*x379 &
                   - x329*x387 + x332*x381 - x332*x386 - x332*x387 + x333*x381 &
                   - x333*x386 - x333*x387 - x340*x91 - x344*x91 - x354*x79 +  &
                  x374*x69 + x374*x75 + x374*x76 - x377*x75 - x378*x65 - x378* &
                  x68 + x382*x49 + x382*x81 - x382*x84 - x385*x97
      case(VVV1)
!       c0*(Metric(1,2)*P(3,1) - Metric(1,3)*P(2,1))
!       c1*(Metric(1,3)*P(2,3) - Metric(2,3)*P(1,3))
!       c2*(-Metric(1,2)*P(3,2) + Metric(2,3)*P(1,2))
!       c3*(Metric(1,2)*P(3,3) - Metric(2,3)*P(1,1))
        if (last) VB_last = .true.
        x0 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x0vec = P1(:)*x0
        x1vec = P2(:)*x0
        x2vec = co(1)*w1(0)*w2(:)
        x3vec = co(0)*w1(:)
        x4vec = co(1)*w1(:)*w2(1)
        x5vec = co(3)*w2(:)
        x1 = P1(1)*w1(1)
        x6vec = w1(:)*w2(2)
        x2 = P1(2)*co(1)
        x7vec = w1(2)*w2(:)
        x8vec = co(1)*w1(:)*w2(3)
        x9vec = P1(3)*w1(3)*w2(:)
        x10vec = co(2)*w2(:)
        x3 = P2(2)*co(1)
        x4 = P1(0)*w2(0)
        x11vec = co(1)*w1(:)
        x12vec = co(1)*w2(:)
        x5 = P2(1)*w1(1)
        x13vec = P2(3)*w1(3)*w2(:)
        wout = -P1(0)*w1(0)*x5vec + P1(0)*x2vec + P1(1)*w2(1)*x3vec + P1(1)*   &
               x4vec + P1(2)*co(0)*x6vec + P1(2)*co(3)*x7vec + P1(3)*w2(3)*    &
               x3vec + P1(3)*x8vec + P2(0)*w1(0)*x10vec - P2(0)*w2(0)*x11vec + &
               P2(0)*x2vec + P2(1)*x4vec - P2(2)*co(2)*x7vec + P2(3)*x8vec - co&
               (0)*x0vec - co(1)*x13vec - co(1)*x9vec - co(2)*x13vec + co(2)*  &
               x1vec + co(3)*x0vec + co(3)*x1vec + co(3)*x9vec - x1*x12vec + x1&
               *x5vec - x10vec*x5 - x11vec*x4 - x12vec*x5 + x2*x6vec - x2*x7vec&
                + x3*x6vec - x3*x7vec - x3vec*x4
      case(VVV2)
!       P(1,2)*P(2,3)*P(3,1)*c0
!       P(1,3)*P(2,1)*P(3,2)*c1
!       c2*(-Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) - Metric(1,3)*P(-1,1)*P(-1,2)*P(2
!       ,3))
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1)*c3
!       Epsilon(-1,-2,1,2)*P(-1,2)*P(-2,3)*P(3,1)*c4
!       Epsilon(-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2,3)*c5
!       Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2)*c6
!       Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2)*c7
!       Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2)*c8
!       Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,2)*P(1,3)*c9
!       Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3)*c10
!       Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*P(-2,3)*c11
        if (last) VB_last = .true.
        x0 = w1(2)*w2(3) - w1(3)*w2(2)
        x1 = w1(1)*w2(2) - w1(2)*w2(1)
        x2 = w1(1)*w2(3) - w1(3)*w2(1)
        x3 = P2(1)*x0 - P2(2)*x2 + P2(3)*x1
        x4 = P1(1)**2
        x5 = co(6)*x4
        x6 = P1(2)**2
        x7 = co(6)*x6
        x8 = P1(3)**2
        x9 = co(6)*x8
        x10 = P1(0)**2
        x11 = co(6)*x10
        x12 = P1(1)*x0
        x13 = P1(3)*x1
        x14 = P1(2)*x2
        x15 = x12 + x13 - x14
        x16 = P1(0)*P2(0)
        x17 = P1(0)*P2(0)*x3
        x18 = co(8)*x15
        x19 = P1(0)*co(4)
        x20 = P1(0)*x2
        x21 = w1(0)*w2(1) - w1(1)*w2(0)
        x22 = P1(3)*x21
        x23 = w1(0)*w2(3) - w1(3)*w2(0)
        x24 = P1(1)*x23
        x25 = x20 + x22 - x24
        x26 = P2(2)*x25
        x27 = P2(0)*x2 - P2(1)*x23 + P2(3)*x21
        x28 = P2(2)*co(4)*x27
        x29 = P1(1)*P2(1)*co(11)
        x30 = P1(1)*P2(1)*co(6)
        x31 = P2(2)*w1(3)
        x32 = P2(3)*w1(2)
        x33 = x31 - x32
        x34 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x35 = P1(1)*co(10)*x34
        x36 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x37 = P1(1)*co(10)*x36
        x38 = P2(1)**2
        x39 = P2(2)**2
        x40 = P2(3)**2
        x41 = P2(0)**2
        x42 = x38 + x39 + x40 - x41
        x43 = co(5)*x42
        x44 = P1(1)*P2(1)
        x45 = P1(2)*P2(2)
        x46 = P1(3)*P2(3)
        x47 = -x16 + x44 + x45 + x46
        x48 = co(5)*x47
        x49 = P1(2)*w2(3) - P1(3)*w2(2)
        x50 = P2(2)*w1(2)
        x51 = P2(3)*w1(3)
        x52 = P2(0)*w1(0)
        x53 = P2(1)*w1(1) + x50 + x51 - x52
        x54 = P1(1)*co(7)*x53
        x55 = P2(2)*w2(3) - P2(3)*w2(2)
        x56 = P1(1)*w1(1)
        x57 = P1(2)*w1(2)
        x58 = P1(3)*w1(3)
        x59 = P1(0)*w1(0)
        x60 = x56 + x57 + x58 - x59
        x61 = co(9)*x55*x60
        x62 = P1(1)*co(9)*x53
        x63 = P1(2)*x25
        x64 = P2(0)*co(8)
        x65 = P1(2)*co(8)*x27
        x66 = P1(2)*P2(2)*co(11)
        x67 = P1(3)*P2(3)*co(11)
        x68 = P1(3)*P2(3)*co(6)
        x69 = P1(3)*x34
        x70 = P2(1)*w1(2)
        x71 = P2(2)*w1(1)
        x72 = x70 - x71
        x73 = co(10)*x72
        x74 = P1(3)*x36
        x75 = P1(1)*w2(2) - P1(2)*w2(1)
        x76 = P1(3)*co(7)*x53
        x77 = P2(1)*w2(2) - P2(2)*w2(1)
        x78 = P1(3)*co(9)*x60
        x79 = P1(3)*co(9)*x53
        x80 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x81 = P2(0)*co(2)*x80
        x82 = P1(2)*w1(3)
        x83 = -P1(3)*w1(2) + x82
        x84 = P2(1)*co(3)*x34
        x85 = P1(2)*w1(1)
        x86 = P1(1)*w1(2) - x85
        x87 = P2(3)*co(3)*x34
        x88 = co(1)*x34
        x89 = P1(0)*P2(0)*co(11)
        x90 = P1(0)*x0
        x91 = w1(0)*w2(2) - w1(2)*w2(0)
        x92 = P1(3)*x91
        x93 = P1(2)*x23
        x94 = x90 + x92 - x93
        x95 = P2(1)*x94
        x96 = P2(0)*x0 - P2(2)*x23 + P2(3)*x91
        x97 = P2(1)*x96
        x98 = P1(2)*x21
        x99 = P1(1)*x91
        x100 = P1(0)*x1 + x98 - x99
        x101 = P2(3)*x100
        x102 = P1(0)*P2(3)
        x103 = P2(0)*x1 - P2(1)*x91 + P2(2)*x21
        x104 = co(4)*x103
        x105 = co(2)*x80
        x106 = P1(1)*co(8)*x94
        x107 = P1(1)*co(8)*x96
        x108 = P2(3)*w1(1)
        x109 = P2(1)*w1(3) - x108
        x110 = P1(2)*co(10)*x34
        x111 = P1(2)*co(10)*x36
        x112 = P1(1)*w2(3) - P1(3)*w2(1)
        x113 = P1(2)*co(7)*x53
        x114 = P2(1)*w2(3) - P2(3)*w2(1)
        x115 = P1(2)*co(9)*x114
        x116 = P1(3)*x100
        x117 = P1(3)*co(8)*x103
        x118 = P1(1)*w1(3)
        x119 = P1(3)*w1(1)
        x120 = x118 - x119
        x121 = P2(2)*co(3)*x34
        x122 = P1(0)*P2(0)*w1(0)
        x123 = co(0)*x34
        x124 = co(0)*x36
        x125 = P2(0)*co(1)*x34
        x126 = P1(1)*P2(1)*co(2)*x34
        x127 = co(2)*w1(0)*x36
        x128 = P1(2)*P2(2)*co(2)*x34
        x129 = P1(2)*P2(2)*co(2)*x36
        x130 = co(2)*x34
        x131 = co(2)*x36
        x132 = P1(0)*w1(1)
        x133 = P2(1)*co(0)*x34
        x134 = P2(1)*co(0)*x36
        x135 = P1(0)*P2(2)*w1(2)
        x136 = P1(0)*w1(3)
        x137 = P2(3)*co(0)*x34
        x138 = P2(3)*co(0)*x36
        x139 = P2(0)*w1(1)
        x140 = P2(1)*co(1)*x34
        x141 = P1(0)*co(8)*x15
        x142 = P2(1)*co(8)
        x143 = P1(0)*x3
        x144 = P1(0)*co(10)*x34
        x145 = P1(0)*co(10)*x36
        x146 = P1(0)*co(7)*x53
        x147 = P1(0)*co(9)*x53
        x148 = P1(1)*P2(0)*co(4)
        x149 = P1(1)*co(4)
        x150 = P1(2)*P2(2)*x96
        x151 = P2(0)*w1(2)
        x152 = P2(2)*w1(0)
        x153 = x151 - x152
        x154 = co(10)*x153
        x155 = P1(0)*w2(2) - P1(2)*w2(0)
        x156 = P2(0)*w2(2) - P2(2)*w2(0)
        x157 = P2(0)*co(3)*x34
        x158 = co(2)*x4*x80
        x159 = P2(1)*co(2)*x80
        x160 = P1(2)*w1(0)
        x161 = P1(0)*w1(2) - x160
        x162 = P1(1)*P2(1)*co(4)
        x163 = P1(1)*P2(1)*co(8)
        x164 = P2(3)*w1(0)
        x165 = P2(0)*w1(3) - x164
        x166 = P1(0)*w2(3) - P1(3)*w2(0)
        x167 = P2(0)*w2(3) - P2(3)*w2(0)
        x168 = x167*x53
        x169 = P1(2)*co(7)
        x170 = P1(2)*co(9)
        x171 = P1(3)*w1(0)
        x172 = x136 - x171
        x173 = P1(1)*co(0)*x34
        x174 = P1(1)*co(0)*x36
        x175 = P1(1)*P2(1)*w1(1)
        x176 = P1(3)*P2(3)*w1(1)
        x177 = P2(1)*w1(0)
        x178 = P1(0)*co(2)*x34
        x179 = P1(0)*co(2)*x36
        x180 = P1(2)*co(1)*x34
        x181 = P2(2)*co(1)*x34
        x182 = co(6)*x27
        x183 = P1(1)*co(9)*x60
        x184 = P1(2)*P2(0)*co(4)
        x185 = P1(2)*P2(2)*x25
        x186 = co(4)*x27
        x187 = P2(2)*co(2)*x80
        x188 = P1(0)*co(9)*x60
        x189 = P1(2)*co(4)
        x190 = P1(3)*P2(2)
        x191 = co(8)*x103
        x192 = x139 - x177
        x193 = co(10)*x192
        x194 = P1(0)*w2(1) - P1(1)*w2(0)
        x195 = P2(0)*w2(1) - P2(1)*w2(0)
        x196 = x195*x53
        x197 = P1(3)*co(9)
        x198 = x195*x60
        x199 = -P1(1)*w1(0) + x132
        x200 = co(1)*w1(2)*x34
        x201 = P1(1)*x36
        x202 = P2(0)*co(0)*x34
        x203 = P2(0)*co(0)*x36
        x204 = P2(3)*co(2)*w1(2)
        x205 = P1(2)*P2(2)*w1(2)
        x206 = P2(3)*co(1)*x34
        x207 = P1(0)*co(5)*x1
        x208 = co(11)*x103
        x209 = co(6)*x103
        x210 = P1(2)*co(10)*x192
        x211 = P1(3)*P2(0)*co(4)
        x212 = P2(3)*co(2)*x80
        x213 = P1(3)*co(4)
        x214 = P1(3)*P2(3)*x100
        x215 = P1(2)*P2(2)*w1(3)
        x216 = P1(3)*P2(3)*w1(3)
        x217 = P1(0)*P2(0)*w1(3)
        x218 = P2(2)*co(0)*w1(2)
        wout(0) = -P1(0)*x105*x41 + P1(0)*x28 + P1(1)*x61 + P1(3)*P2(3)*w1(0)* &
                  x130 - P2(0)*x106 - P2(0)*x107 - P2(0)*x117 + P2(0)*x65 - co(&
                  11)*x17 + co(4)*x15*x16 + co(4)*x17 - co(6)*x17 + co(6)*x3*  &
                  x45 + co(8)*x17 + w1(0)*x126 + w1(0)*x128 + w1(0)*x129 + w1(0&
                  )*x41*x88 - x10*x81 - x101*x19 - x102*x104 - x109*x110 - x109&
                  *x111 - x109*x121 - x11*x3 - x112*x113 - x113*x114 - x115*x53&
                   - x115*x60 - x116*x64 + x12*x43 + x12*x48 - x120*x121 + x122&
                  *x123 + x122*x124 - x122*x130 - x122*x131 - x123*x135 - x124*&
                  x135 - x125*x50 - x125*x51 - x125*x56 - x125*x57 - x125*x58  &
                   + x125*x59 + x127*x44 + x127*x46 + x13*x43 + x13*x48 - x132*&
                  x133 - x132*x134 - x136*x137 - x136*x138 - x139*x140 - x14*  &
                  x43 - x14*x48 + x15*x29 + x15*x66 + x15*x67 - x15*x89 + x16* &
                  x18 + x19*x26 - x19*x95 - x19*x97 + x29*x3 + x3*x30 + x3*x5  &
                   + x3*x66 + x3*x67 + x3*x68 + x3*x7 + x3*x9 + x33*x35 + x33* &
                  x37 + x33*x84 + x4*x81 + x44*x81 + x45*x81 + x46*x81 + x49*  &
                  x54 + x54*x55 + x55*x62 + x6*x81 + x63*x64 + x69*x73 + x72*  &
                  x87 + x73*x74 + x75*x76 + x76*x77 + x77*x78 + x77*x79 + x8*  &
                  x81 + x83*x84 + x86*x87
        wout(1) = P1(0)*x61 - P1(1)*P2(3)*x104 + P1(1)*x105*x38 + P1(1)*x28 +  &
                  P1(2)*x142*x27 - P2(1)*x117 + P2(1)*x141 + P2(1)*x158 + co(11&
                  )*x150 + co(6)*x150 - co(6)*x16*x96 + w1(1)*x128 + w1(1)*x129&
                   - w1(1)*x38*x88 - x10*x159 - x101*x149 - x11*x96 - x110*x165&
                   - x111*x165 - x113*x166 - x116*x142 - x118*x137 - x118*x138 &
                   - x121*x165 - x121*x172 + x125*x177 + x130*x175 + x130*x176 &
                   + x131*x175 + x131*x176 - x133*x56 - x134*x56 - x139*x178 - &
                  x139*x179 - x140*x51 - x140*x56 - x140*x58 + x140*x59 + x142*&
                  x143 + x142*x63 + x144*x33 + x145*x33 + x146*x49 + x146*x55  &
                   + x147*x55 + x148*x15 + x148*x3 + x149*x26 + x153*x87 + x154&
                  *x69 + x154*x74 + x155*x76 + x156*x76 + x156*x78 + x156*x79  &
                   + x157*x33 + x157*x83 - x159*x16 + x159*x45 + x159*x46 +    &
                  x159*x6 + x159*x8 + x161*x87 - x162*x94 - x162*x96 - x163*x94&
                   - x163*x96 - x167*x170*x60 - x168*x169 - x168*x170 - x173*  &
                  x50 + x173*x52 - x174*x50 + x174*x52 - x180*x70 - x181*x70 + &
                  x29*x94 + x29*x96 + x30*x96 + x43*x90 + x43*x92 - x43*x93 +  &
                  x48*x90 + x48*x92 - x48*x93 + x5*x96 + x66*x94 + x67*x94 +   &
                  x67*x96 + x68*x96 + x7*x96 - x89*x94 - x89*x96 + x9*x96
        wout(2) = P1(1)*P2(1)*w1(2)*x130 + P1(1)*co(7)*x168 + P1(1)*co(9)*x168 &
                   + P1(2)*x105*x39 - P1(3)*co(7)*x196 + P2(1)*co(2)*w1(2)*x201&
                   - P2(2)*co(1)*w1(3)*x69 + P2(2)*co(8)*x143 - P2(2)*x106 - P2&
                  (2)*x107 + P2(2)*x141 - P2(3)*x103*x189 + co(4)*x185 - co(8)*&
                  x100*x190 + co(8)*x185 + co(8)*x27*x45 + w1(2)*x128 + w1(2)* &
                  x129 - x10*x187 - x101*x189 - x109*x144 - x109*x145 - x109*  &
                  x157 + x11*x27 - x112*x146 - x114*x146 - x114*x147 - x114*   &
                  x188 - x120*x157 - x123*x205 - x124*x205 + x125*x152 - x133* &
                  x85 - x134*x85 - x137*x82 - x138*x82 - x140*x71 + x15*x184 - &
                  x151*x178 - x151*x179 + x16*x182 - x16*x187 + x160*x202 +    &
                  x160*x203 + x165*x35 + x165*x37 + x165*x84 + x166*x54 + x167*&
                  x183 + x172*x84 - x181*x56 + x181*x59 - x182*x45 - x182*x46  &
                   + x184*x3 + x186*x45 + x187*x4 + x187*x44 + x187*x46 + x187*&
                  x6 + x187*x8 - x189*x95 - x189*x97 - x190*x191 - x192*x87 -  &
                  x193*x69 - x193*x74 - x194*x76 - x196*x197 - x197*x198 - x199&
                  *x87 - x20*x43 - x20*x48 - x200*x39 - x200*x45 + x204*x69 +  &
                  x204*x74 - x206*x31 - x22*x43 - x22*x48 + x24*x43 + x24*x48  &
                   - x25*x29 - x25*x66 - x25*x67 + x25*x89 - x27*x29 - x27*x30 &
                   - x27*x5 - x27*x66 - x27*x67 - x27*x7 + x27*x89 - x27*x9
        wout(3) = P1(1)*P2(1)*w1(3)*x131 + P1(3)*x105*x40 + P2(3)*co(8)*x63 -  &
                  P2(3)*x106 - P2(3)*x107 + P2(3)*x158 + P2(3)*x65 + co(4)*x190&
                  *x25 - co(4)*x214 + co(8)*x102*x3 - co(8)*x214 + w1(3)*x126  &
                   - w1(3)*x40*x88 - x10*x212 + x100*x29 + x100*x66 + x100*x67 &
                   - x100*x89 + x102*x18 - x103*x11 + x103*x29 + x103*x30 +    &
                  x103*x5 + x103*x67 + x103*x68 + x103*x7 + x103*x9 - x104*x46 &
                   - x108*x140 + x113*x194 - x119*x133 - x119*x134 + x121*x192 &
                   + x121*x199 + x125*x164 + x130*x215 + x130*x216 - x130*x217 &
                   + x131*x215 + x131*x216 - x131*x217 - x137*x58 - x138*x58 + &
                  x144*x72 + x145*x72 + x146*x75 + x146*x77 + x147*x77 + x15*  &
                  x211 - x153*x35 - x153*x84 - x154*x201 - x155*x54 - x156*x183&
                   - x156*x54 - x156*x62 + x157*x72 + x157*x86 - x16*x208 - x16&
                  *x209 - x16*x212 - x161*x84 + x169*x196 + x170*x196 + x170*  &
                  x198 + x171*x202 + x171*x203 - x180*x32 - x181*x32 + x186*   &
                  x190 + x188*x77 - x191*x46 - x206*x56 - x206*x58 + x206*x59  &
                   + x207*x42 + x207*x47 + x208*x45 + x209*x45 + x210*x34 +    &
                  x210*x36 + x211*x3 + x212*x44 + x212*x45 + x212*x6 + x212*x8 &
                   - x213*x95 - x213*x97 - x218*x69 - x218*x74 + x43*x98 - x43*&
                  x99 + x48*x98 - x48*x99
      case(VVV3)
!       P(1,2)*P(2,3)*P(3,1)*c0
!       P(1,3)*P(2,1)*P(3,2)*c1
!       Metric(1,2)*P(-1,2)*P(-1,3)*P(3,1)*c2
!       Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3)*c3
!       Metric(2,3)*P(-1,1)*P(-1,3)*P(1,2)*c4
!       Metric(1,3)*P(-1,2)*P(-1,3)*P(2,1)*c5
!       Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3)*c6
!       Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2)*c7
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1)*c8
!       Epsilon(-1,-2,1,2)*P(-1,2)*P(-2,3)*P(3,1)*c9
!       Epsilon(-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2,3)*c10
!       Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2)*c11
!       Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2)*c12
!       Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2)*c13
!       Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,2)*P(1,3)*c14
!       Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3)*c15
!       Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*P(-2,3)*c16
        if (last) VB_last = .true.
        x0 = w1(2)*w2(3) - w1(3)*w2(2)
        x1 = w1(1)*w2(2) - w1(2)*w2(1)
        x2 = w1(1)*w2(3) - w1(3)*w2(1)
        x3 = P2(1)*x0 - P2(2)*x2 + P2(3)*x1
        x4 = P1(1)**2
        x5 = co(11)*x4
        x6 = P1(2)**2
        x7 = co(11)*x6
        x8 = P1(3)**2
        x9 = co(11)*x8
        x10 = P1(0)**2
        x11 = co(11)*x10
        x12 = P1(0)*P2(0)
        x13 = P1(1)*x0
        x14 = P1(3)*x1
        x15 = P1(2)*x2
        x16 = x13 + x14 - x15
        x17 = co(13)*x16
        x18 = co(13)*x3
        x19 = P1(0)*P2(0)*co(9)
        x20 = P1(0)*x2
        x21 = w1(0)*w2(1) - w1(1)*w2(0)
        x22 = P1(3)*x21
        x23 = w1(0)*w2(3) - w1(3)*w2(0)
        x24 = P1(1)*x23
        x25 = x20 + x22 - x24
        x26 = P2(2)*co(9)*x25
        x27 = P2(0)*x2 - P2(1)*x23 + P2(3)*x21
        x28 = P2(2)*co(9)*x27
        x29 = P2(0)**2
        x30 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x31 = P1(0)*co(2)*x30
        x32 = co(7)*x30
        x33 = P1(1)*P2(1)*co(11)
        x34 = P1(1)*P2(1)*co(16)
        x35 = P2(1)**2
        x36 = P2(2)**2
        x37 = P2(3)**2
        x38 = co(10)*(-x29 + x35 + x36 + x37)
        x39 = P1(1)*P2(1)
        x40 = P1(2)*P2(2)
        x41 = P1(3)*P2(3)
        x42 = co(10)*(-x12 + x39 + x40 + x41)
        x43 = P1(2)*w2(3) - P1(3)*w2(2)
        x44 = P2(2)*w1(2)
        x45 = P2(3)*w1(3)
        x46 = -P2(0)*w1(0) + P2(1)*w1(1) + x44 + x45
        x47 = P1(1)*co(12)*x46
        x48 = P2(2)*w2(3) - P2(3)*w2(2)
        x49 = P1(1)*w1(1)
        x50 = P1(2)*w1(2)
        x51 = P1(3)*w1(3)
        x52 = P1(0)*w1(0)
        x53 = x49 + x50 + x51 - x52
        x54 = co(14)*x48*x53
        x55 = co(14)*x48
        x56 = P1(1)*x46
        x57 = P2(3)*w1(2)
        x58 = P2(2)*w1(3) - x57
        x59 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x60 = P1(1)*co(15)*x59
        x61 = P2(1)*w2(1)
        x62 = -P2(0)*w2(0) + P2(2)*w2(2) + P2(3)*w2(3) + x61
        x63 = co(15)*x58*x62
        x64 = P1(2)*co(13)*x25
        x65 = P1(2)*co(13)*x27
        x66 = P1(2)*P2(2)*co(11)
        x67 = P1(2)*P2(2)*co(16)
        x68 = co(11)*x3
        x69 = P1(3)*P2(3)*co(16)
        x70 = P1(1)*w2(2) - P1(2)*w2(1)
        x71 = P1(3)*co(12)*x46
        x72 = P2(1)*w2(2) - P2(2)*w2(1)
        x73 = co(14)*x72
        x74 = P1(3)*x53
        x75 = P1(3)*x46
        x76 = P2(1)*w1(2)
        x77 = P2(2)*w1(1)
        x78 = x76 - x77
        x79 = P1(3)*co(15)*x59
        x80 = P1(3)*co(15)*x62
        x81 = P2(0)*x10*x30
        x82 = P1(2)*w1(3)
        x83 = -P1(3)*w1(2) + x82
        x84 = P2(1)*co(8)*x59
        x85 = P1(2)*w1(1)
        x86 = P1(1)*w1(2) - x85
        x87 = P2(3)*co(8)*x59
        x88 = co(1)*w1(0)*x59
        x89 = co(4)*x10*x46
        x90 = co(5)*x29*x59
        x91 = P1(0)*P2(0)*co(16)
        x92 = P1(0)*x0
        x93 = w1(0)*w2(2) - w1(2)*w2(0)
        x94 = P1(3)*x93
        x95 = P1(2)*x23
        x96 = x92 + x94 - x95
        x97 = P2(1)*co(9)*x96
        x98 = P2(0)*x0 - P2(2)*x23 + P2(3)*x93
        x99 = P2(1)*co(9)*x98
        x100 = P1(0)*x1
        x101 = P1(2)*x21
        x102 = P1(1)*x93
        x103 = x100 + x101 - x102
        x104 = P2(3)*co(9)*x103
        x105 = P2(0)*x1 - P2(1)*x93 + P2(2)*x21
        x106 = P2(3)*co(9)*x105
        x107 = P1(1)*P2(0)
        x108 = co(13)*x96
        x109 = co(13)*x98
        x110 = P1(1)*w2(3) - P1(3)*w2(1)
        x111 = P1(2)*co(12)*x46
        x112 = P2(1)*w2(3)
        x113 = -P2(3)*w2(1) + x112
        x114 = co(14)*x113*x53
        x115 = co(14)*x46
        x116 = P2(3)*w1(1)
        x117 = P2(1)*w1(3) - x116
        x118 = co(15)*x59
        x119 = co(15)*x117*x62
        x120 = P1(3)*co(13)*x103
        x121 = P1(3)*co(13)*x105
        x122 = P2(0)*co(7)*x30
        x123 = P1(1)*w1(3)
        x124 = P1(3)*w1(1)
        x125 = x123 - x124
        x126 = P2(2)*co(8)*x59
        x127 = co(4)*w2(0)*x46
        x128 = co(4)*x46*x8
        x129 = co(5)*x35*x59
        x130 = co(5)*x36*x59
        x131 = co(5)*x37*x59
        x132 = P1(0)*P2(0)*co(0)
        x133 = co(3)*x53
        x134 = P1(0)*P2(0)*w2(0)
        x135 = co(3)*x46
        x136 = co(5)*w1(0)*x59
        x137 = co(6)*w1(0)*x59
        x138 = co(6)*w1(0)*x62
        x139 = P1(0)*w1(1)
        x140 = P2(1)*co(0)*x59
        x141 = P2(1)*co(0)*x62
        x142 = P2(2)*co(0)*w1(2)*x59
        x143 = P2(2)*co(0)*w1(2)*x62
        x144 = P1(0)*w1(3)
        x145 = P2(3)*co(0)*x59
        x146 = P2(3)*co(0)*x62
        x147 = P1(1)*co(1)*w1(1)*x59
        x148 = P1(1)*P2(1)*w2(0)
        x149 = co(4)*x46
        x150 = P2(0)*co(1)*x59
        x151 = P1(2)*P2(2)*co(3)*x53
        x152 = P1(2)*P2(2)*co(3)*x46
        x153 = P2(3)*co(3)*w2(0)
        x154 = P2(0)*w1(1)
        x155 = P2(1)*co(1)*x59
        x156 = P1(0)*P2(1)*co(13)
        x157 = P1(0)*co(12)*x46
        x158 = P1(0)*x46
        x159 = P1(0)*co(15)*x59
        x160 = P1(1)*co(2)*x30
        x161 = co(11)*x98
        x162 = P1(0)*w2(2)
        x163 = -P1(2)*w2(0) + x162
        x164 = P2(0)*w2(2) - P2(2)*w2(0)
        x165 = P2(2)*w1(0)
        x166 = P2(0)*w1(2) - x165
        x167 = P2(0)*co(8)*x59
        x168 = P2(1)*co(7)*x30
        x169 = P1(0)*w1(2) - P1(2)*w1(0)
        x170 = co(4)*w2(1)*x46
        x171 = co(2)*x30
        x172 = P1(1)*x35
        x173 = P1(0)*w2(3)
        x174 = -P1(3)*w2(0) + x173
        x175 = P2(0)*w2(3) - P2(3)*w2(0)
        x176 = P1(2)*x175
        x177 = co(14)*x53
        x178 = P2(3)*w1(0)
        x179 = P2(0)*w1(3) - x178
        x180 = P1(2)*x179
        x181 = co(15)*x62
        x182 = P2(1)*x4
        x183 = -P1(3)*w1(0) + x144
        x184 = co(1)*x59
        x185 = w1(1)*x35
        x186 = co(5)*x59
        x187 = co(3)*w2(1)*x53
        x188 = co(3)*w2(1)*x46
        x189 = P1(0)*P2(0)*co(5)*x59
        x190 = P1(0)*P2(0)*co(6)*x59
        x191 = co(6)*w1(1)*x62
        x192 = P1(1)*P2(0)*w1(0)
        x193 = co(0)*x59
        x194 = co(0)*x62
        x195 = P2(1)*w1(0)
        x196 = P1(1)*P2(1)*w1(1)
        x197 = P1(1)*P2(1)*w2(1)
        x198 = P1(1)*co(3)*x46
        x199 = co(6)*x59
        x200 = co(6)*x62
        x201 = P1(2)*co(1)*x59
        x202 = P1(2)*P2(2)*co(6)*x59
        x203 = P1(3)*P2(3)*w1(1)
        x204 = P2(2)*co(1)*x59
        x205 = co(11)*x27
        x206 = P1(0)*P2(2)
        x207 = P1(1)*co(15)*x62
        x208 = P2(0)*co(9)*x16
        x209 = P2(0)*co(9)*x3
        x210 = P1(2)*P2(2)*x25
        x211 = P1(2)*P2(2)*x27
        x212 = P1(2)*co(2)*x30
        x213 = P2(2)*co(7)*x30
        x214 = co(5)*w1(2)*x59
        x215 = co(16)*x27
        x216 = P1(1)*co(13)*x96
        x217 = P1(1)*co(13)*x98
        x218 = co(12)*x46*(P1(0)*w2(1) - P1(1)*w2(0))
        x219 = P2(0)*w2(1) - P2(1)*w2(0)
        x220 = co(14)*x219
        x221 = x154 - x195
        x222 = P2(2)*x6
        x223 = -P1(1)*w1(0) + x139
        x224 = co(1)*w1(2)*x59
        x225 = co(4)*w2(2)*x46
        x226 = P1(0)*P2(0)*w2(2)
        x227 = P2(0)*co(4)*x46
        x228 = P1(0)*P2(0)*co(6)*x62
        x229 = P1(2)*P2(0)*w1(0)
        x230 = co(3)*w2(2)*x53
        x231 = P1(1)*P2(1)*w1(2)
        x232 = P1(2)*P2(2)*w1(2)
        x233 = P2(2)*co(1)*w1(3)*x59
        x234 = P1(3)*P2(3)*w2(2)
        x235 = P1(3)*P2(3)*w1(2)
        x236 = P1(0)*P2(3)
        x237 = co(11)*x105
        x238 = P1(2)*co(14)*x219
        x239 = P1(2)*x221
        x240 = P1(3)*co(2)*x30
        x241 = P2(3)*co(7)*x30
        x242 = co(4)*w2(3)*x46
        x243 = P1(1)*x164*x46
        x244 = P1(3)*P2(3)*co(13)
        x245 = P1(3)*P2(3)*co(9)
        x246 = P1(3)*x37
        x247 = w1(3)*x37
        x248 = P1(0)*P2(0)*w2(3)
        x249 = P1(3)*P2(0)*w1(0)
        x250 = P1(1)*P2(1)*w2(3)
        x251 = P1(1)*P2(1)*w1(3)
        x252 = P1(2)*P2(2)*w1(3)
        x253 = P1(3)*P2(3)*w1(3)
        x254 = P1(3)*P2(3)*w2(3)
        wout(0) = -P1(0)*x104 - P1(0)*x106 - P1(0)*x142 - P1(0)*x143 + P1(0)*  &
                  x26 + P1(0)*x28 + P1(0)*x29*x32 - P1(0)*x97 - P1(0)*x99 + P1(&
                  1)*x54 + P1(1)*x63 - P1(2)*x113*x115 - P1(2)*x114 - P1(2)*   &
                  x117*x118 - P1(2)*x119 - P1(3)*P2(3)*w2(0)*x149 - P2(0)*x120 &
                   - P2(0)*x121 - P2(0)*x147 + P2(0)*x64 + P2(0)*x65 + co(2)*  &
                  x81 + co(7)*x81 - w1(0)*x129 - w1(0)*x130 - w1(0)*x131 + w1(0&
                  )*x132*x59 + w1(0)*x132*x62 + w1(0)*x90 - w2(0)*x128 - w2(0)*&
                  x151 - w2(0)*x152 + w2(0)*x89 - x107*x108 - x107*x109 - x11* &
                  x3 - x110*x111 - x111*x113 - x117*x126 + x12*x127 + x12*x136 &
                   + x12*x137 + x12*x138 + x12*x17 + x12*x18 - x12*x68 + x12*  &
                  x88 - x122*x39 - x122*x4 - x122*x40 - x122*x41 - x122*x6 -   &
                  x122*x8 - x125*x126 - x127*x4 - x127*x40 - x127*x6 + x13*x38 &
                   + x13*x42 + x133*x134 - x133*x148 + x134*x135 - x135*x148 - &
                  x136*x39 - x136*x40 - x136*x41 - x137*x39 - x137*x40 - x137* &
                  x41 - x138*x39 - x138*x40 - x138*x41 - x139*x140 - x139*x141 &
                   + x14*x38 + x14*x42 - x144*x145 - x144*x146 - x148*x149 -   &
                  x15*x38 - x15*x42 - x150*x44 - x150*x45 - x150*x50 - x150*x51&
                   - x153*x74 - x153*x75 - x154*x155 + x16*x19 + x16*x34 + x16*&
                  x67 + x16*x69 - x16*x91 + x19*x3 + x29*x31 + x29*x88 + x3*x33&
                   + x3*x34 + x3*x5 + x3*x66 + x3*x67 + x3*x69 + x3*x7 + x3*x9 &
                   - x3*x91 - x31*x35 - x31*x36 - x31*x37 - x31*x39 - x31*x40  &
                   - x31*x41 + x41*x68 + x43*x47 + x47*x48 + x55*x56 + x58*x60 &
                   + x58*x84 + x70*x71 + x71*x72 + x73*x74 + x73*x75 + x78*x79 &
                   + x78*x80 + x78*x87 + x83*x84 + x86*x87
        wout(1) = P1(0)*x54 + P1(0)*x63 - P1(1)*x104 - P1(1)*x106 - P1(1)*x142 &
                   - P1(1)*x143 + P1(1)*x26 + P1(1)*x28 - P1(2)*P2(2)*w1(1)*   &
                  x186 + P1(3)*x115*x164 - P2(1)*x120 - P2(1)*x121 - P2(1)*x147&
                   + P2(1)*x64 + P2(1)*x65 - co(12)*x176*x46 + co(14)*x164*x74 &
                   + co(9)*x107*x16 + co(9)*x107*x3 - co(9)*x39*x96 - co(9)*x39&
                  *x98 - w1(1)*x130 - w1(1)*x131 + w1(1)*x189 + w1(1)*x190 - w1&
                  (1)*x202 + w1(1)*x90 - w2(1)*x152 + x10*x168 + x10*x170 -    &
                  x108*x39 - x109*x39 - x11*x98 - x111*x174 - x115*x176 - x118*&
                  x180 + x12*x160 - x12*x161 + x12*x168 + x12*x170 + x12*x187  &
                   + x12*x188 + x12*x191 - x123*x145 - x123*x146 - x126*x179 - &
                  x126*x183 - x133*x197 - x141*x49 - x149*x197 + x150*x195 -   &
                  x155*x45 - x155*x51 + x155*x52 + x156*x16 + x156*x3 + x157*  &
                  x43 + x157*x48 + x158*x55 + x159*x58 + x160*x29 - x160*x36 - &
                  x160*x37 - x160*x40 - x160*x41 + x161*x41 + x163*x71 + x164* &
                  x71 + x166*x79 + x166*x80 + x166*x87 + x167*x58 + x167*x83 - &
                  x168*x40 - x168*x41 - x168*x6 - x168*x8 + x169*x87 - x170*x4 &
                   - x170*x40 - x170*x41 - x170*x6 - x170*x8 - x171*x172 - x171&
                  *x182 - x172*x32 - x176*x177 - x180*x181 - x182*x32 - x184*  &
                  x185 - x185*x186 - x186*x196 - x186*x203 - x187*x40 - x187*  &
                  x41 - x188*x41 - x191*x40 + x192*x193 + x192*x194 - x193*x196&
                   - x196*x199 - x196*x200 - x198*x61 - x199*x203 - x200*x203  &
                   - x201*x76 - x204*x76 + x33*x98 + x34*x96 + x34*x98 + x38*  &
                  x92 + x38*x94 - x38*x95 + x42*x92 + x42*x94 - x42*x95 + x5*  &
                  x98 + x66*x98 + x67*x96 + x67*x98 + x69*x96 + x69*x98 + x7*  &
                  x98 + x9*x98 - x91*x96 - x91*x98
        wout(2) = -P1(0)*x114 - P1(0)*x119 - P1(1)*P2(1)*w2(2)*x135 + P1(1)*   &
                  x175*x177 - P1(2)*x104 - P1(2)*x106 + P1(2)*x208 + P1(2)*x209&
                   - P1(2)*x32*x36 - P1(2)*x97 - P1(2)*x99 - P1(3)*x218 - P1(3 &
                  )*x233 - P2(2)*x120 - P2(2)*x121 - P2(2)*x147 - P2(2)*x216 - &
                  P2(2)*x217 - P2(3)*x233 + co(13)*x210 + co(13)*x211 - co(14)*&
                  x113*x158 + co(14)*x175*x56 + co(9)*x210 + co(9)*x211 + w1(2 &
                  )*x190 - w1(2)*x202 + w1(2)*x228 - w2(2)*x128 - w2(2)*x152 + &
                  w2(2)*x89 + x10*x213 + x11*x27 - x110*x157 - x113*x157 - x117&
                  *x159 - x117*x167 + x12*x205 + x12*x212 + x12*x213 + x12*x214&
                   - x125*x167 + x133*x226 - x133*x234 + x135*x226 - x135*x234 &
                   - x140*x85 - x141*x85 - x145*x82 - x146*x82 - x149*x234 +   &
                  x150*x165 - x155*x77 + x162*x227 + x17*x206 - x171*x222 +    &
                  x174*x47 + x175*x47 + x179*x207 + x179*x60 + x179*x84 + x18* &
                  x206 + x183*x84 - x186*x231 - x186*x235 + x193*x229 - x193*  &
                  x232 + x194*x229 - x194*x232 - x199*x231 - x199*x235 - x20*  &
                  x38 - x20*x42 - x200*x231 - x200*x232 - x200*x235 + x204*x52 &
                   - x205*x41 + x212*x29 - x212*x35 - x212*x36 - x212*x37 -    &
                  x212*x39 - x212*x41 - x213*x39 - x213*x4 - x213*x41 - x213*x8&
                   + x214*x29 - x214*x35 - x214*x36 - x214*x37 - x214*x40 -    &
                  x215*x39 - x215*x40 - x215*x41 - x219*x71 - x22*x38 - x22*x42&
                   - x220*x74 - x220*x75 - x221*x79 - x221*x80 - x221*x87 -    &
                  x222*x32 - x223*x87 - x224*x36 - x224*x40 - x225*x39 - x225* &
                  x4 - x225*x40 - x225*x6 - x230*x39 - x230*x40 + x24*x38 + x24&
                  *x42 - x25*x34 - x25*x67 - x25*x69 + x25*x91 - x27*x33 - x27*&
                  x5 - x27*x66 - x27*x7 - x27*x9 + x27*x91
        wout(3) = P1(0)*P2(3)*w1(0)*x184 + P1(0)*x181*x78 + P1(0)*x53*x73 - P1(&
                  1)*x164*x177 + P1(2)*x218 - P1(3)*x142 - P1(3)*x143 + P1(3)* &
                  x208 + P1(3)*x209 + P1(3)*x26 + P1(3)*x28 - P1(3)*x97 - P1(3 &
                  )*x99 - P2(3)*x147 - P2(3)*x171*x8 - P2(3)*x216 - P2(3)*x217 &
                   + P2(3)*x64 + P2(3)*x65 - co(12)*x243 - co(14)*x243 - w1(3)*&
                  x129 - w1(3)*x130 + w1(3)*x189 + w1(3)*x190 + w1(3)*x228 + w1&
                  (3)*x90 - w2(3)*x151 - w2(3)*x152 + x10*x241 + x10*x242 +    &
                  x100*x38 + x100*x42 + x101*x38 + x101*x42 - x102*x38 - x102* &
                  x42 - x103*x244 - x103*x245 + x103*x34 + x103*x67 + x103*x69 &
                   - x103*x91 - x105*x11 - x105*x244 - x105*x245 + x105*x34 +  &
                  x105*x5 + x105*x67 + x105*x69 + x105*x7 + x105*x9 - x105*x91 &
                   + x111*x219 - x112*x198 - x116*x155 + x118*x239 - x12*x237  &
                   + x12*x240 + x12*x241 - x124*x140 - x124*x141 + x126*x221 + &
                  x126*x223 + x133*x248 - x133*x250 - x133*x254 + x135*x248 -  &
                  x135*x254 - x145*x51 - x149*x250 - x149*x254 + x150*x178 +   &
                  x157*x70 + x157*x72 + x158*x73 + x159*x78 - x163*x47 - x166* &
                  x207 - x166*x60 - x166*x84 + x167*x78 + x167*x86 - x169*x84  &
                   + x17*x236 - x171*x246 + x173*x227 + x18*x236 + x181*x239 - &
                  x184*x247 - x184*x253 - x186*x247 - x186*x251 - x186*x252 -  &
                  x186*x253 + x193*x249 + x194*x249 - x194*x253 - x199*x251 -  &
                  x199*x252 - x199*x253 - x200*x251 - x200*x252 - x200*x253 -  &
                  x201*x57 - x204*x57 + x237*x39 + x237*x40 + x237*x41 + x238* &
                  x46 + x238*x53 + x240*x29 - x240*x35 - x240*x36 - x240*x39 - &
                  x240*x40 - x241*x39 - x241*x4 - x241*x40 - x241*x6 - x241*x8 &
                   - x242*x4 - x242*x40 - x242*x6 - x242*x8 - x246*x32
      case(VVV4)
!       P(1,2)*P(2,3)*P(3,1)*c0
!       P(1,3)*P(2,1)*P(3,2)*c1
!       Metric(1,2)*P(-1,2)*P(-1,3)*P(3,1)*c2
!       Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3)*c3
!       Metric(2,3)*P(-1,1)*P(-1,3)*P(1,2)*c4
!       Metric(1,3)*P(-1,2)*P(-1,3)*P(2,1)*c5
!       Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3)*c6
!       Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2)*c7
!       -Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3)*c8
!       Epsilon(-1,-2,-3,3)*Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3)*c9
!       Epsilon(-1,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3)*c10
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1)*c11
!       Epsilon(-1,-2,1,2)*P(-1,2)*P(-2,3)*P(3,1)*c12
!       Epsilon(-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2,3)*c13
!       Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2)*c14
!       Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2)*c15
!       Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2)*c16
!       Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,2)*P(1,3)*c17
!       Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3)*c18
!       Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*P(-2,3)*c19
!       c20*(Metric(1,2)*P(3,1) - Metric(1,3)*P(2,1))
!       c21*(Metric(1,3)*P(2,3) - Metric(2,3)*P(1,3))
!       c22*(-Metric(1,2)*P(3,2) + Metric(2,3)*P(1,2))
!       c23*(Metric(1,2)*P(3,3) - Metric(2,3)*P(1,1))
!       Epsilon(-1,1,2,3)*P(-1,3)*c24
        if (last) VB_last = .true.
        x0 = w1(3)*w2(3)
        x1 = w1(0)*w2(0)
        x2 = w1(1)*w2(1) + w1(2)*w2(2) + x0 - x1
        x3 = co(23)*x2
        x4 = w1(1)*w2(3)
        x5 = w1(3)*w2(1)
        x6 = x4 - x5
        x7 = P1(2)*x6
        x8 = co(22)*x2
        x9 = P2(2)*x6
        x10 = P1(1)**2
        x11 = w1(2)*w2(3)
        x12 = w1(3)*w2(2)
        x13 = x11 - x12
        x14 = P2(1)*x13
        x15 = w1(1)*w2(2)
        x16 = w1(2)*w2(1)
        x17 = x15 - x16
        x18 = P2(3)*x17
        x19 = x14 + x18 - x9
        x20 = co(14)*x19
        x21 = P1(2)**2
        x22 = P1(3)**2
        x23 = co(20)*x2
        x24 = P1(1)*x13
        x25 = P1(3)*x17
        x26 = P1(0)**2
        x27 = P1(0)*P2(0)
        x28 = x24 + x25 - x7
        x29 = co(12)*x28
        x30 = co(12)*x19
        x31 = co(16)*x28
        x32 = co(16)*x19
        x33 = P1(0)*P2(2)
        x34 = P1(0)*x6
        x35 = w1(0)*w2(1)
        x36 = -w1(1)*w2(0) + x35
        x37 = P1(3)*x36
        x38 = w1(0)*w2(3)
        x39 = w1(3)*w2(0)
        x40 = x38 - x39
        x41 = P1(1)*x40
        x42 = x34 + x37 - x41
        x43 = co(12)*x42
        x44 = P2(0)*x6
        x45 = P2(3)*x36
        x46 = P2(1)*x40
        x47 = x44 + x45 - x46
        x48 = co(12)*x47
        x49 = P1(0)*w1(0)
        x50 = P1(2)*w2(3)
        x51 = P1(3)*w2(2)
        x52 = x50 - x51
        x53 = P1(1)*w2(2)
        x54 = P1(2)*w2(1)
        x55 = x53 - x54
        x56 = P1(1)*w2(3)
        x57 = P1(3)*w2(1)
        x58 = x56 - x57
        x59 = co(10)*(P2(1)*x52 - P2(2)*x58 + P2(3)*x55)
        x60 = P2(2)*w2(3) - P2(3)*w2(2)
        x61 = P2(1)*w2(2) - P2(2)*w2(1)
        x62 = P2(1)*w2(3)
        x63 = -P2(3)*w2(1) + x62
        x64 = co(10)*(P2(1)*x60 - P2(2)*x63 + P2(3)*x61)
        x65 = co(2)*x2
        x66 = P2(0)**2
        x67 = P1(0)*x66
        x68 = co(7)*x2
        x69 = P1(1)*P2(1)
        x70 = P1(1)*P2(1)*co(19)
        x71 = P2(1)**2
        x72 = P2(2)**2
        x73 = P2(3)**2
        x74 = co(13)*(-x66 + x71 + x72 + x73)
        x75 = P1(2)*P2(2)
        x76 = P1(3)*P2(3)
        x77 = co(13)*(-x27 + x69 + x75 + x76)
        x78 = P2(2)*w1(2)
        x79 = P2(3)*w1(3)
        x80 = -P2(0)*w1(0) + P2(1)*w1(1) + x78 + x79
        x81 = P1(1)*co(15)*x80
        x82 = P1(1)*w1(1)
        x83 = P1(2)*w1(2)
        x84 = P1(3)*w1(3)
        x85 = -x49 + x82 + x83 + x84
        x86 = P1(1)*co(17)
        x87 = P1(1)*co(17)*x80
        x88 = P2(2)*w1(3)
        x89 = P2(3)*w1(2)
        x90 = x88 - x89
        x91 = P1(1)*w2(1)
        x92 = P1(2)*w2(2)
        x93 = P1(3)*w2(3)
        x94 = P1(0)*w2(0)
        x95 = x91 + x92 + x93 - x94
        x96 = P1(1)*co(18)*x95
        x97 = P2(1)*w2(1)
        x98 = P2(0)*w2(0)
        x99 = P2(2)*w2(2) + P2(3)*w2(3) + x97 - x98
        x100 = co(18)*x90*x99
        x101 = P1(1)*co(20)
        x102 = P1(1)*co(21)
        x103 = P1(1)*w2(0)
        x104 = P1(2)*w1(3)
        x105 = P1(3)*w1(2)
        x106 = x104 - x105
        x107 = P2(0)*x106
        x108 = P1(0)*w1(2)
        x109 = P1(2)*w1(0)
        x110 = x108 - x109
        x111 = P2(3)*x110
        x112 = P1(0)*w1(3)
        x113 = P1(3)*w1(0)
        x114 = x112 - x113
        x115 = P2(2)*x114
        x116 = co(8)*(x107 + x111 - x115)
        x117 = P2(0)*x90
        x118 = P2(2)*w1(0)
        x119 = P2(0)*w1(2) - x118
        x120 = P2(3)*x119
        x121 = P2(3)*w1(0)
        x122 = P2(0)*w1(3) - x121
        x123 = P2(2)*x122
        x124 = co(8)*(x117 + x120 - x123)
        x125 = P1(2)*P2(0)
        x126 = co(16)*x42
        x127 = co(16)*x47
        x128 = P1(2)*P2(2)*co(19)
        x129 = P1(0)*w2(1)
        x130 = -x103 + x129
        x131 = P1(0)*w2(3)
        x132 = -P1(3)*w2(0) + x131
        x133 = co(10)*(P2(0)*x58 - P2(1)*x132 + P2(3)*x130)
        x134 = P2(1)*w2(0)
        x135 = P2(0)*w2(1) - x134
        x136 = P2(3)*w2(0)
        x137 = P2(0)*w2(3) - x136
        x138 = co(10)*(P2(0)*x63 - P2(1)*x137 + P2(3)*x135)
        x139 = P1(2)*w1(0)*w2(2)
        x140 = P1(2)*w2(0)
        x141 = P1(1)*P2(3)
        x142 = P1(3)*P2(1)
        x143 = x141 - x142
        x144 = P1(2)*co(9)*x2
        x145 = P1(3)*P2(3)*co(19)
        x146 = P1(3)*co(15)*x80
        x147 = P1(3)*co(17)
        x148 = co(17)*x61*x80
        x149 = P2(1)*w1(2)
        x150 = P2(2)*w1(1)
        x151 = x149 - x150
        x152 = P1(3)*co(18)*x95
        x153 = co(18)*x151*x99
        x154 = P1(3)*w1(0)*w2(3)
        x155 = P1(3)*co(23)*w1(3)
        x156 = P1(1)*w1(2)
        x157 = P1(2)*w1(1)
        x158 = x156 - x157
        x159 = P2(0)*x158
        x160 = P1(0)*w1(1)
        x161 = P1(1)*w1(0)
        x162 = x160 - x161
        x163 = P2(2)*x162
        x164 = P2(1)*x110
        x165 = x159 + x163 - x164
        x166 = P1(3)*co(8)*w2(0)
        x167 = P2(0)*x151
        x168 = P2(0)*w1(1)
        x169 = P2(1)*w1(0)
        x170 = x168 - x169
        x171 = P2(2)*x170
        x172 = P2(1)*x119
        x173 = x167 + x171 - x172
        x174 = P2(0)*x26
        x175 = P2(0)*co(22)
        x176 = P2(1)*x106
        x177 = co(11)*x95
        x178 = P2(1)*x90
        x179 = P2(1)*co(21)
        x180 = co(21)*w2(2)
        x181 = P2(3)*x158
        x182 = P2(3)*x151
        x183 = P2(3)*co(21)
        x184 = co(1)*w1(0)*x95
        x185 = co(4)*x26*x80
        x186 = co(5)*x66*x95
        x187 = P1(0)*P2(0)*co(19)
        x188 = P1(0)*P2(1)
        x189 = P1(0)*x13
        x190 = w1(0)*w2(2)
        x191 = -w1(2)*w2(0) + x190
        x192 = P1(3)*x191
        x193 = P1(2)*x40
        x194 = x189 + x192 - x193
        x195 = co(12)*x194
        x196 = P2(0)*x13
        x197 = P2(3)*x191
        x198 = P2(2)*x40
        x199 = x196 + x197 - x198
        x200 = co(12)*x199
        x201 = P1(0)*P2(3)
        x202 = P1(0)*x17
        x203 = P1(2)*x36
        x204 = P1(1)*x191
        x205 = x202 + x203 - x204
        x206 = co(12)*x205
        x207 = P2(0)*x17
        x208 = P2(2)*x36
        x209 = P2(1)*x191
        x210 = x207 + x208 - x209
        x211 = co(12)*x210
        x212 = co(2)*x2*x71
        x213 = co(2)*x2*x72
        x214 = P1(0)*co(2)*x2
        x215 = co(20)*w2(0)
        x216 = P1(0)*co(23)*w1(0)
        x217 = P1(1)*w1(3)
        x218 = P1(3)*w1(1)
        x219 = x217 - x218
        x220 = P2(2)*x219
        x221 = co(8)*(x176 + x181 - x220)
        x222 = P2(3)*w1(1)
        x223 = P2(1)*w1(3) - x222
        x224 = P2(2)*x223
        x225 = co(8)*(x178 + x182 - x224)
        x226 = P1(1)*P2(0)
        x227 = co(16)*x194
        x228 = co(16)*x199
        x229 = P1(0)*w2(2)
        x230 = -x140 + x229
        x231 = co(10)*(P2(0)*x52 - P2(2)*x132 + P2(3)*x230)
        x232 = P2(2)*w2(0)
        x233 = P2(0)*w2(2) - x232
        x234 = co(10)*(P2(0)*x60 - P2(2)*x137 + P2(3)*x233)
        x235 = co(21)*w1(1)
        x236 = P1(2)*P2(3)
        x237 = P1(3)*P2(2)
        x238 = co(9)*x2*(x236 - x237)
        x239 = co(15)*x58*x80
        x240 = P1(2)*co(15)*x80
        x241 = P1(2)*co(17)*x85
        x242 = P1(2)*co(17)*x80
        x243 = co(18)*x95
        x244 = co(18)*x223*x99
        x245 = co(21)*w1(2)
        x246 = P2(0)*x219
        x247 = P2(3)*x162
        x248 = P2(1)*x114
        x249 = co(8)*(x246 + x247 - x248)
        x250 = P2(0)*x223
        x251 = P2(3)*x170
        x252 = P2(1)*x122
        x253 = co(8)*(x250 + x251 - x252)
        x254 = P1(3)*P2(0)
        x255 = co(16)*x205
        x256 = co(16)*x210
        x257 = co(10)*(P2(0)*x55 - P2(1)*x230 + P2(2)*x130)
        x258 = co(10)*(P2(0)*x61 - P2(1)*x233 + P2(2)*x135)
        x259 = co(21)*w2(0)
        x260 = P1(1)*P2(2)
        x261 = P1(2)*P2(1)
        x262 = x260 - x261
        x263 = P1(3)*co(9)*x2
        x264 = co(7)*x10*x2
        x265 = P2(0)*co(7)*x2
        x266 = co(7)*x2*x22
        x267 = co(22)*w1(1)
        x268 = co(21)*w1(3)
        x269 = co(4)*w2(0)*x80
        x270 = co(4)*x22*x80
        x271 = co(5)*x71*x95
        x272 = co(5)*x72*x95
        x273 = co(5)*x73*x95
        x274 = w1(0)*x95
        x275 = P1(0)*P2(0)*co(0)
        x276 = w1(0)*x99
        x277 = P1(0)*P2(0)*co(3)*x85
        x278 = P1(0)*P2(0)*co(3)*x80
        x279 = co(5)*w1(0)*x95
        x280 = P1(0)*P2(0)*co(6)
        x281 = P1(3)*co(2)*x2
        x282 = co(0)*x95
        x283 = P1(0)*P2(1)*w1(1)
        x284 = co(0)*x99
        x285 = P1(0)*P2(2)*w1(2)
        x286 = P1(0)*P2(3)*w1(3)
        x287 = P2(0)*co(1)*w1(1)*x95
        x288 = P1(1)*P2(1)*w2(0)
        x289 = co(3)*x85
        x290 = co(3)*x80
        x291 = co(4)*x80
        x292 = P1(1)*P2(1)*co(6)
        x293 = co(1)*w1(2)*x95
        x294 = P1(2)*P2(2)*co(3)*x85
        x295 = P1(2)*P2(2)*co(3)*x80
        x296 = P1(2)*P2(2)*co(6)
        x297 = P2(3)*co(7)*x2
        x298 = P2(0)*co(1)*x95
        x299 = P1(3)*P2(3)*w2(0)
        x300 = co(5)*x95
        x301 = P1(3)*P2(3)*co(6)*w1(0)
        x302 = co(14)*x199
        x303 = P1(0)*co(15)*x80
        x304 = P1(0)*co(17)*x85
        x305 = P1(0)*co(17)*x80
        x306 = P1(0)*co(18)*x95
        x307 = co(21)*w2(1)
        x308 = co(19)*x194
        x309 = P1(1)*co(2)*x2
        x310 = P1(1)*w1(1)*w2(1)
        x311 = P1(2)*co(20)*w2(2)
        x312 = P1(2)*w1(2)*w2(1)
        x313 = x201 - x254
        x314 = x233*x85
        x315 = co(17)*x233*x80
        x316 = co(18)*x119*x99
        x317 = P1(3)*co(20)
        x318 = P1(3)*co(21)
        x319 = co(8)*x165
        x320 = co(8)*x173
        x321 = P2(0)*co(21)
        x322 = P2(1)*co(7)*x2
        x323 = P2(2)*co(21)
        x324 = co(4)*w2(1)*x80
        x325 = P1(0)*co(20)*w2(0)
        x326 = P1(1)*P2(3)*co(12)
        x327 = P1(1)*x71
        x328 = x137*x85
        x329 = co(18)*x122*x95
        x330 = co(18)*x122*x99
        x331 = -x125 + x33
        x332 = P2(2)*co(22)
        x333 = P2(3)*co(22)
        x334 = co(1)*x95
        x335 = w1(1)*x71
        x336 = P1(0)*P2(0)*w1(1)
        x337 = co(6)*x95
        x338 = co(6)*x99
        x339 = P2(1)*co(1)*x95
        x340 = P2(1)*co(0)*x95
        x341 = P2(1)*co(0)*x99
        x342 = P1(1)*P2(1)*w2(1)
        x343 = P1(1)*P2(1)*co(6)*w1(1)
        x344 = P1(1)*P2(2)*w1(2)
        x345 = P1(1)*P2(3)*w1(3)
        x346 = P1(2)*co(1)*x95
        x347 = P1(2)*P2(2)*co(6)*x95
        x348 = P1(3)*P2(3)*w2(1)
        x349 = P1(3)*P2(3)*w1(1)
        x350 = P2(2)*co(1)*x95
        x351 = co(14)*x47
        x352 = co(21)*w1(0)
        x353 = P1(0)*co(9)*x2
        x354 = P1(2)*co(2)*x2
        x355 = P1(2)*w1(2)*w2(2)
        x356 = P1(3)*co(23)
        x357 = co(9)*x2*(x188 - x226)
        x358 = P2(2)*co(7)*x2
        x359 = co(5)*w1(2)*x95
        x360 = co(23)*w1(0)
        x361 = co(19)*x47
        x362 = P1(1)*co(9)*x2
        x363 = P1(3)*x135
        x364 = P1(3)*x170
        x365 = co(18)*x99
        x366 = P2(2)*x21
        x367 = co(4)*w2(2)*x80
        x368 = P1(0)*P2(0)*w2(2)
        x369 = P2(0)*co(4)*x80
        x370 = P1(0)*P2(0)*w1(2)
        x371 = P2(0)*co(0)*x95
        x372 = P2(0)*co(0)*x99
        x373 = co(3)*w2(2)*x85
        x374 = P1(1)*P2(1)*w1(2)
        x375 = P1(2)*P2(2)*w1(2)
        x376 = P1(2)*P2(3)*w1(3)
        x377 = P2(2)*co(1)*w1(3)*x95
        x378 = P1(3)*P2(3)*w2(2)
        x379 = P1(3)*P2(3)*w1(2)
        x380 = co(14)*x210
        x381 = P1(2)*x170
        x382 = P1(2)*w1(2)*w2(3)
        x383 = co(4)*w2(3)*x80
        x384 = P1(3)*x73
        x385 = w1(3)*x73
        x386 = P1(0)*P2(0)*w2(3)
        x387 = P1(0)*P2(0)*w1(3)
        x388 = P2(3)*co(1)*x95
        x389 = P1(1)*P2(1)*w2(3)
        x390 = P1(1)*P2(1)*co(6)*w1(3)
        x391 = P1(2)*P2(2)*w1(3)
        x392 = P1(3)*P2(2)*w1(2)
        x393 = P1(3)*P2(3)*w1(3)
        x394 = P1(3)*P2(3)*w2(3)
        wout(0) = -P1(0)*x212 - P1(0)*x213 - P1(0)*x23 + P1(0)*x3 + P1(1)*x100 &
                   - P1(1)*x238 - P1(1)*x287 - P1(2)*x223*x243 - P1(2)*x239 -  &
                  P1(2)*x244 - P1(3)*P2(3)*w1(0)*x300 + P1(3)*x148 + P1(3)*x153&
                   - P2(0)*x264 - P2(0)*x266 + P2(0)*x3 + P2(0)*x8 - P2(1)*x287&
                   + co(20)*x139 + co(20)*x154 + co(21)*x139 + co(21)*x154 - co&
                  (22)*w1(2)*x232 - co(22)*w1(3)*x136 + co(23)*w1(1)*x103 + co(&
                  23)*w1(2)*x140 - co(24)*x14 - co(24)*x18 - co(24)*x24 - co(24&
                  )*x25 + co(24)*x7 + co(24)*x9 + w1(0)*x186 - w1(0)*x271 - w1(&
                  0)*x272 - w1(0)*x273 + w2(0)*x155 + w2(0)*x185 - w2(0)*x216  &
                   - w2(0)*x270 + w2(0)*x277 + w2(0)*x278 - w2(0)*x294 - w2(0)*&
                  x295 + x1*x175 + x10*x20 - x10*x269 + x101*x35 + x102*x35 +  &
                  x103*x116 + x103*x124 - x103*x235 + x109*x133 + x109*x138 -  &
                  x113*x257 - x113*x258 + x118*x180 + x125*x126 + x125*x127 -  &
                  x125*x293 + x128*x19 + x128*x28 - x134*x235 - x134*x267 -    &
                  x136*x268 - x140*x245 - x140*x249 - x140*x253 + x143*x144 +  &
                  x145*x19 + x145*x28 + x146*x55 + x146*x61 + x147*x61*x85 +   &
                  x151*x152 - x161*x231 - x161*x234 + x165*x166 + x166*x173 +  &
                  x174*x65 + x174*x68 + x176*x177 + x177*x178 + x177*x181 +    &
                  x177*x182 - x177*x220 - x177*x224 + x179*x35 + x183*x38 +    &
                  x184*x27 + x184*x66 - x187*x19 - x187*x28 - x188*x195 - x188*&
                  x200 + x19*x70 + x20*x21 + x20*x22 - x20*x26 - x20*x27 + x20*&
                  x69 + x20*x75 + x20*x76 - x201*x206 - x201*x211 - x201*x281  &
                   - x21*x265 - x21*x269 - x214*x69 - x214*x73 - x214*x75 -    &
                  x215*x49 - x221*x94 - x225*x94 - x226*x227 - x226*x228 - x232&
                  *x245 + x24*x74 + x24*x77 - x240*x63 - x241*x63 - x242*x63 + &
                  x25*x74 + x25*x77 - x254*x255 - x254*x256 - x254*x297 - x259*&
                  x84 - x262*x263 - x265*x69 - x265*x75 + x269*x27 - x269*x75  &
                   + x27*x279 + x27*x29 + x27*x30 + x27*x31 + x27*x32 + x274*  &
                  x275 + x274*x280 - x274*x292 - x274*x296 + x275*x276 + x276* &
                  x280 - x276*x292 - x276*x296 - x279*x69 - x279*x75 + x28*x70 &
                   - x282*x283 - x282*x285 - x282*x286 - x283*x284 - x284*x285 &
                   - x284*x286 - x288*x289 - x288*x290 - x288*x291 - x289*x299 &
                   - x290*x299 - x291*x299 - x298*x78 - x298*x79 - x298*x84 -  &
                  x301*x95 - x301*x99 + x33*x43 + x33*x48 + x49*x59 + x49*x64  &
                   + x52*x81 + x60*x81 + x60*x85*x86 + x60*x87 + x65*x67 + x67*&
                  x68 - x7*x74 - x7*x77 + x90*x96
        wout(1) = P1(0)*x100 - P1(0)*x238 + P1(1)*P2(0)*co(0)*x274 + P1(1)*P2(0&
                  )*w1(0)*x284 - P1(1)*P2(1)*w1(1)*x300 - P1(1)*x213 - P1(1)*  &
                  x23 + P1(1)*x3 - P1(2)*P2(2)*w1(1)*x300 - P1(2)*co(17)*x328  &
                   - P1(2)*x329 - P1(2)*x330 + P1(3)*x315 + P1(3)*x316 - P2(1)*&
                  x10*x65 - P2(1)*x264 + P2(1)*x3 + P2(1)*x8 + co(20)*x310 - co&
                  (21)*x312 + co(23)*x310 + co(23)*x312 - co(24)*x189 - co(24)*&
                  x192 + co(24)*x193 - co(24)*x196 - co(24)*x197 + co(24)*x198 &
                   + w1(1)*x186 - w1(1)*x272 - w1(1)*x273 - w1(1)*x296*x99 + w1&
                  (1)*x311 - w1(1)*x325 - w1(1)*x347 + w2(1)*x155 - w2(1)*x216 &
                   + w2(1)*x277 + w2(1)*x278 - w2(1)*x294 - w2(1)*x295 + x10*  &
                  x302 - x10*x324 + x107*x177 + x111*x177 - x115*x177 + x116*  &
                  x91 + x117*x177 + x119*x152 + x120*x177 - x123*x177 + x124*  &
                  x91 + x126*x261 + x127*x261 + x128*x199 - x129*x221 - x129*  &
                  x225 - x132*x240 + x133*x157 - x137*x240 - x137*x242 + x138* &
                  x157 - x142*x255 - x142*x256 - x142*x297 + x144*x313 + x145* &
                  x199 + x146*x230 + x146*x233 + x147*x314 - x149*x346 - x149* &
                  x350 + x15*x323 - x16*x323 - x16*x332 + x160*x59 + x160*x64  &
                   - x168*x259 + x169*x298 + x175*x35 + x183*x4 - x183*x5 -    &
                  x187*x199 + x188*x31 + x188*x32 + x189*x74 + x189*x77 + x192*&
                  x74 + x192*x77 - x193*x74 - x193*x77 - x195*x69 + x199*x70 - &
                  x200*x69 - x205*x326 + x21*x302 - x21*x322 - x21*x324 - x210*&
                  x326 - x218*x257 - x218*x258 + x22*x302 - x22*x322 - x22*x324&
                   + x226*x29 + x226*x30 - x227*x69 - x228*x69 - x231*x82 -    &
                  x234*x82 + x235*x92 - x235*x94 - x249*x54 - x253*x54 - x26*  &
                  x302 + x26*x322 + x26*x324 + x260*x43 + x260*x48 - x263*x331 &
                   - x267*x97 - x27*x302 - x27*x308 + x27*x309 + x27*x322 + x27&
                  *x324 - x282*x344 - x282*x345 - x284*x344 - x284*x345 - x289*&
                  x342 - x289*x348 - x290*x342 - x290*x348 - x291*x342 - x291* &
                  x348 - x300*x335 + x300*x336 - x300*x349 + x302*x69 + x302*  &
                  x75 + x302*x76 + x303*x52 + x303*x60 + x304*x60 + x305*x60 + &
                  x306*x90 + x307*x49 - x307*x84 + x308*x69 + x308*x75 + x308* &
                  x76 + x309*x66 - x309*x73 - x309*x75 - x309*x76 + x317*x4 +  &
                  x318*x4 + x319*x57 + x320*x57 + x321*x35 - x322*x75 - x324*  &
                  x75 - x327*x65 - x327*x68 - x333*x5 - x334*x335 + x336*x337  &
                   + x336*x338 - x337*x349 - x338*x349 + x339*x49 - x339*x79 - &
                  x339*x82 - x339*x84 - x340*x82 - x341*x82 - x343*x95 - x343* &
                  x99
        wout(2) = -P1(0)*x239 - P1(0)*x244 - P1(1)*P2(1)*w2(2)*x290 + P1(1)*   &
                  x329 + P1(1)*x330 - P1(2)*x213 - P1(2)*x23 + P1(2)*x3 - P1(2 &
                  )*x68*x72 + P1(3)*x357 - P1(3)*x377 - P2(1)*co(22)*x15 - P2(2&
                  )*x264 - P2(2)*x266 + P2(2)*x3 + P2(2)*x8 - P2(3)*x377 - co( &
                  15)*x363*x80 - co(17)*x363*x80 - co(17)*x363*x85 + co(20)*   &
                  x355 + co(21)*w2(3)*x89 - co(22)*w2(2)*x78 + co(23)*w2(2)*x82&
                   + co(23)*x355 + co(24)*x34 + co(24)*x37 - co(24)*x41 + co(24&
                  )*x44 + co(24)*x45 - co(24)*x46 - w1(2)*x325 - w1(2)*x347 +  &
                  w2(2)*x185 - w2(2)*x270 - w2(2)*x295 - x10*x351 - x10*x367 + &
                  x101*x16 + x102*x16 - x105*x257 - x105*x258 + x108*x59 + x108&
                  *x64 + x109*x371 + x109*x372 + x11*x317 + x11*x318 + x116*x53&
                   + x118*x298 - x12*x183 - x12*x318 - x12*x333 + x12*x356 +   &
                  x124*x53 + x125*x29 + x125*x30 + x126*x75 + x127*x75 - x128* &
                  x42 - x130*x146 + x132*x81 + x133*x83 + x137*x81 + x137*x87  &
                   + x138*x83 + x143*x353 - x145*x42 - x145*x47 + x149*x307 -  &
                  x15*x179 - x150*x339 - x156*x231 - x156*x234 - x157*x340 -   &
                  x157*x341 + x175*x190 - x177*x246 - x177*x247 + x177*x248 -  &
                  x177*x250 - x177*x251 + x177*x252 - x180*x82 + x187*x42 +    &
                  x187*x47 + x190*x321 - x195*x261 - x200*x261 - x206*x236 -   &
                  x21*x351 - x21*x367 - x211*x236 - x22*x351 - x221*x229 - x223&
                  *x306 - x225*x229 - x227*x260 - x228*x260 + x229*x352 - x229*&
                  x360 + x229*x369 - x236*x281 - x237*x255 - x237*x256 - x243* &
                  x364 - x245*x94 - x245*x98 - x249*x92 - x253*x92 + x26*x351  &
                   + x26*x358 + x27*x351 + x27*x354 + x27*x358 + x27*x359 -    &
                  x282*x375 - x282*x376 - x284*x375 - x284*x376 + x289*x368 -  &
                  x289*x378 + x290*x368 - x290*x378 - x291*x378 - x293*x72 -   &
                  x293*x75 - x300*x374 - x300*x379 - x303*x63 - x304*x63 - x305&
                  *x63 + x31*x33 - x313*x362 + x319*x51 + x32*x33 + x320*x51 + &
                  x328*x86 + x337*x370 - x337*x374 - x337*x379 + x338*x370 -   &
                  x338*x374 - x338*x375 - x338*x379 - x34*x74 - x34*x77 + x350*&
                  x49 - x350*x82 - x351*x69 - x351*x75 - x351*x76 + x354*x66 - &
                  x354*x69 - x354*x71 - x354*x73 - x358*x69 - x358*x76 + x359* &
                  x66 - x359*x71 - x359*x72 - x359*x73 - x359*x75 - x361*x69 - &
                  x361*x75 - x364*x365 - x366*x65 - x366*x68 - x367*x69 - x367*&
                  x75 - x37*x74 - x37*x77 - x373*x69 - x373*x75 + x41*x74 + x41&
                  *x77 - x42*x70 + x43*x75 + x48*x75
        wout(3) = P1(0)*x148 + P1(0)*x153 - P1(1)*P2(1)*w1(3)*x300 + P1(1)*co( &
                  23)*x4 - P1(1)*x315 - P1(1)*x316 - P1(2)*x357 - P1(3)*x212 - &
                  P1(3)*x213 - P1(3)*x23 + P1(3)*x3 - P2(3)*x22*x65 - P2(3)*   &
                  x264 + P2(3)*x3 + P2(3)*x8 - co(21)*x382 + co(23)*x382 - co( &
                  24)*x202 - co(24)*x203 + co(24)*x204 - co(24)*x207 - co(24)* &
                  x208 + co(24)*x209 + w1(3)*x186 - w1(3)*x271 - w1(3)*x272 +  &
                  w1(3)*x311 - w2(3)*x270 - w2(3)*x294 - w2(3)*x295 + x0*x317  &
                   - x0*x333 + x0*x356 + x10*x380 - x10*x383 + x101*x5 - x102* &
                  x4 + x102*x5 + x104*x133 + x104*x138 - x11*x323 - x11*x332 - &
                  x112*x215 - x112*x259 + x112*x59 + x112*x64 + x113*x371 +    &
                  x113*x372 + x116*x56 - x119*x96 + x121*x298 + x124*x56 + x126&
                  *x236 + x127*x236 + x128*x205 + x128*x210 + x130*x240 - x131*&
                  x221 - x131*x225 + x131*x352 - x131*x360 + x131*x369 + x135* &
                  x240 + x135*x241 + x135*x242 - x141*x227 - x141*x228 - x142* &
                  x195 - x142*x200 + x145*x205 + x145*x210 + x151*x306 + x159* &
                  x177 + x163*x177 - x164*x177 + x167*x177 + x171*x177 - x172* &
                  x177 + x175*x38 + x180*x88 - x187*x205 - x187*x210 + x201*x31&
                   + x201*x32 + x202*x74 + x202*x77 + x203*x74 + x203*x77 -    &
                  x204*x74 - x204*x77 + x205*x70 - x206*x76 - x21*x297 + x21*  &
                  x380 - x21*x383 + x210*x70 - x211*x76 - x217*x231 - x217*x234&
                   - x218*x340 - x218*x341 - x22*x297 + x22*x380 - x222*x339 - &
                  x230*x81 - x233*x81 - x235*x62 + x237*x43 + x237*x48 + x243* &
                  x381 - x249*x50 - x253*x50 + x254*x29 + x254*x30 - x255*x76  &
                   - x256*x76 - x257*x84 - x258*x84 + x26*x297 - x26*x380 + x26&
                  *x383 - x262*x353 - x267*x62 + x268*x92 + x268*x97 + x27*x281&
                   + x27*x297 - x27*x380 + x281*x66 - x281*x69 - x281*x75 -    &
                  x282*x392 - x282*x393 - x284*x392 - x284*x393 + x289*x386 -  &
                  x289*x389 - x289*x394 + x290*x386 - x290*x389 - x290*x394 -  &
                  x291*x389 - x291*x394 - x297*x69 - x297*x75 - x300*x385 +    &
                  x300*x387 - x300*x391 - x300*x393 + x303*x55 + x303*x61 +    &
                  x304*x61 - x314*x86 + x319*x93 + x320*x93 + x321*x38 - x321* &
                  x39 + x331*x362 - x334*x385 - x334*x393 + x337*x387 - x337*  &
                  x391 - x337*x393 + x338*x387 - x338*x391 - x338*x393 - x346* &
                  x89 - x350*x89 + x365*x381 + x380*x69 + x380*x75 + x380*x76  &
                   - x383*x75 - x384*x65 - x384*x68 + x388*x49 - x388*x82 -    &
                  x390*x95 - x390*x99
      case(VVV5)
!       P(1,2)*P(2,3)*P(3,1)*c0
!       P(1,3)*P(2,1)*P(3,2)*c1
!       c2*(-Metric(1,3)*P(-1,2)*P(-1,3)*P(2,1) - Metric(2,3)*P(-1,1)*P(-1,3)*P(1
!       ,2))
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1)*c3
!       Epsilon(-1,-2,1,2)*P(-1,2)*P(-2,3)*P(3,1)*c4
!       Epsilon(-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2,3)*c5
!       Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2)*c6
!       Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2)*c7
!       Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2)*c8
!       Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,2)*P(1,3)*c9
!       Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3)*c10
!       Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*P(-2,3)*c11
        if (last) VB_last = .true.
        x0 = w1(2)*w2(3) - w1(3)*w2(2)
        x1 = w1(1)*w2(2) - w1(2)*w2(1)
        x2 = w1(1)*w2(3) - w1(3)*w2(1)
        x3 = P2(1)*x0 - P2(2)*x2 + P2(3)*x1
        x4 = P1(1)**2
        x5 = co(6)*x4
        x6 = P1(2)**2
        x7 = co(6)*x6
        x8 = P1(3)**2
        x9 = co(6)*x8
        x10 = P1(0)**2
        x11 = co(6)*x10
        x12 = P1(1)*x0
        x13 = P1(3)*x1
        x14 = P1(2)*x2
        x15 = x12 + x13 - x14
        x16 = P1(0)*P2(0)
        x17 = P1(0)*P2(0)*x3
        x18 = co(8)*x15
        x19 = P1(0)*co(4)
        x20 = P1(0)*x2
        x21 = w1(0)*w2(1) - w1(1)*w2(0)
        x22 = P1(3)*x21
        x23 = w1(0)*w2(3) - w1(3)*w2(0)
        x24 = P1(1)*x23
        x25 = x20 + x22 - x24
        x26 = P2(2)*x25
        x27 = P2(0)*x2 - P2(1)*x23 + P2(3)*x21
        x28 = P2(2)*co(4)*x27
        x29 = P1(1)*P2(1)*co(11)
        x30 = P1(1)*P2(1)*co(6)
        x31 = P2(3)*w1(2)
        x32 = P2(2)*w1(3) - x31
        x33 = P1(3)*w2(3)
        x34 = P1(0)*w2(0)
        x35 = P1(1)*w2(1) + P1(2)*w2(2) + x33 - x34
        x36 = P1(1)*co(10)*x35
        x37 = P2(1)*w2(1)
        x38 = -P2(0)*w2(0) + P2(2)*w2(2) + P2(3)*w2(3) + x37
        x39 = co(10)*x32*x38
        x40 = P2(1)**2
        x41 = P2(2)**2
        x42 = P2(3)**2
        x43 = P2(0)**2
        x44 = x40 + x41 + x42 - x43
        x45 = co(5)*x44
        x46 = P1(1)*P2(1)
        x47 = P1(2)*P2(2)
        x48 = P1(3)*P2(3)
        x49 = -x16 + x46 + x47 + x48
        x50 = co(5)*x49
        x51 = P1(3)*w2(2)
        x52 = P1(2)*w2(3) - x51
        x53 = P2(2)*w1(2)
        x54 = P2(3)*w1(3)
        x55 = -P2(0)*w1(0) + P2(1)*w1(1) + x53 + x54
        x56 = P1(1)*co(7)*x55
        x57 = P2(2)*w2(3) - P2(3)*w2(2)
        x58 = P1(1)*w1(1)
        x59 = P1(2)*w1(2)
        x60 = P1(3)*w1(3)
        x61 = P1(0)*w1(0)
        x62 = x58 + x59 + x60 - x61
        x63 = co(9)*x57*x62
        x64 = P1(1)*co(9)*x55
        x65 = P1(2)*x25
        x66 = P2(0)*co(8)
        x67 = P1(2)*co(8)*x27
        x68 = P1(2)*P2(2)*co(11)
        x69 = P1(3)*P2(3)*co(11)
        x70 = P1(3)*P2(3)*co(6)
        x71 = P2(1)*w1(2)
        x72 = P2(2)*w1(1)
        x73 = x71 - x72
        x74 = P1(3)*co(10)*x35
        x75 = co(10)*x38*x73
        x76 = P1(1)*w2(2) - P1(2)*w2(1)
        x77 = P1(3)*co(7)*x55
        x78 = P2(1)*w2(2) - P2(2)*w2(1)
        x79 = P1(3)*co(9)*x62
        x80 = P1(3)*co(9)*x55
        x81 = P1(2)*w1(3)
        x82 = -P1(3)*w1(2) + x81
        x83 = P2(1)*co(3)*x35
        x84 = P1(1)*w1(2)
        x85 = P1(2)*w1(1)
        x86 = x84 - x85
        x87 = P2(3)*co(3)*x35
        x88 = co(1)*x35
        x89 = co(2)*w1(0)*x35
        x90 = co(2)*x4*x55
        x91 = co(2)*x55*x6
        x92 = co(2)*x55*x8
        x93 = P1(0)*P2(0)*co(11)
        x94 = P1(0)*x0
        x95 = w1(0)*w2(2) - w1(2)*w2(0)
        x96 = P1(3)*x95
        x97 = P1(2)*x23
        x98 = x94 + x96 - x97
        x99 = P2(1)*x98
        x100 = P2(0)*x0 - P2(2)*x23 + P2(3)*x95
        x101 = P2(1)*x100
        x102 = P1(2)*x21
        x103 = P1(1)*x95
        x104 = P1(0)*x1 + x102 - x103
        x105 = P2(3)*x104
        x106 = P1(0)*P2(3)
        x107 = P2(0)*x1 - P2(1)*x95 + P2(2)*x21
        x108 = co(4)*x107
        x109 = P1(1)*co(8)*x98
        x110 = P1(1)*co(8)*x100
        x111 = P2(3)*w1(1)
        x112 = P2(1)*w1(3) - x111
        x113 = P1(2)*co(10)*x35
        x114 = co(10)*x112*x38
        x115 = P1(1)*w2(3) - P1(3)*w2(1)
        x116 = P1(2)*co(7)*x55
        x117 = P2(1)*w2(3)
        x118 = -P2(3)*w2(1) + x117
        x119 = P1(2)*co(9)*x118
        x120 = P1(3)*x104
        x121 = P1(3)*co(8)*x107
        x122 = P1(1)*w1(3)
        x123 = P1(3)*w1(1)
        x124 = x122 - x123
        x125 = P2(2)*co(3)*x35
        x126 = co(2)*x10*x55
        x127 = co(0)*x35
        x128 = P1(0)*P2(0)*w1(0)
        x129 = co(0)*x38
        x130 = P2(0)*co(1)*x35
        x131 = co(2)*x55
        x132 = P1(2)*P2(2)*co(2)*x55
        x133 = co(2)*x35
        x134 = P2(0)*co(2)*x55
        x135 = P1(0)*w1(1)
        x136 = P2(1)*co(0)*x35
        x137 = P2(1)*co(0)*x38
        x138 = P1(0)*P2(2)*w1(2)
        x139 = P1(0)*w1(3)
        x140 = P2(3)*co(0)*x35
        x141 = P2(3)*co(0)*x38
        x142 = P2(0)*w1(1)
        x143 = P2(1)*co(1)*x35
        x144 = P1(0)*co(8)*x15
        x145 = P2(1)*co(8)
        x146 = P1(0)*x3
        x147 = P1(0)*co(10)*x35
        x148 = P1(0)*co(7)*x55
        x149 = P1(0)*co(9)*x55
        x150 = P1(1)*P2(0)*co(4)
        x151 = P1(1)*co(4)
        x152 = P1(2)*P2(2)*x100
        x153 = P2(0)*w1(2)
        x154 = P2(2)*w1(0)
        x155 = x153 - x154
        x156 = co(10)*x155*x38
        x157 = P1(0)*w2(2)
        x158 = -P1(2)*w2(0) + x157
        x159 = P2(0)*w2(2) - P2(2)*w2(0)
        x160 = P2(0)*co(3)*x35
        x161 = P1(2)*w1(0)
        x162 = P1(0)*w1(2) - x161
        x163 = co(2)*x35*x40
        x164 = co(2)*w1(1)*x35
        x165 = P1(1)*P2(1)*co(4)
        x166 = P1(1)*P2(1)*co(8)
        x167 = P2(3)*w1(0)
        x168 = P2(0)*w1(3) - x167
        x169 = co(10)*x168*x38
        x170 = P1(0)*w2(3)
        x171 = -P1(3)*w2(0) + x170
        x172 = P2(0)*w2(3) - P2(3)*w2(0)
        x173 = x172*x55
        x174 = P1(2)*co(9)*x62
        x175 = P1(2)*co(9)
        x176 = P1(3)*w1(0)
        x177 = x139 - x176
        x178 = P1(1)*P2(0)*w1(0)
        x179 = P2(1)*co(2)*x35
        x180 = P1(1)*co(2)*x55
        x181 = P2(1)*w1(0)
        x182 = P1(0)*co(2)*x35
        x183 = P1(1)*P2(2)*w1(2)
        x184 = P1(2)*co(1)*x35
        x185 = P2(2)*co(1)*x35
        x186 = co(6)*x27
        x187 = P1(1)*co(9)*x62
        x188 = P1(2)*P2(0)*co(4)
        x189 = P1(2)*P2(2)*x25
        x190 = co(4)*x27
        x191 = w1(2)*x41
        x192 = co(2)*w1(2)*x35
        x193 = P1(0)*x118
        x194 = co(9)*x62
        x195 = P1(2)*co(4)
        x196 = P1(3)*P2(2)
        x197 = co(8)*x107
        x198 = x142 - x181
        x199 = co(10)*x38
        x200 = P1(0)*w2(1) - P1(1)*w2(0)
        x201 = P2(0)*w2(1) - P2(1)*w2(0)
        x202 = x201*x55
        x203 = -P1(1)*w1(0) + x135
        x204 = co(2)*x35*x43
        x205 = P2(0)*co(0)*x35
        x206 = P2(0)*co(0)*x38
        x207 = P2(3)*co(2)*x55
        x208 = P1(2)*P2(2)*w1(2)
        x209 = P2(2)*co(1)*w1(3)*x35
        x210 = P1(0)*co(5)*x1
        x211 = co(11)*x107
        x212 = co(6)*x107
        x213 = P1(2)*x198
        x214 = P1(3)*P2(0)*co(4)
        x215 = co(2)*w1(3)*x35
        x216 = w1(3)*x42
        x217 = P1(3)*co(4)
        x218 = P1(3)*P2(3)*x104
        x219 = P2(3)*co(1)*x35
        x220 = P1(3)*P2(2)*w1(2)
        wout(0) = P1(0)*x28 + P1(1)*P2(1)*w2(0)*x131 + P1(1)*x39 + P1(1)*x63 - &
                  P1(2)*x114 + P1(3)*P2(3)*w2(0)*x131 + P1(3)*x75 - P2(0)*x109 &
                   - P2(0)*x110 - P2(0)*x121 + P2(0)*x67 - co(11)*x17 + co(4)* &
                  x15*x16 + co(4)*x17 - co(6)*x17 + co(6)*x3*x47 + co(8)*x17 + &
                  w1(0)*x43*x88 - w2(0)*x126 + w2(0)*x132 + w2(0)*x90 + w2(0)* &
                  x91 + w2(0)*x92 - x101*x19 - x105*x19 - x106*x108 - x11*x3 - &
                  x112*x113 - x112*x125 - x115*x116 - x116*x118 - x119*x55 -   &
                  x119*x62 + x12*x45 + x12*x50 - x120*x66 - x124*x125 + x127*  &
                  x128 - x127*x138 + x128*x129 - x128*x133 - x129*x138 + x13*  &
                  x45 + x13*x50 - x130*x53 - x130*x54 - x130*x58 - x130*x59 -  &
                  x130*x60 + x130*x61 - x134*x34 - x135*x136 - x135*x137 - x139&
                  *x140 - x139*x141 - x14*x45 - x14*x50 - x142*x143 + x15*x29  &
                   + x15*x68 + x15*x69 - x15*x93 + x16*x18 + x19*x26 - x19*x99 &
                   + x29*x3 + x3*x30 + x3*x5 + x3*x68 + x3*x69 + x3*x7 + x3*x70&
                   + x3*x9 + x32*x36 + x32*x83 + x40*x89 + x41*x89 + x42*x89 - &
                  x43*x89 + x46*x89 + x47*x89 + x48*x89 + x52*x56 + x56*x57 +  &
                  x57*x64 + x65*x66 + x73*x74 + x73*x87 + x76*x77 + x77*x78 +  &
                  x78*x79 + x78*x80 + x82*x83 + x86*x87
        wout(1) = -P1(0)*P2(0)*w2(1)*x131 + P1(0)*x39 + P1(0)*x63 - P1(1)*P2(3 &
                  )*x108 + P1(1)*x28 - P1(2)*co(7)*x173 + P1(2)*x145*x27 - P1(2&
                  )*x169 + P1(3)*P2(3)*w2(1)*x131 + P1(3)*x156 - P2(1)*x121 +  &
                  P2(1)*x144 + co(11)*x152 - co(6)*x100*x16 + co(6)*x152 + w1(1&
                  )*x163 - w1(1)*x40*x88 - w2(1)*x126 + w2(1)*x132 + w2(1)*x90 &
                   + w2(1)*x91 + w2(1)*x92 - x100*x11 - x100*x165 - x100*x166  &
                   + x100*x29 + x100*x30 + x100*x5 + x100*x69 + x100*x7 + x100*&
                  x70 + x100*x9 - x100*x93 - x105*x151 - x113*x168 - x116*x171 &
                   - x120*x145 - x122*x140 - x122*x141 - x125*x168 - x125*x177 &
                   + x127*x178 - x127*x183 + x129*x178 - x129*x183 + x130*x181 &
                   - x136*x58 - x137*x58 - x142*x182 - x143*x54 - x143*x58 -   &
                  x143*x60 + x143*x61 + x145*x146 + x145*x65 + x147*x32 + x148*&
                  x52 + x148*x57 + x149*x57 + x15*x150 + x150*x3 + x151*x26 +  &
                  x155*x74 + x155*x87 + x158*x77 + x159*x77 + x159*x79 + x159* &
                  x80 + x160*x32 + x160*x82 + x162*x87 + x164*x41 + x164*x42 - &
                  x164*x43 + x164*x47 + x164*x48 - x165*x98 - x166*x98 - x172* &
                  x174 - x173*x175 + x179*x58 + x180*x37 - x184*x71 - x185*x71 &
                   + x29*x98 + x45*x94 + x45*x96 - x45*x97 + x50*x94 + x50*x96 &
                   - x50*x97 + x68*x98 + x69*x98 - x93*x98
        wout(2) = -P1(0)*x114 + P1(1)*P2(1)*w2(2)*x131 + P1(1)*co(7)*x173 + P1(&
                  1)*co(9)*x173 + P1(1)*x169 + P1(3)*P2(3)*w1(2)*x133 - P1(3)* &
                  co(9)*x202 - P1(3)*x198*x199 - P1(3)*x209 + P2(2)*co(8)*x146 &
                   - P2(2)*x109 - P2(2)*x110 + P2(2)*x144 - P2(3)*x107*x195 -  &
                  P2(3)*x209 + co(4)*x189 - co(7)*x193*x55 - co(8)*x104*x196 + &
                  co(8)*x189 + co(8)*x27*x47 + w1(2)*x163 - w1(2)*x204 - w2(2)*&
                  x126 + w2(2)*x132 + w2(2)*x90 + w2(2)*x91 + w2(2)*x92 - x101*&
                  x195 - x105*x195 + x11*x27 - x112*x147 - x112*x160 - x115*   &
                  x148 - x118*x149 - x124*x160 - x127*x208 - x129*x208 + x130* &
                  x154 + x133*x191 - x134*x157 - x136*x85 - x137*x85 - x140*x81&
                   - x141*x81 - x143*x72 + x15*x188 - x153*x182 + x16*x186 +   &
                  x161*x205 + x161*x206 + x168*x36 + x168*x83 + x171*x56 + x172&
                  *x187 + x177*x83 + x179*x84 - x185*x58 + x185*x61 - x186*x47 &
                   - x186*x48 + x188*x3 + x190*x47 - x191*x88 + x192*x42 + x192&
                  *x47 - x193*x194 - x195*x99 - x196*x197 - x198*x74 - x198*x87&
                   - x20*x45 - x20*x50 - x200*x77 - x201*x77 - x201*x79 - x203*&
                  x87 + x207*x51 - x208*x88 - x22*x45 - x22*x50 + x24*x45 + x24&
                  *x50 - x25*x29 - x25*x68 - x25*x69 + x25*x93 - x27*x29 - x27*&
                  x30 - x27*x5 - x27*x68 - x27*x69 - x27*x7 - x27*x9 + x27*x93
        wout(3) = -P1(0)*P2(0)*w1(3)*x133 + P1(0)*x194*x78 + P1(0)*x75 - P1(1)*&
                  x156 + P1(2)*P2(2)*w1(3)*x133 + P1(3)*P2(3)*w1(3)*x133 + P2(3&
                  )*co(8)*x65 - P2(3)*x109 - P2(3)*x110 + P2(3)*x67 + co(10)*  &
                  x213*x35 + co(4)*x196*x25 - co(4)*x218 + co(8)*x106*x3 - co(8&
                  )*x218 + w1(3)*x163 - w1(3)*x204 - w2(3)*x126 + w2(3)*x132 + &
                  w2(3)*x90 + w2(3)*x91 + w2(3)*x92 - x101*x217 + x102*x45 +   &
                  x102*x50 - x103*x45 - x103*x50 + x104*x29 + x104*x68 + x104* &
                  x69 - x104*x93 + x106*x18 - x107*x11 + x107*x29 + x107*x30 + &
                  x107*x5 + x107*x69 + x107*x7 + x107*x70 + x107*x9 - x108*x48 &
                   - x111*x143 + x116*x200 + x116*x201 + x117*x180 - x123*x136 &
                   - x123*x137 + x125*x198 + x125*x203 - x127*x220 - x129*x220 &
                   + x130*x167 + x133*x216 - x134*x170 - x140*x60 - x141*x60 + &
                  x147*x73 + x148*x76 + x148*x78 + x149*x78 + x15*x214 - x155* &
                  x36 - x155*x83 - x158*x56 - x159*x187 - x159*x56 - x159*x64  &
                   - x16*x211 - x16*x212 + x160*x73 + x160*x86 - x162*x83 +    &
                  x174*x201 + x175*x202 + x176*x205 + x176*x206 - x184*x31 -   &
                  x185*x31 + x190*x196 - x197*x48 + x199*x213 + x207*x33 + x210&
                  *x44 + x210*x49 + x211*x47 + x212*x47 + x214*x3 + x215*x41 + &
                  x215*x46 - x216*x88 - x217*x99 - x219*x58 - x219*x60 + x219* &
                  x61
      case(VVV6)
!       P(1,2)*P(2,3)*P(3,1)*c0
!       P(1,3)*P(2,1)*P(3,2)*c1
!       c2*(-Metric(1,3)*P(-1,2)*P(-1,3)*P(2,1) - Metric(2,3)*P(-1,1)*P(-1,3)*P(1
!       ,2))
!       -Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3)*c3
!       Epsilon(-1,-2,-3,3)*Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3)*c4
!       Epsilon(-1,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3)*c5
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1)*c6
!       Epsilon(-1,-2,1,2)*P(-1,2)*P(-2,3)*P(3,1)*c7
!       Epsilon(-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2,3)*c8
!       Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2)*c9
!       Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2)*c10
!       Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2)*c11
!       Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,2)*P(1,3)*c12
!       Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3)*c13
!       Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*P(-2,3)*c14
        if (last) VB_last = .true.
        x0 = P1(1)**2
        x1 = w1(2)*w2(3) - w1(3)*w2(2)
        x2 = w1(1)*w2(2) - w1(2)*w2(1)
        x3 = w1(1)*w2(3) - w1(3)*w2(1)
        x4 = P2(1)*x1 - P2(2)*x3 + P2(3)*x2
        x5 = co(9)*x4
        x6 = P1(2)**2
        x7 = P1(3)**2
        x8 = co(9)*x7
        x9 = P1(0)**2
        x10 = P1(0)*P2(0)
        x11 = P1(1)*x1
        x12 = P1(3)*x2
        x13 = P1(2)*x3
        x14 = x11 + x12 - x13
        x15 = co(11)*x14
        x16 = co(11)*x4
        x17 = co(7)*x14
        x18 = co(7)*x4
        x19 = P1(0)*P2(2)
        x20 = P1(0)*x3
        x21 = w1(0)*w2(1) - w1(1)*w2(0)
        x22 = P1(3)*x21
        x23 = w1(0)*w2(3) - w1(3)*w2(0)
        x24 = P1(1)*x23
        x25 = x20 + x22 - x24
        x26 = co(7)*x25
        x27 = P2(0)*x3 - P2(1)*x23 + P2(3)*x21
        x28 = co(7)*x27
        x29 = P1(0)*w1(0)
        x30 = P1(2)*w2(3)
        x31 = P1(3)*w2(2)
        x32 = x30 - x31
        x33 = P1(1)*w2(2)
        x34 = P1(2)*w2(1)
        x35 = x33 - x34
        x36 = P1(1)*w2(3)
        x37 = P1(3)*w2(1)
        x38 = x36 - x37
        x39 = co(5)*(P2(1)*x32 - P2(2)*x38 + P2(3)*x35)
        x40 = P2(2)*w2(3) - P2(3)*w2(2)
        x41 = P2(1)*w2(2) - P2(2)*w2(1)
        x42 = P2(1)*w2(3) - P2(3)*w2(1)
        x43 = co(5)*(P2(1)*x40 - P2(2)*x42 + P2(3)*x41)
        x44 = P1(1)*P2(1)*co(14)
        x45 = P1(1)*P2(1)
        x46 = P2(2)*w1(2)
        x47 = P2(3)*w1(3)
        x48 = -P2(0)*w1(0) + P2(1)*w1(1) + x46 + x47
        x49 = P1(1)*co(10)*x48
        x50 = P1(1)*w1(1)
        x51 = P1(2)*w1(2)
        x52 = P1(3)*w1(3)
        x53 = -x29 + x50 + x51 + x52
        x54 = P1(1)*co(12)*x53
        x55 = P1(1)*co(12)*x48
        x56 = P2(2)*w1(3) - P2(3)*w1(2)
        x57 = P1(1)*w2(1)
        x58 = P1(2)*w2(2)
        x59 = P1(3)*w2(3)
        x60 = -P1(0)*w2(0) + x57 + x58 + x59
        x61 = co(13)*x56*x60
        x62 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x63 = P1(1)*co(13)*x62
        x64 = P1(1)*w2(0)
        x65 = P1(3)*w1(2)
        x66 = P1(2)*w1(3) - x65
        x67 = P2(0)*x66
        x68 = P1(0)*w1(2)
        x69 = P1(2)*w1(0)
        x70 = x68 - x69
        x71 = P2(3)*x70
        x72 = P1(0)*w1(3)
        x73 = P1(3)*w1(0)
        x74 = x72 - x73
        x75 = P2(2)*x74
        x76 = co(3)*(x67 + x71 - x75)
        x77 = P2(0)*x56
        x78 = P2(2)*w1(0)
        x79 = P2(0)*w1(2) - x78
        x80 = P2(3)*x79
        x81 = P2(3)*w1(0)
        x82 = P2(0)*w1(3) - x81
        x83 = P2(2)*x82
        x84 = co(3)*(x77 + x80 - x83)
        x85 = P2(1)**2
        x86 = P2(2)**2
        x87 = P2(3)**2
        x88 = P2(0)**2
        x89 = co(8)*(x85 + x86 + x87 - x88)
        x90 = P1(2)*P2(2)
        x91 = P1(3)*P2(3)
        x92 = co(8)*(-x10 + x45 + x90 + x91)
        x93 = P1(2)*P2(0)
        x94 = co(11)*x25
        x95 = co(11)*x27
        x96 = P1(2)*P2(2)*co(14)
        x97 = P1(1)*P2(3)
        x98 = P1(3)*P2(1)
        x99 = x97 - x98
        x100 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x101 = P1(2)*co(4)*x100
        x102 = P1(0)*w2(1)
        x103 = x102 - x64
        x104 = P1(0)*w2(3)
        x105 = P1(3)*w2(0)
        x106 = x104 - x105
        x107 = P2(0)*x38 - P2(1)*x106 + P2(3)*x103
        x108 = co(5)*x107
        x109 = P2(0)*w2(1) - P2(1)*w2(0)
        x110 = P2(0)*w2(3) - P2(3)*w2(0)
        x111 = P2(0)*x42 - P2(1)*x110 + P2(3)*x109
        x112 = co(5)*x111
        x113 = P1(3)*P2(3)*co(14)
        x114 = P1(3)*co(10)*x48
        x115 = P1(3)*co(12)*x41
        x116 = P2(2)*w1(1)
        x117 = P2(1)*w1(2) - x116
        x118 = P1(3)*co(13)*x117
        x119 = P1(1)*w1(2)
        x120 = P1(2)*w1(1)
        x121 = x119 - x120
        x122 = P2(0)*x121
        x123 = P1(0)*w1(1)
        x124 = P1(1)*w1(0)
        x125 = x123 - x124
        x126 = P2(2)*x125
        x127 = P2(1)*x70
        x128 = co(3)*(x122 + x126 - x127)
        x129 = P2(0)*x117
        x130 = P2(0)*w1(1)
        x131 = P2(1)*w1(0)
        x132 = x130 - x131
        x133 = P2(2)*x132
        x134 = P2(1)*x79
        x135 = co(3)*(x129 + x133 - x134)
        x136 = P2(1)*x66
        x137 = co(6)*x60
        x138 = P2(1)*x56
        x139 = P2(3)*x121
        x140 = P2(3)*x117
        x141 = co(1)*w1(0)*x60
        x142 = co(2)*w1(0)*x60
        x143 = co(2)*w2(0)*x48
        x144 = P1(0)*P2(0)*co(14)
        x145 = P1(0)*P2(1)
        x146 = P1(0)*x1
        x147 = w1(0)*w2(2) - w1(2)*w2(0)
        x148 = P1(3)*x147
        x149 = P1(2)*x23
        x150 = x146 + x148 - x149
        x151 = co(7)*x150
        x152 = P2(0)*x1 - P2(2)*x23 + P2(3)*x147
        x153 = co(7)*x152
        x154 = P1(0)*P2(3)
        x155 = P1(0)*x2
        x156 = P1(2)*x21
        x157 = P1(1)*x147
        x158 = x155 + x156 - x157
        x159 = co(7)*x158
        x160 = P2(0)*x2 - P2(1)*x147 + P2(2)*x21
        x161 = co(7)*x160
        x162 = P1(1)*w1(3)
        x163 = P1(3)*w1(1)
        x164 = x162 - x163
        x165 = P2(2)*x164
        x166 = x136 + x139 - x165
        x167 = P1(0)*co(3)*w2(0)
        x168 = P2(3)*w1(1)
        x169 = P2(1)*w1(3) - x168
        x170 = P2(2)*x169
        x171 = x138 + x140 - x170
        x172 = P1(1)*P2(0)
        x173 = co(11)*x150
        x174 = co(11)*x152
        x175 = P1(2)*P2(3)
        x176 = P1(3)*P2(2)
        x177 = x175 - x176
        x178 = P1(1)*co(4)*x100
        x179 = P1(0)*w2(2)
        x180 = P1(2)*w2(0)
        x181 = x179 - x180
        x182 = co(5)*(P2(0)*x32 - P2(2)*x106 + P2(3)*x181)
        x183 = P2(0)*w2(2) - P2(2)*w2(0)
        x184 = co(5)*(P2(0)*x40 - P2(2)*x110 + P2(3)*x183)
        x185 = P1(2)*co(10)*x48
        x186 = P1(2)*co(12)*x42
        x187 = P1(2)*co(13)*x60
        x188 = P1(2)*co(13)*x62
        x189 = P2(0)*x164
        x190 = P2(3)*x125
        x191 = P2(1)*x74
        x192 = co(3)*(x189 + x190 - x191)
        x193 = P2(0)*x169
        x194 = P2(3)*x132
        x195 = P2(1)*x82
        x196 = co(3)*(x193 + x194 - x195)
        x197 = P1(3)*P2(0)
        x198 = co(11)*x158
        x199 = co(11)*x160
        x200 = P1(1)*P2(2)
        x201 = P1(2)*P2(1)
        x202 = x200 - x201
        x203 = P1(3)*co(4)*x100
        x204 = co(5)*(P2(0)*x35 - P2(1)*x181 + P2(2)*x103)
        x205 = co(5)*(P2(0)*x41 - P2(1)*x183 + P2(2)*x109)
        x206 = co(0)*x60
        x207 = P1(0)*P2(0)*w1(0)
        x208 = co(0)*x62
        x209 = co(2)*x48
        x210 = co(2)*x60
        x211 = P2(3)*co(2)*x48
        x212 = co(0)*w1(1)*x62
        x213 = P2(2)*co(0)*w1(2)*x60
        x214 = P2(2)*co(0)*w1(2)*x62
        x215 = P2(3)*co(0)*x60
        x216 = P2(3)*co(0)*x62
        x217 = P2(0)*co(1)*x60
        x218 = co(1)*w1(2)*x60
        x219 = co(1)*x60
        x220 = P2(1)*co(1)*x60
        x221 = co(9)*x152
        x222 = P1(0)*co(10)*x48
        x223 = P1(0)*co(12)*x53
        x224 = P1(0)*co(12)*x48
        x225 = co(13)*x62
        x226 = P1(1)*P2(1)*x150
        x227 = co(4)*x100*(x154 - x197)
        x228 = P1(3)*co(12)*x183
        x229 = co(13)*x60*x79
        x230 = P1(3)*co(13)*x62
        x231 = w1(1)*x85
        x232 = co(2)*w1(1)*x60
        x233 = co(2)*w2(1)*x48
        x234 = co(3)*x166
        x235 = co(3)*x171
        x236 = P1(0)*co(4)*x100
        x237 = P1(2)*co(12)*x110
        x238 = x19 - x93
        x239 = co(0)*w1(0)*x60
        x240 = co(0)*w1(0)*x62
        x241 = P1(1)*P2(1)*w1(1)
        x242 = P2(1)*co(1)*w1(2)*x60
        x243 = co(9)*x27
        x244 = co(14)*x25
        x245 = co(13)*x60
        x246 = P1(1)*x82
        x247 = x145 - x172
        x248 = co(2)*w1(2)*x60
        x249 = w1(2)*x86
        x250 = co(2)*w2(2)*x48
        x251 = P1(0)*x169
        x252 = P1(3)*co(12)*x109
        x253 = co(13)*x132*x60
        x254 = P1(0)*co(1)*w1(0)*x60
        x255 = P1(2)*P2(0)*w1(0)
        x256 = P1(2)*P2(2)*w1(2)
        x257 = P2(0)*co(2)*x48
        x258 = P1(1)*co(1)*w1(1)*x60
        x259 = P1(2)*P2(1)*w1(1)
        x260 = P1(2)*P2(3)*w1(3)
        x261 = P2(2)*co(1)*w1(3)*x60
        x262 = co(9)*x160
        x263 = P1(0)*x117
        x264 = P1(2)*co(12)*x109
        x265 = P1(2)*co(5)*w1(3)
        x266 = co(2)*w1(3)*x60
        x267 = w1(3)*x87
        x268 = co(2)*w2(3)*x48
        x269 = P1(3)*P2(3)*w1(3)
        x270 = P1(3)*P2(1)*w1(1)
        wout(0) = -P1(0)*P2(1)*w1(1)*x206 - P1(0)*x213 - P1(0)*x214 + P1(1)*P2(&
                  1)*w2(0)*x209 + P1(1)*x61 + P1(2)*P2(2)*w1(0)*x210 - P1(3)*P2&
                  (0)*w1(3)*x219 + x0*x143 + x0*x5 + x10*x141 - x10*x142 - x10*&
                  x143 + x10*x15 + x10*x16 + x10*x17 + x10*x18 - x10*x5 + x101*&
                  x99 + x105*x128 + x105*x135 + x105*x211 + x108*x69 + x11*x89 &
                   + x11*x92 + x112*x69 + x113*x14 + x113*x4 + x114*x35 + x114*&
                  x41 + x115*x48 + x115*x53 + x118*x60 + x118*x62 + x12*x89 +  &
                  x12*x92 - x124*x182 - x124*x184 - x13*x89 - x13*x92 - x130*  &
                  x220 + x136*x137 + x137*x138 + x137*x139 + x137*x140 - x137* &
                  x165 - x137*x170 - x14*x144 + x14*x44 + x14*x96 + x141*x88 + &
                  x142*x45 + x142*x85 + x142*x86 + x142*x87 - x142*x88 + x142* &
                  x91 + x143*x6 + x143*x7 - x143*x9 + x143*x90 - x144*x4 - x145&
                  *x151 - x145*x153 - x145*x212 - x154*x159 - x154*x161 - x166*&
                  x167 - x167*x171 - x169*x187 - x169*x188 - x172*x173 - x172* &
                  x174 - x177*x178 - x180*x192 - x180*x196 - x185*x38 - x185*  &
                  x42 - x186*x48 - x186*x53 + x19*x26 + x19*x28 - x197*x198 -  &
                  x197*x199 - x202*x203 - x204*x73 - x205*x73 + x206*x207 +    &
                  x207*x208 - x215*x72 - x216*x72 - x217*x46 - x217*x47 - x217*&
                  x50 - x218*x93 + x29*x39 + x29*x43 + x32*x49 + x4*x44 + x4*x8&
                   + x4*x96 + x40*x49 + x40*x54 + x40*x55 + x45*x5 + x5*x6 - x5&
                  *x9 + x5*x90 + x5*x91 + x56*x63 + x64*x76 + x64*x84 + x93*x94&
                   + x93*x95
        wout(1) = P1(0)*x225*x56 + P1(0)*x61 - P1(1)*x213 - P1(1)*x214 + P1(2)*&
                  x227 - P1(2)*x242 + P1(3)*P2(3)*w2(1)*x209 + P1(3)*x229 - P2(&
                  2)*x242 - co(11)*x226 + co(14)*x226 - co(7)*x226 + x0*x221 + &
                  x0*x233 - x10*x221 - x10*x232 - x10*x233 - x102*x234 - x102* &
                  x235 - x106*x185 + x108*x120 - x110*x185 + x112*x120 + x113* &
                  x150 + x113*x152 + x114*x181 + x114*x183 + x123*x39 + x123*  &
                  x43 + x128*x37 + x131*x217 + x135*x37 + x137*x67 + x137*x71  &
                   - x137*x75 + x137*x77 + x137*x80 - x137*x83 - x144*x150 -   &
                  x144*x152 + x145*x15 + x145*x16 + x146*x89 + x146*x92 + x148*&
                  x89 + x148*x92 - x149*x89 - x149*x92 + x150*x96 + x152*x44 + &
                  x152*x8 + x152*x96 - x153*x45 - x159*x97 - x161*x97 - x162*  &
                  x215 - x162*x216 - x163*x204 - x163*x205 + x17*x172 + x172*  &
                  x18 + x172*x239 + x172*x240 - x174*x45 - x177*x236 - x182*x50&
                   - x184*x50 - x187*x82 - x188*x82 - x192*x34 - x196*x34 -    &
                  x198*x98 - x199*x98 + x200*x26 + x200*x28 + x201*x94 + x201* &
                  x95 - x203*x238 - x206*x241 + x210*x231 - x212*x45 - x219*   &
                  x231 - x219*x241 + x220*x29 - x220*x47 - x220*x52 + x221*x45 &
                   + x221*x6 - x221*x9 + x221*x90 + x221*x91 + x222*x32 + x222*&
                  x40 + x223*x40 + x224*x40 + x228*x48 + x228*x53 + x230*x79 + &
                  x232*x45 + x232*x86 + x232*x87 - x232*x88 + x232*x90 + x232* &
                  x91 + x233*x45 + x233*x6 + x233*x7 - x233*x9 + x233*x90 -    &
                  x237*x48 - x237*x53 + x57*x76 + x57*x84
        wout(2) = P1(1)*P2(1)*w1(2)*x210 - P1(1)*x227 + P1(2)*P2(2)*w2(2)*x209 &
                   + P1(3)*P2(3)*w1(2)*x210 - P1(3)*x253 - P1(3)*x261 + P2(2)* &
                  x254 - P2(2)*x258 - P2(3)*x261 - x0*x243 + x0*x250 + x10*x243&
                   + x10*x244 - x10*x248 - x103*x114 + x106*x49 + x108*x51 -   &
                  x109*x114 + x110*x49 + x110*x54 + x110*x55 + x112*x51 - x113*&
                  x27 - x116*x220 - x119*x182 - x119*x184 + x128*x31 - x132*   &
                  x230 + x135*x31 - x137*x189 - x137*x190 + x137*x191 - x137*  &
                  x193 - x137*x194 + x137*x195 + x144*x27 + x15*x19 - x151*x201&
                   - x153*x201 - x159*x175 + x16*x19 - x161*x175 + x17*x93 -   &
                  x173*x200 - x174*x200 - x176*x198 - x176*x199 - x179*x234 -  &
                  x179*x235 - x179*x257 + x18*x93 - x192*x58 - x196*x58 - x20* &
                  x89 - x20*x92 + x203*x247 - x204*x65 - x205*x65 + x206*x255  &
                   - x206*x256 - x206*x259 - x206*x260 + x208*x255 - x208*x256 &
                   - x208*x259 - x208*x260 + x210*x249 + x210*x256 + x217*x78  &
                   - x219*x249 - x219*x256 - x22*x89 - x22*x92 - x222*x38 -    &
                  x222*x42 - x223*x42 - x224*x42 + x225*x246 - x225*x251 + x236&
                  *x99 + x24*x89 + x24*x92 - x243*x45 - x243*x6 + x243*x9 -    &
                  x243*x90 - x243*x91 - x244*x45 - x244*x90 - x244*x91 + x245* &
                  x246 - x245*x251 + x248*x85 + x248*x87 - x248*x88 + x250*x45 &
                   + x250*x6 + x250*x7 - x250*x9 + x250*x91 - x252*x48 - x252* &
                  x53 + x26*x90 - x27*x44 - x27*x8 - x27*x96 + x28*x90 + x33*  &
                  x76 + x33*x84 + x39*x68 + x43*x68 + x90*x94 + x90*x95
        wout(3) = -P1(0)*P2(0)*w1(3)*x210 + P1(1)*P2(1)*w2(3)*x209 - P1(1)*x229&
                   + P1(2)*P2(2)*w1(3)*x210 + P1(2)*x253 - P1(3)*x213 - P1(3)* &
                  x214 - P2(2)*P2(3)*w1(2)*x219 + P2(3)*x254 - P2(3)*x258 + x0*&
                  x262 + x0*x268 - x10*x262 - x101*x247 + x103*x185 - x104*x234&
                   - x104*x235 - x104*x257 + x107*x265 + x109*x185 + x111*x265 &
                   + x113*x158 + x113*x160 + x122*x137 + x126*x137 - x127*x137 &
                   + x128*x59 + x129*x137 + x132*x188 + x133*x137 - x134*x137  &
                   + x135*x59 - x144*x158 - x144*x160 + x15*x154 - x151*x98 -  &
                  x153*x98 + x154*x16 + x155*x89 + x155*x92 + x156*x89 + x156* &
                  x92 - x157*x89 - x157*x92 + x158*x44 + x158*x96 - x159*x91 + &
                  x160*x44 + x160*x8 + x160*x96 - x161*x91 - x162*x182 - x162* &
                  x184 - x168*x220 + x17*x197 - x173*x97 - x174*x97 - x175*x218&
                   + x175*x94 + x175*x95 + x176*x26 + x176*x28 + x178*x238 +   &
                  x18*x197 - x181*x49 - x183*x49 - x183*x54 - x183*x55 - x192* &
                  x30 - x196*x30 + x197*x239 + x197*x240 - x198*x91 - x199*x91 &
                   - x202*x236 - x204*x52 - x205*x52 - x206*x270 - x208*x269 - &
                  x208*x270 + x210*x267 + x210*x269 + x211*x59 - x215*x52 +    &
                  x217*x81 - x219*x267 - x219*x269 + x222*x35 + x222*x41 + x223&
                  *x41 + x224*x41 + x225*x263 + x245*x263 + x262*x45 + x262*x6 &
                   - x262*x9 + x262*x90 + x262*x91 + x264*x48 + x264*x53 + x266&
                  *x45 + x266*x85 + x266*x86 - x266*x88 + x268*x6 + x268*x7 -  &
                  x268*x9 + x268*x90 + x36*x76 + x36*x84 + x39*x72 + x43*x72 - &
                  x63*x79
      case(VVV7)
!       P(1,2)*P(2,3)*P(3,1)*c0
!       P(1,3)*P(2,1)*P(3,2)*c1
!       c2*(-Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2) - Metric(1,3)*P(-1,1)*P(-1,2)*P(2
!       ,3))
!       -Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3)*c3
!       Epsilon(-1,-2,-3,3)*Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3)*c4
!       Epsilon(-1,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3)*c5
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1)*c6
!       Epsilon(-1,-2,1,2)*P(-1,2)*P(-2,3)*P(3,1)*c7
!       Epsilon(-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2,3)*c8
!       Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2)*c9
!       Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2)*c10
!       Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2)*c11
!       Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,2)*P(1,3)*c12
!       Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3)*c13
!       Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*P(-2,3)*c14
        if (last) VB_last = .true.
        x0 = P1(1)**2
        x1 = w1(2)*w2(3) - w1(3)*w2(2)
        x2 = w1(1)*w2(2) - w1(2)*w2(1)
        x3 = w1(1)*w2(3) - w1(3)*w2(1)
        x4 = P2(1)*x1 - P2(2)*x3 + P2(3)*x2
        x5 = co(9)*x4
        x6 = P1(2)**2
        x7 = P1(3)**2
        x8 = co(9)*x7
        x9 = P1(0)**2
        x10 = P1(0)*P2(0)
        x11 = P1(1)*x1
        x12 = P1(3)*x2
        x13 = P1(2)*x3
        x14 = x11 + x12 - x13
        x15 = co(11)*x14
        x16 = co(11)*x4
        x17 = co(7)*x14
        x18 = co(7)*x4
        x19 = P1(0)*P2(2)
        x20 = P1(0)*x3
        x21 = w1(0)*w2(1) - w1(1)*w2(0)
        x22 = P1(3)*x21
        x23 = w1(0)*w2(3) - w1(3)*w2(0)
        x24 = P1(1)*x23
        x25 = x20 + x22 - x24
        x26 = co(7)*x25
        x27 = P2(0)*x3 - P2(1)*x23 + P2(3)*x21
        x28 = co(7)*x27
        x29 = P1(0)*w1(0)
        x30 = P1(2)*w2(3)
        x31 = P1(3)*w2(2)
        x32 = x30 - x31
        x33 = P1(1)*w2(2)
        x34 = P1(2)*w2(1)
        x35 = x33 - x34
        x36 = P1(1)*w2(3)
        x37 = P1(3)*w2(1)
        x38 = x36 - x37
        x39 = co(5)*(P2(1)*x32 - P2(2)*x38 + P2(3)*x35)
        x40 = P2(2)*w2(3) - P2(3)*w2(2)
        x41 = P2(1)*w2(2) - P2(2)*w2(1)
        x42 = P2(1)*w2(3) - P2(3)*w2(1)
        x43 = co(5)*(P2(1)*x40 - P2(2)*x42 + P2(3)*x41)
        x44 = P1(1)*P2(1)*co(14)
        x45 = P1(1)*P2(1)
        x46 = P2(2)*w1(2)
        x47 = P2(3)*w1(3)
        x48 = -P2(0)*w1(0) + P2(1)*w1(1) + x46 + x47
        x49 = co(10)*x32*x48
        x50 = co(10)*x40*x48
        x51 = P1(1)*w1(1)
        x52 = P1(2)*w1(2)
        x53 = P1(3)*w1(3)
        x54 = -x29 + x51 + x52 + x53
        x55 = co(12)*x40*x54
        x56 = co(12)*x40*x48
        x57 = P2(2)*w1(3) - P2(3)*w1(2)
        x58 = P1(1)*w2(1)
        x59 = P1(2)*w2(2)
        x60 = P1(3)*w2(3)
        x61 = P1(0)*w2(0)
        x62 = x58 + x59 + x60 - x61
        x63 = co(13)*x57*x62
        x64 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x65 = P1(1)*co(13)*x64
        x66 = P1(1)*w2(0)
        x67 = P1(3)*w1(2)
        x68 = P1(2)*w1(3) - x67
        x69 = P2(0)*x68
        x70 = P1(0)*w1(2)
        x71 = P1(2)*w1(0)
        x72 = x70 - x71
        x73 = P2(3)*x72
        x74 = P1(0)*w1(3)
        x75 = P1(3)*w1(0)
        x76 = x74 - x75
        x77 = P2(2)*x76
        x78 = co(3)*(x69 + x73 - x77)
        x79 = P2(0)*x57
        x80 = P2(2)*w1(0)
        x81 = P2(0)*w1(2) - x80
        x82 = P2(3)*x81
        x83 = P2(3)*w1(0)
        x84 = P2(0)*w1(3) - x83
        x85 = P2(2)*x84
        x86 = co(3)*(x79 + x82 - x85)
        x87 = P2(1)**2
        x88 = P2(2)**2
        x89 = P2(3)**2
        x90 = P2(0)**2
        x91 = co(8)*(x87 + x88 + x89 - x90)
        x92 = P1(2)*P2(2)
        x93 = P1(3)*P2(3)
        x94 = co(8)*(-x10 + x45 + x92 + x93)
        x95 = P1(2)*P2(0)
        x96 = co(11)*x25
        x97 = co(11)*x27
        x98 = P1(2)*P2(2)*co(14)
        x99 = P1(1)*P2(3)
        x100 = P1(3)*P2(1)
        x101 = -x100 + x99
        x102 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x103 = P1(2)*co(4)*x102
        x104 = P1(0)*w2(1)
        x105 = x104 - x66
        x106 = P1(0)*w2(3)
        x107 = P1(3)*w2(0)
        x108 = x106 - x107
        x109 = P2(0)*x38 - P2(1)*x108 + P2(3)*x105
        x110 = co(5)*x109
        x111 = P2(0)*w2(1) - P2(1)*w2(0)
        x112 = P2(0)*w2(3) - P2(3)*w2(0)
        x113 = P2(0)*x42 - P2(1)*x112 + P2(3)*x111
        x114 = co(5)*x113
        x115 = P1(3)*P2(3)*co(14)
        x116 = P1(3)*co(10)*x48
        x117 = co(12)*x54
        x118 = P1(3)*x41
        x119 = co(12)*x48
        x120 = P2(2)*w1(1)
        x121 = P2(1)*w1(2) - x120
        x122 = P1(3)*co(13)*x121
        x123 = P1(1)*w1(2)
        x124 = P1(2)*w1(1)
        x125 = x123 - x124
        x126 = P2(0)*x125
        x127 = P1(0)*w1(1)
        x128 = P1(1)*w1(0)
        x129 = x127 - x128
        x130 = P2(2)*x129
        x131 = P2(1)*x72
        x132 = co(3)*(x126 + x130 - x131)
        x133 = P2(0)*x121
        x134 = P2(0)*w1(1)
        x135 = P2(1)*w1(0)
        x136 = x134 - x135
        x137 = P2(2)*x136
        x138 = P2(1)*x81
        x139 = co(3)*(x133 + x137 - x138)
        x140 = P2(0)*co(2)*x102
        x141 = P2(1)*x68
        x142 = co(6)*x62
        x143 = P2(1)*x57
        x144 = P2(3)*x125
        x145 = P2(3)*x121
        x146 = co(1)*w1(0)*x62
        x147 = P1(0)*P2(0)*co(14)
        x148 = P1(0)*P2(1)
        x149 = P1(0)*x1
        x150 = w1(0)*w2(2) - w1(2)*w2(0)
        x151 = P1(3)*x150
        x152 = P1(2)*x23
        x153 = x149 + x151 - x152
        x154 = co(7)*x153
        x155 = P2(0)*x1 - P2(2)*x23 + P2(3)*x150
        x156 = co(7)*x155
        x157 = P1(0)*P2(3)
        x158 = P1(0)*x2
        x159 = P1(2)*x21
        x160 = P1(1)*x150
        x161 = x158 + x159 - x160
        x162 = co(7)*x161
        x163 = P2(0)*x2 - P2(1)*x150 + P2(2)*x21
        x164 = co(7)*x163
        x165 = co(2)*x102
        x166 = P1(1)*w1(3)
        x167 = P1(3)*w1(1)
        x168 = x166 - x167
        x169 = P2(2)*x168
        x170 = co(3)*(x141 + x144 - x169)
        x171 = P2(3)*w1(1)
        x172 = P2(1)*w1(3) - x171
        x173 = P2(2)*x172
        x174 = co(3)*(x143 + x145 - x173)
        x175 = P1(1)*P2(0)
        x176 = co(11)*x153
        x177 = co(11)*x155
        x178 = P1(2)*P2(3)
        x179 = P1(3)*P2(2)
        x180 = x178 - x179
        x181 = P1(1)*co(4)*x102
        x182 = P1(0)*w2(2)
        x183 = P1(2)*w2(0)
        x184 = x182 - x183
        x185 = co(5)*(P2(0)*x32 - P2(2)*x108 + P2(3)*x184)
        x186 = P2(0)*w2(2) - P2(2)*w2(0)
        x187 = co(5)*(P2(0)*x40 - P2(2)*x112 + P2(3)*x186)
        x188 = P1(2)*co(10)*x48
        x189 = co(12)*x42*x54
        x190 = co(12)*x42*x48
        x191 = P1(2)*co(13)*x62
        x192 = P1(2)*co(13)*x64
        x193 = P2(0)*x168
        x194 = P2(3)*x129
        x195 = P2(1)*x76
        x196 = co(3)*(x193 + x194 - x195)
        x197 = P2(0)*x172
        x198 = P2(3)*x136
        x199 = P2(1)*x84
        x200 = co(3)*(x197 + x198 - x199)
        x201 = P1(3)*P2(0)
        x202 = co(11)*x161
        x203 = co(11)*x163
        x204 = P1(1)*P2(2)
        x205 = P1(2)*P2(1)
        x206 = x204 - x205
        x207 = P1(3)*co(4)*x102
        x208 = co(5)*(P2(0)*x35 - P2(1)*x184 + P2(2)*x105)
        x209 = co(5)*(P2(0)*x41 - P2(1)*x186 + P2(2)*x111)
        x210 = P1(0)*P2(0)*w1(0)
        x211 = co(0)*x62
        x212 = co(0)*x64
        x213 = P1(1)*P2(1)*co(2)*x62
        x214 = P1(1)*P2(1)*co(2)*x64
        x215 = co(2)*x62
        x216 = P1(2)*P2(2)*w1(0)
        x217 = co(2)*x64
        x218 = P2(3)*co(2)*x102
        x219 = P1(3)*P2(3)*w1(0)
        x220 = co(0)*w1(1)*x62
        x221 = co(0)*w1(1)*x64
        x222 = P2(2)*co(0)*w1(2)*x62
        x223 = P2(2)*co(0)*w1(2)*x64
        x224 = P2(3)*co(0)*x62
        x225 = P2(3)*co(0)*x64
        x226 = P2(0)*co(1)*x62
        x227 = co(1)*w1(2)*x62
        x228 = co(1)*w1(3)*x62
        x229 = P2(1)*co(1)*x62
        x230 = co(9)*x0
        x231 = co(9)*x6
        x232 = co(9)*x9
        x233 = co(13)*x64
        x234 = co(9)*x155
        x235 = co(4)*x102*(x157 - x201)
        x236 = P1(3)*x186
        x237 = co(13)*x62*x81
        x238 = P1(3)*co(13)*x64
        x239 = co(2)*x0*x102
        x240 = P2(1)*co(2)*x102
        x241 = P1(0)*P2(0)*co(9)
        x242 = P1(0)*co(4)*x102
        x243 = P1(2)*co(12)*x112
        x244 = x19 - x95
        x245 = co(1)*w1(1)*x62
        x246 = co(0)*w1(0)*x62
        x247 = co(0)*w1(0)*x64
        x248 = co(2)*w1(1)*x62
        x249 = co(2)*w1(1)*x64
        x250 = P2(1)*co(1)*w1(2)*x62
        x251 = co(9)*x27
        x252 = co(14)*x25
        x253 = P1(1)*co(10)*x48
        x254 = P1(1)*x112
        x255 = co(13)*x62
        x256 = P1(1)*x84
        x257 = x148 - x175
        x258 = P2(2)*co(2)*x102
        x259 = P1(0)*co(10)*x48
        x260 = P1(0)*x172
        x261 = P1(3)*x111
        x262 = co(13)*x136*x62
        x263 = P1(0)*co(1)*w1(0)*x62
        x264 = P1(1)*P2(1)*w1(2)
        x265 = P1(2)*P2(0)*w1(0)
        x266 = P1(2)*P2(2)*w1(2)
        x267 = P1(3)*P2(3)*w1(2)
        x268 = P1(0)*P2(0)*w1(2)
        x269 = P1(1)*co(1)*w1(1)*x62
        x270 = P1(2)*P2(1)*w1(1)
        x271 = co(1)*x62
        x272 = P1(2)*P2(3)*w1(3)
        x273 = P2(2)*co(1)*w1(3)*x62
        x274 = P1(0)*x41
        x275 = P1(0)*x121
        x276 = co(9)*x163
        x277 = P1(2)*x111
        x278 = P1(2)*co(5)*w1(3)
        x279 = P1(1)*x186
        x280 = P1(2)*P2(2)*w1(3)
        x281 = P1(3)*P2(3)*w1(3)
        x282 = P1(0)*P2(0)*w1(3)
        x283 = P1(3)*P2(1)*w1(1)
        wout(0) = -P1(0)*x165*x90 - P1(0)*x222 - P1(0)*x223 + P1(1)*x49 + P1(1 &
                  )*x50 + P1(1)*x55 + P1(1)*x56 + P1(1)*x63 - P1(2)*x189 - P1(2&
                  )*x190 + w1(0)*x213 + w1(0)*x214 + x0*x140 + x0*x5 + x10*x146&
                   + x10*x15 + x10*x16 + x10*x17 + x10*x18 - x10*x5 + x101*x103&
                   + x107*x132 + x107*x139 + x11*x91 + x11*x94 + x110*x71 +    &
                  x114*x71 + x115*x14 + x115*x4 + x116*x35 + x116*x41 + x117*  &
                  x118 + x118*x119 + x12*x91 + x12*x94 + x122*x62 + x122*x64 - &
                  x128*x185 - x128*x187 - x13*x91 - x13*x94 - x134*x229 - x14* &
                  x147 + x14*x44 + x14*x98 + x140*x45 + x140*x6 + x140*x7 -    &
                  x140*x9 + x140*x92 + x141*x142 + x142*x143 + x142*x144 + x142&
                  *x145 - x142*x169 - x142*x173 + x146*x90 - x147*x4 - x148*   &
                  x154 - x148*x156 - x148*x220 - x148*x221 - x157*x162 - x157* &
                  x164 - x170*x61 - x172*x191 - x172*x192 - x174*x61 - x175*   &
                  x176 - x175*x177 - x180*x181 - x183*x196 - x183*x200 - x188* &
                  x38 - x188*x42 + x19*x26 + x19*x28 - x201*x202 - x201*x203 + &
                  x201*x218 - x201*x228 - x206*x207 - x208*x75 - x209*x75 +    &
                  x210*x211 + x210*x212 - x210*x215 - x210*x217 + x215*x216 +  &
                  x215*x219 + x216*x217 + x217*x219 - x224*x74 - x225*x74 -    &
                  x226*x46 - x226*x47 - x226*x51 - x227*x95 + x29*x39 + x29*x43&
                   + x4*x44 + x4*x8 + x4*x98 + x45*x5 + x5*x6 - x5*x9 + x5*x92 &
                   + x5*x93 + x57*x65 + x66*x78 + x66*x86 + x95*x96 + x95*x97
        wout(1) = P1(0)*x233*x57 + P1(0)*x49 + P1(0)*x50 + P1(0)*x55 + P1(0)*  &
                  x56 + P1(0)*x63 + P1(1)*x165*x87 - P1(1)*x222 - P1(1)*x223 + &
                  P1(2)*x235 - P1(2)*x250 + P1(3)*x237 + P2(1)*x239 - P2(2)*   &
                  x250 + w1(1)*x214 - x10*x240 - x10*x248 - x10*x249 - x100*   &
                  x202 - x100*x203 - x104*x170 - x104*x174 - x108*x188 + x110* &
                  x124 - x112*x188 + x114*x124 + x115*x153 + x115*x155 + x116* &
                  x184 + x116*x186 + x117*x236 + x119*x236 + x127*x39 + x127*  &
                  x43 + x132*x37 + x135*x226 + x139*x37 + x142*x69 + x142*x73  &
                   - x142*x77 + x142*x79 + x142*x82 - x142*x85 - x147*x153 -   &
                  x147*x155 + x148*x15 + x148*x16 + x149*x91 + x149*x94 + x151*&
                  x91 + x151*x94 - x152*x91 - x152*x94 + x153*x44 + x153*x98 - &
                  x154*x45 + x155*x230 + x155*x231 - x155*x232 - x155*x241 +   &
                  x155*x44 + x155*x8 + x155*x98 - x156*x45 - x162*x99 - x164*  &
                  x99 - x166*x224 - x166*x225 - x167*x208 - x167*x209 + x17*   &
                  x175 + x175*x18 + x175*x246 + x175*x247 - x176*x45 - x177*x45&
                   - x180*x242 - x185*x51 - x187*x51 - x191*x84 - x192*x84 -   &
                  x196*x34 - x200*x34 + x204*x26 + x204*x28 + x205*x96 + x205* &
                  x97 - x207*x244 - x220*x45 - x221*x45 + x229*x29 - x229*x47  &
                   - x229*x53 + x234*x45 + x234*x92 + x234*x93 + x238*x81 +    &
                  x240*x6 + x240*x7 - x240*x9 + x240*x92 + x240*x93 - x243*x48 &
                   - x243*x54 - x245*x45 - x245*x87 + x248*x45 + x248*x92 +    &
                  x248*x93 + x249*x92 + x249*x93 + x58*x78 + x58*x86
        wout(2) = -P1(0)*x189 - P1(0)*x190 - P1(1)*x235 + P1(2)*x165*x88 - P1(3&
                  )*x262 - P1(3)*x273 + P2(2)*x263 - P2(2)*x269 - P2(3)*x273 - &
                  x0*x251 + x0*x258 + x10*x251 + x10*x252 - x10*x258 + x101*   &
                  x242 - x105*x116 + x108*x253 + x110*x52 - x111*x116 + x112*  &
                  x253 + x114*x52 - x115*x27 + x117*x254 - x117*x261 + x119*   &
                  x254 - x119*x261 - x120*x229 - x123*x185 - x123*x187 + x132* &
                  x31 - x136*x238 + x139*x31 - x142*x193 - x142*x194 + x142*   &
                  x195 - x142*x197 - x142*x198 + x142*x199 + x147*x27 + x15*x19&
                   - x154*x205 - x156*x205 + x16*x19 - x162*x178 - x164*x178 + &
                  x17*x95 - x170*x182 - x174*x182 - x176*x204 - x177*x204 -    &
                  x179*x202 - x179*x203 + x18*x95 - x196*x59 - x20*x91 - x20*  &
                  x94 - x200*x59 + x207*x257 - x208*x67 - x209*x67 + x211*x265 &
                   - x211*x266 - x211*x270 - x211*x272 + x212*x265 - x212*x266 &
                   - x212*x270 - x212*x272 + x215*x264 + x215*x266 + x215*x267 &
                   - x215*x268 + x217*x264 + x217*x266 + x217*x267 - x217*x268 &
                   - x22*x91 - x22*x94 + x226*x80 - x227*x88 + x233*x256 - x233&
                  *x260 + x24*x91 + x24*x94 - x251*x45 - x251*x6 + x251*x9 -   &
                  x251*x92 - x251*x93 - x252*x45 - x252*x92 - x252*x93 + x255* &
                  x256 - x255*x260 + x258*x45 + x258*x6 + x258*x7 - x258*x9 +  &
                  x258*x93 - x259*x38 - x259*x42 + x26*x92 - x266*x271 - x27*  &
                  x44 - x27*x8 - x27*x98 + x28*x92 + x33*x78 + x33*x86 + x39*  &
                  x70 + x43*x70 + x92*x96 + x92*x97
        wout(3) = -P1(1)*x237 + P1(2)*x262 + P1(3)*x165*x89 - P1(3)*x222 - P1(3&
                  )*x223 - P2(2)*P2(3)*w1(2)*x271 + P2(3)*x239 + P2(3)*x263 -  &
                  P2(3)*x269 + w1(3)*x213 + w1(3)*x214 - x10*x218 - x100*x154  &
                   - x100*x156 - x103*x257 + x105*x188 - x106*x170 - x106*x174 &
                   + x109*x278 + x111*x188 + x113*x278 + x115*x161 + x115*x163 &
                   + x117*x274 + x117*x277 - x117*x279 + x119*x274 + x119*x277 &
                   - x119*x279 + x126*x142 + x130*x142 - x131*x142 + x132*x60  &
                   + x133*x142 + x136*x192 + x137*x142 - x138*x142 + x139*x60  &
                   - x147*x161 - x147*x163 + x15*x157 + x157*x16 + x158*x91 +  &
                  x158*x94 + x159*x91 + x159*x94 - x160*x91 - x160*x94 + x161* &
                  x44 + x161*x98 - x162*x93 + x163*x230 + x163*x231 - x163*x232&
                   - x163*x241 + x163*x44 + x163*x8 + x163*x98 - x164*x93 -    &
                  x166*x185 - x166*x187 + x17*x201 - x171*x229 - x176*x99 -    &
                  x177*x99 - x178*x227 + x178*x258 + x178*x96 + x178*x97 + x179&
                  *x26 + x179*x28 + x18*x201 + x181*x244 - x184*x253 - x186*   &
                  x253 - x196*x30 - x200*x30 + x201*x246 + x201*x247 - x202*x93&
                   - x203*x93 - x206*x242 - x208*x53 - x209*x53 - x211*x283 -  &
                  x212*x281 - x212*x283 + x215*x280 + x215*x281 - x215*x282 +  &
                  x217*x280 + x217*x281 - x217*x282 + x218*x45 + x218*x6 + x218&
                  *x7 - x218*x9 - x224*x53 + x226*x83 - x228*x89 + x233*x275 + &
                  x255*x275 + x259*x35 + x259*x41 - x271*x281 + x276*x45 + x276&
                  *x92 + x276*x93 + x36*x78 + x36*x86 + x39*x74 + x43*x74 - x65&
                  *x81
      case(VVV8)
!       P(1,2)*P(2,3)*P(3,1)*c0
!       P(1,3)*P(2,1)*P(3,2)*c1
!       Metric(1,2)*P(-1,2)*P(-1,3)*P(3,1)*c2
!       Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3)*c3
!       Metric(2,3)*P(-1,1)*P(-1,3)*P(1,2)*c4
!       Metric(1,3)*P(-1,2)*P(-1,3)*P(2,1)*c5
!       Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3)*c6
!       Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2)*c7
!       -Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3)*c8
!       Epsilon(-1,-2,-3,3)*Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3)*c9
!       Epsilon(-1,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3)*c10
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1)*c11
!       Epsilon(-1,-2,1,2)*P(-1,2)*P(-2,3)*P(3,1)*c12
!       Epsilon(-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2,3)*c13
!       Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2)*c14
!       Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2)*c15
!       Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2)*c16
!       Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,2)*P(1,3)*c17
!       Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3)*c18
!       Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*P(-2,3)*c19
!       c20*(Metric(1,2)*P(3,1) - Metric(1,3)*P(2,1))
!       c21*(Metric(1,3)*P(2,3) - Metric(2,3)*P(1,3))
!       c22*(-Metric(1,2)*P(3,2) + Metric(2,3)*P(1,2))
!       c23*(Metric(1,2)*P(3,3) - Metric(2,3)*P(1,1))
!       Epsilon(-1,1,2,3)*P(-1,2)*c24
        if (last) VB_last = .true.
        x0 = w1(3)*w2(3)
        x1 = w1(0)*w2(0)
        x2 = w1(1)*w2(1) + w1(2)*w2(2) + x0 - x1
        x3 = co(23)*x2
        x4 = co(22)*x2
        x5 = w1(2)*w2(3)
        x6 = w1(3)*w2(2)
        x7 = x5 - x6
        x8 = P2(1)*x7
        x9 = w1(1)*w2(2)
        x10 = w1(2)*w2(1)
        x11 = -x10 + x9
        x12 = P2(3)*x11
        x13 = P1(1)**2
        x14 = w1(1)*w2(3)
        x15 = w1(3)*w2(1)
        x16 = x14 - x15
        x17 = P2(2)*x16
        x18 = x12 - x17 + x8
        x19 = co(14)*x18
        x20 = P1(2)**2
        x21 = P1(3)**2
        x22 = co(20)*x2
        x23 = P1(0)**2
        x24 = P1(0)*P2(0)
        x25 = P1(1)*x7
        x26 = P1(3)*x11
        x27 = P1(2)*x16
        x28 = x25 + x26 - x27
        x29 = co(12)*x28
        x30 = co(12)*x18
        x31 = co(16)*x28
        x32 = co(16)*x18
        x33 = P1(0)*P2(2)
        x34 = P1(0)*x16
        x35 = w1(0)*w2(1)
        x36 = -w1(1)*w2(0) + x35
        x37 = P1(3)*x36
        x38 = w1(0)*w2(3)
        x39 = w1(3)*w2(0)
        x40 = x38 - x39
        x41 = P1(1)*x40
        x42 = x34 + x37 - x41
        x43 = co(12)*x42
        x44 = P2(0)*x16
        x45 = P2(3)*x36
        x46 = P2(1)*x40
        x47 = x44 + x45 - x46
        x48 = co(12)*x47
        x49 = P1(0)*w1(0)
        x50 = P1(2)*w2(3)
        x51 = P1(3)*w2(2)
        x52 = x50 - x51
        x53 = P1(1)*w2(2)
        x54 = P1(2)*w2(1)
        x55 = x53 - x54
        x56 = P1(1)*w2(3)
        x57 = P1(3)*w2(1)
        x58 = x56 - x57
        x59 = co(10)*(P2(1)*x52 - P2(2)*x58 + P2(3)*x55)
        x60 = P2(2)*w2(3) - P2(3)*w2(2)
        x61 = P2(1)*w2(2) - P2(2)*w2(1)
        x62 = P2(1)*w2(3)
        x63 = -P2(3)*w2(1) + x62
        x64 = co(10)*(P2(1)*x60 - P2(2)*x63 + P2(3)*x61)
        x65 = co(2)*x2
        x66 = P2(0)**2
        x67 = P1(0)*x66
        x68 = co(7)*x2
        x69 = P1(1)*P2(1)
        x70 = P1(1)*P2(1)*co(19)
        x71 = P2(1)**2
        x72 = P2(2)**2
        x73 = P2(3)**2
        x74 = co(13)*(-x66 + x71 + x72 + x73)
        x75 = P1(2)*P2(2)
        x76 = P1(3)*P2(3)
        x77 = co(13)*(-x24 + x69 + x75 + x76)
        x78 = P2(2)*w1(2)
        x79 = P2(3)*w1(3)
        x80 = -P2(0)*w1(0) + P2(1)*w1(1) + x78 + x79
        x81 = P1(1)*co(15)*x80
        x82 = P1(1)*w1(1)
        x83 = P1(2)*w1(2)
        x84 = P1(3)*w1(3)
        x85 = -x49 + x82 + x83 + x84
        x86 = P1(1)*co(17)
        x87 = P1(1)*co(17)*x80
        x88 = P2(2)*w1(3)
        x89 = P2(3)*w1(2)
        x90 = x88 - x89
        x91 = P1(1)*w2(1)
        x92 = P1(2)*w2(2)
        x93 = P1(3)*w2(3)
        x94 = P1(0)*w2(0)
        x95 = x91 + x92 + x93 - x94
        x96 = P1(1)*co(18)*x95
        x97 = P2(1)*w2(1)
        x98 = P2(0)*w2(0)
        x99 = P2(2)*w2(2) + P2(3)*w2(3) + x97 - x98
        x100 = co(18)*x90*x99
        x101 = P1(1)*co(20)
        x102 = P1(1)*co(21)
        x103 = P1(1)*w2(0)
        x104 = P1(2)*w1(3)
        x105 = P1(3)*w1(2)
        x106 = x104 - x105
        x107 = P2(0)*x106
        x108 = P1(0)*w1(2)
        x109 = P1(2)*w1(0)
        x110 = x108 - x109
        x111 = P2(3)*x110
        x112 = P1(0)*w1(3)
        x113 = P1(3)*w1(0)
        x114 = x112 - x113
        x115 = P2(2)*x114
        x116 = co(8)*(x107 + x111 - x115)
        x117 = P2(0)*x90
        x118 = P2(2)*w1(0)
        x119 = P2(0)*w1(2) - x118
        x120 = P2(3)*x119
        x121 = P2(3)*w1(0)
        x122 = P2(0)*w1(3) - x121
        x123 = P2(2)*x122
        x124 = co(8)*(x117 + x120 - x123)
        x125 = P1(2)*P2(0)
        x126 = co(16)*x42
        x127 = co(16)*x47
        x128 = P1(2)*P2(2)*co(19)
        x129 = P1(0)*w2(1)
        x130 = -x103 + x129
        x131 = P1(0)*w2(3)
        x132 = -P1(3)*w2(0) + x131
        x133 = co(10)*(P2(0)*x58 - P2(1)*x132 + P2(3)*x130)
        x134 = P2(1)*w2(0)
        x135 = P2(0)*w2(1) - x134
        x136 = P2(3)*w2(0)
        x137 = P2(0)*w2(3) - x136
        x138 = co(10)*(P2(0)*x63 - P2(1)*x137 + P2(3)*x135)
        x139 = P1(2)*w1(0)*w2(2)
        x140 = P1(2)*w2(0)
        x141 = P1(1)*P2(3)
        x142 = P1(3)*P2(1)
        x143 = x141 - x142
        x144 = P1(2)*co(9)*x2
        x145 = P1(3)*P2(3)*co(19)
        x146 = P1(3)*co(15)*x80
        x147 = P1(3)*co(17)
        x148 = co(17)*x61*x80
        x149 = P2(1)*w1(2)
        x150 = P2(2)*w1(1)
        x151 = x149 - x150
        x152 = P1(3)*co(18)*x95
        x153 = co(18)*x151*x99
        x154 = P1(3)*w1(0)*w2(3)
        x155 = P1(3)*co(23)*w1(3)
        x156 = P1(1)*w1(2)
        x157 = P1(2)*w1(1)
        x158 = x156 - x157
        x159 = P2(0)*x158
        x160 = P1(0)*w1(1)
        x161 = P1(1)*w1(0)
        x162 = x160 - x161
        x163 = P2(2)*x162
        x164 = P2(1)*x110
        x165 = x159 + x163 - x164
        x166 = P1(3)*co(8)*w2(0)
        x167 = P2(0)*x151
        x168 = P2(0)*w1(1)
        x169 = P2(1)*w1(0)
        x170 = x168 - x169
        x171 = P2(2)*x170
        x172 = P2(1)*x119
        x173 = x167 + x171 - x172
        x174 = P2(0)*x23
        x175 = P2(0)*co(22)
        x176 = P2(1)*x106
        x177 = co(11)*x95
        x178 = P2(1)*x90
        x179 = P2(1)*co(21)
        x180 = co(21)*w2(2)
        x181 = P2(3)*x158
        x182 = P2(3)*x151
        x183 = P2(3)*co(21)
        x184 = co(1)*w1(0)*x95
        x185 = co(4)*x23*x80
        x186 = co(5)*w1(0)*x95
        x187 = P1(0)*P2(0)*co(19)
        x188 = P1(0)*P2(1)
        x189 = P1(0)*x7
        x190 = w1(0)*w2(2)
        x191 = -w1(2)*w2(0) + x190
        x192 = P1(3)*x191
        x193 = P1(2)*x40
        x194 = x189 + x192 - x193
        x195 = co(12)*x194
        x196 = P2(0)*x7
        x197 = P2(3)*x191
        x198 = P2(2)*x40
        x199 = x196 + x197 - x198
        x200 = co(12)*x199
        x201 = P1(0)*P2(3)
        x202 = P1(0)*x11
        x203 = P1(2)*x36
        x204 = P1(1)*x191
        x205 = x202 + x203 - x204
        x206 = co(12)*x205
        x207 = P2(0)*x11
        x208 = P2(2)*x36
        x209 = P2(1)*x191
        x210 = x207 + x208 - x209
        x211 = co(12)*x210
        x212 = co(2)*x2*x71
        x213 = co(2)*x2*x72
        x214 = P1(0)*co(2)*x2
        x215 = co(20)*w2(0)
        x216 = P1(0)*co(23)*w1(0)
        x217 = P1(1)*w1(3)
        x218 = P1(3)*w1(1)
        x219 = x217 - x218
        x220 = P2(2)*x219
        x221 = co(8)*(x176 + x181 - x220)
        x222 = P2(3)*w1(1)
        x223 = P2(1)*w1(3) - x222
        x224 = P2(2)*x223
        x225 = co(8)*(x178 + x182 - x224)
        x226 = P1(1)*P2(0)
        x227 = co(16)*x194
        x228 = co(16)*x199
        x229 = P1(0)*w2(2)
        x230 = -x140 + x229
        x231 = co(10)*(P2(0)*x52 - P2(2)*x132 + P2(3)*x230)
        x232 = P2(2)*w2(0)
        x233 = P2(0)*w2(2) - x232
        x234 = co(10)*(P2(0)*x60 - P2(2)*x137 + P2(3)*x233)
        x235 = co(21)*w1(1)
        x236 = P1(2)*P2(3)
        x237 = P1(3)*P2(2)
        x238 = co(9)*x2*(x236 - x237)
        x239 = co(15)*x58*x80
        x240 = P1(2)*co(15)*x80
        x241 = P1(2)*co(17)
        x242 = P1(2)*co(17)*x80
        x243 = co(18)*x95
        x244 = co(18)*x223*x99
        x245 = co(21)*w1(2)
        x246 = P2(0)*x219
        x247 = P2(3)*x162
        x248 = P2(1)*x114
        x249 = co(8)*(x246 + x247 - x248)
        x250 = P2(0)*x223
        x251 = P2(3)*x170
        x252 = P2(1)*x122
        x253 = co(8)*(x250 + x251 - x252)
        x254 = P1(3)*P2(0)
        x255 = co(16)*x205
        x256 = co(16)*x210
        x257 = co(10)*(P2(0)*x55 - P2(1)*x230 + P2(2)*x130)
        x258 = co(10)*(P2(0)*x61 - P2(1)*x233 + P2(2)*x135)
        x259 = co(21)*w2(0)
        x260 = P1(1)*P2(2)
        x261 = P1(2)*P2(1)
        x262 = co(9)*x2*(x260 - x261)
        x263 = P2(0)*co(7)*x2
        x264 = co(22)*w1(1)
        x265 = co(21)*w1(3)
        x266 = co(4)*w2(0)*x80
        x267 = co(4)*x21*x80
        x268 = w1(0)*x95
        x269 = P1(0)*P2(0)*co(0)
        x270 = w1(0)*x99
        x271 = P1(0)*P2(0)*co(3)*x85
        x272 = P1(0)*P2(0)*co(3)*x80
        x273 = P1(0)*P2(0)*co(6)
        x274 = P1(3)*co(2)*x2
        x275 = co(0)*x95
        x276 = P1(0)*P2(1)*w1(1)
        x277 = co(0)*x99
        x278 = P1(0)*P2(2)*w1(2)
        x279 = P1(0)*P2(3)*w1(3)
        x280 = P2(0)*co(1)*w1(1)*x95
        x281 = P1(1)*P2(1)*w2(0)
        x282 = co(3)*x85
        x283 = co(3)*x80
        x284 = co(4)*x80
        x285 = P1(1)*P2(1)*co(6)
        x286 = co(1)*w1(2)*x95
        x287 = P1(2)*P2(2)*co(3)*x85
        x288 = P1(2)*P2(2)*co(3)*x80
        x289 = P1(2)*P2(2)*co(6)
        x290 = P2(3)*co(7)*x2
        x291 = P2(0)*co(1)*x95
        x292 = P1(3)*P2(3)*w2(0)
        x293 = co(5)*x95
        x294 = P1(3)*P2(3)*co(6)*w1(0)
        x295 = co(14)*x199
        x296 = P1(0)*co(15)*x80
        x297 = P1(0)*co(17)*x85
        x298 = P1(0)*co(17)*x80
        x299 = P1(0)*co(18)*x95
        x300 = co(21)*w2(1)
        x301 = co(19)*x194
        x302 = P1(1)*co(2)*x2
        x303 = P1(1)*w1(1)*w2(1)
        x304 = P1(2)*co(20)*w2(2)
        x305 = P1(2)*w1(2)*w2(1)
        x306 = x201 - x254
        x307 = x233*x85
        x308 = P1(3)*co(17)*x80
        x309 = co(18)*x119*x99
        x310 = P1(3)*co(20)
        x311 = P1(3)*co(21)
        x312 = co(8)*x165
        x313 = co(8)*x173
        x314 = P2(0)*co(21)
        x315 = P2(1)*co(7)*x2
        x316 = P2(2)*co(21)
        x317 = co(4)*w2(1)*x80
        x318 = co(5)*w1(1)*x95
        x319 = P1(0)*co(20)*w2(0)
        x320 = P1(1)*P2(3)*co(12)
        x321 = P1(1)*x71
        x322 = x137*x85
        x323 = co(18)*x122*x95
        x324 = co(18)*x122*x99
        x325 = co(9)*x2*(-x125 + x33)
        x326 = P2(2)*co(22)
        x327 = P2(3)*w1(3)*w2(1)
        x328 = co(1)*x95
        x329 = P1(0)*P2(0)*w1(1)
        x330 = co(6)*x95
        x331 = co(6)*x99
        x332 = P2(1)*co(1)*x95
        x333 = P2(1)*co(0)*x95
        x334 = P2(1)*co(0)*x99
        x335 = P1(1)*P2(1)*w2(1)
        x336 = P1(1)*P2(1)*co(6)*w1(1)
        x337 = P1(1)*P2(2)*w1(2)
        x338 = P1(1)*P2(3)*w1(3)
        x339 = P1(2)*co(1)*x95
        x340 = P1(2)*P2(2)*co(6)*x95
        x341 = P1(3)*P2(3)*w2(1)
        x342 = P1(3)*P2(3)*w1(1)
        x343 = P2(2)*co(1)*x95
        x344 = co(14)*x47
        x345 = co(21)*w1(0)
        x346 = co(9)*x2
        x347 = P1(2)*co(2)*x2
        x348 = P1(2)*w1(2)*w2(2)
        x349 = P1(3)*co(23)
        x350 = co(9)*x2*(x188 - x226)
        x351 = P2(2)*co(7)*x2
        x352 = co(5)*w1(2)*x95
        x353 = co(23)*w1(0)
        x354 = co(19)*x47
        x355 = x135*x85
        x356 = P1(3)*x170
        x357 = co(18)*x99
        x358 = co(21)*w1(3)*w2(2)
        x359 = P2(3)*co(22)
        x360 = co(4)*w2(2)*x80
        x361 = P1(0)*P2(0)*w2(2)
        x362 = P2(0)*co(4)*x80
        x363 = P1(0)*P2(0)*w1(2)
        x364 = P2(0)*co(0)*x95
        x365 = P2(0)*co(0)*x99
        x366 = co(3)*w2(2)*x85
        x367 = P1(1)*P2(1)*w1(2)
        x368 = P1(2)*P2(2)*w1(2)
        x369 = P1(2)*P2(3)*w1(3)
        x370 = P2(2)*co(1)*w1(3)*x95
        x371 = P1(3)*P2(3)*w2(2)
        x372 = P1(3)*P2(3)*w1(2)
        x373 = co(14)*x210
        x374 = P1(2)*x170
        x375 = P1(2)*w1(2)*w2(3)
        x376 = co(4)*w2(3)*x80
        x377 = co(5)*w1(3)*x95
        x378 = P1(3)*x73
        x379 = P1(0)*P2(0)*w2(3)
        x380 = P1(0)*P2(0)*w1(3)
        x381 = P2(3)*co(1)*x95
        x382 = P1(1)*P2(1)*w2(3)
        x383 = P1(1)*P2(1)*co(6)*w1(3)
        x384 = P1(2)*P2(2)*w1(3)
        x385 = P1(3)*P2(2)*w1(2)
        x386 = P1(3)*P2(3)*w1(3)
        x387 = P1(3)*P2(3)*w2(3)
        wout(0) = -P1(0)*x212 - P1(0)*x213 - P1(0)*x22 + P1(0)*x3 + P1(1)*x100 &
                   - P1(1)*x238 - P1(1)*x280 - P1(2)*x223*x243 - P1(2)*x239 -  &
                  P1(2)*x244 - P1(3)*P2(3)*w1(0)*x293 + P1(3)*x148 + P1(3)*x153&
                   - P1(3)*x262 + P2(0)*x3 + P2(0)*x4 - P2(1)*x280 + co(20)*   &
                  x139 + co(20)*x154 + co(21)*x139 + co(21)*x154 - co(22)*w1(2 &
                  )*x232 - co(22)*w1(3)*x136 + co(23)*w1(1)*x103 + co(23)*w1(2 &
                  )*x140 + co(24)*x12 - co(24)*x17 + co(24)*x8 + w2(0)*x155 +  &
                  w2(0)*x185 - w2(0)*x216 - w2(0)*x267 + w2(0)*x271 + w2(0)*   &
                  x272 - w2(0)*x287 - w2(0)*x288 + x1*x175 + x101*x35 + x102*  &
                  x35 + x103*x116 + x103*x124 - x103*x235 + x109*x133 + x109*  &
                  x138 - x113*x257 - x113*x258 + x118*x180 + x125*x126 + x125* &
                  x127 - x125*x286 + x128*x18 + x128*x28 + x13*x19 - x13*x263  &
                   - x13*x266 - x134*x235 - x134*x264 - x136*x265 - x140*x245  &
                   - x140*x249 - x140*x253 + x143*x144 + x145*x18 + x145*x28 + &
                  x146*x55 + x146*x61 + x147*x61*x85 + x151*x152 - x161*x231 - &
                  x161*x234 + x165*x166 + x166*x173 + x174*x65 + x174*x68 +    &
                  x176*x177 + x177*x178 + x177*x181 + x177*x182 - x177*x220 -  &
                  x177*x224 + x179*x35 - x18*x187 + x18*x70 + x183*x38 + x184* &
                  x24 + x184*x66 + x186*x24 + x186*x66 - x186*x69 - x186*x71 - &
                  x186*x72 - x186*x73 - x186*x75 - x187*x28 - x188*x195 - x188*&
                  x200 + x19*x20 + x19*x21 - x19*x23 - x19*x24 + x19*x69 + x19*&
                  x75 + x19*x76 - x20*x263 - x20*x266 - x201*x206 - x201*x211  &
                   - x201*x274 - x21*x263 - x214*x69 - x214*x73 - x214*x75 -   &
                  x215*x49 - x221*x94 - x225*x94 - x226*x227 - x226*x228 - x232&
                  *x245 + x24*x266 + x24*x29 + x24*x30 + x24*x31 + x24*x32 -   &
                  x240*x63 - x241*x63*x85 - x242*x63 + x25*x74 + x25*x77 - x254&
                  *x255 - x254*x256 - x254*x290 - x259*x84 + x26*x74 + x26*x77 &
                   - x263*x69 - x263*x75 - x266*x75 + x268*x269 + x268*x273 -  &
                  x268*x285 - x268*x289 + x269*x270 - x27*x74 - x27*x77 + x270*&
                  x273 - x270*x285 - x270*x289 - x275*x276 - x275*x278 - x275* &
                  x279 - x276*x277 - x277*x278 - x277*x279 + x28*x70 - x281*   &
                  x282 - x281*x283 - x281*x284 - x282*x292 - x283*x292 - x284* &
                  x292 - x291*x78 - x291*x79 - x291*x84 - x294*x95 - x294*x99  &
                   + x33*x43 + x33*x48 + x49*x59 + x49*x64 + x52*x81 + x60*x81 &
                   + x60*x85*x86 + x60*x87 + x65*x67 + x67*x68 + x90*x96
        wout(1) = P1(0)*x100 - P1(0)*x238 + P1(1)*P2(0)*co(0)*x268 + P1(1)*P2(0&
                  )*w1(0)*x277 - P1(1)*P2(1)*w1(1)*x293 - P1(1)*x213 - P1(1)*  &
                  x22 + P1(1)*x3 - P1(2)*x323 - P1(2)*x324 + P1(3)*x309 - P1(3 &
                  )*x325 - P2(1)*x13*x65 + P2(1)*x3 + P2(1)*x4 + co(20)*x303 - &
                  co(21)*x305 - co(21)*x327 - co(22)*x327 + co(23)*x303 + co(23&
                  )*x305 + co(24)*x196 + co(24)*x197 - co(24)*x198 - w1(1)*x289&
                  *x99 + w1(1)*x304 - w1(1)*x319 - w1(1)*x328*x71 - w1(1)*x340 &
                   + w2(1)*x155 - w2(1)*x216 + w2(1)*x271 + w2(1)*x272 - w2(1)*&
                  x287 - w2(1)*x288 - x10*x316 - x10*x326 + x107*x177 + x111*  &
                  x177 - x115*x177 + x116*x91 + x117*x177 + x119*x152 + x120*  &
                  x177 - x123*x177 + x124*x91 + x126*x261 + x127*x261 + x128*  &
                  x199 - x129*x221 - x129*x225 + x13*x295 - x13*x315 - x13*x317&
                   - x132*x240 + x133*x157 - x137*x240 - x137*x242 + x138*x157 &
                   + x14*x183 + x14*x310 + x14*x311 - x142*x255 - x142*x256 -  &
                  x142*x290 + x144*x306 + x145*x199 + x146*x230 + x146*x233 +  &
                  x147*x307 - x149*x339 - x149*x343 + x160*x59 + x160*x64 -    &
                  x168*x259 + x169*x291 + x175*x35 - x187*x199 + x188*x31 +    &
                  x188*x32 + x189*x74 + x189*x77 + x192*x74 + x192*x77 - x193* &
                  x74 - x193*x77 - x195*x69 + x199*x70 + x20*x295 - x20*x315 - &
                  x20*x317 - x200*x69 - x205*x320 + x21*x295 - x21*x315 - x21* &
                  x317 - x210*x320 - x218*x257 - x218*x258 + x226*x29 + x226*  &
                  x30 - x227*x69 - x228*x69 - x23*x295 + x23*x315 + x23*x317 - &
                  x231*x82 + x233*x308 - x234*x82 + x235*x92 - x235*x94 - x24* &
                  x295 - x24*x301 + x24*x302 + x24*x315 + x24*x317 - x241*x322 &
                   - x249*x54 - x253*x54 + x260*x43 + x260*x48 - x264*x97 -    &
                  x275*x337 - x275*x338 - x277*x337 - x277*x338 - x282*x335 -  &
                  x282*x341 - x283*x335 - x283*x341 - x284*x335 - x284*x341 +  &
                  x293*x329 - x293*x342 + x295*x69 + x295*x75 + x295*x76 + x296&
                  *x52 + x296*x60 + x297*x60 + x298*x60 + x299*x90 + x300*x49  &
                   - x300*x84 + x301*x69 + x301*x75 + x301*x76 + x302*x66 -    &
                  x302*x73 - x302*x75 - x302*x76 + x312*x57 + x313*x57 + x314* &
                  x35 - x315*x75 + x316*x9 - x317*x75 + x318*x66 - x318*x71 -  &
                  x318*x72 - x318*x73 - x318*x75 - x321*x65 - x321*x68 + x329* &
                  x330 + x329*x331 - x330*x342 - x331*x342 + x332*x49 - x332*  &
                  x79 - x332*x82 - x332*x84 - x333*x82 - x334*x82 - x336*x95 - &
                  x336*x99
        wout(2) = P1(0)*x143*x346 - P1(0)*x239 - P1(0)*x244 - P1(1)*P2(1)*w2(2 &
                  )*x283 - P1(1)*x306*x346 + P1(1)*x323 + P1(1)*x324 - P1(2)*  &
                  x213 - P1(2)*x22 + P1(2)*x3 - P1(2)*x68*x72 + P1(3)*x350 - P1&
                  (3)*x358 - P1(3)*x370 - P2(1)*co(22)*x9 - P2(2)*x20*x65 + P2(&
                  2)*x3 + P2(2)*x4 - P2(3)*x358 - P2(3)*x370 + co(20)*x348 + co&
                  (21)*w2(3)*x89 - co(22)*w2(2)*x78 + co(23)*w2(2)*x82 + co(23 &
                  )*x348 - co(24)*x44 - co(24)*x45 + co(24)*x46 - w1(2)*x319 - &
                  w1(2)*x340 + w2(2)*x185 - w2(2)*x267 - w2(2)*x288 + x10*x101 &
                   + x10*x102 - x105*x257 - x105*x258 + x108*x59 + x108*x64 +  &
                  x109*x364 + x109*x365 + x116*x53 + x118*x291 + x124*x53 +    &
                  x125*x29 + x125*x30 + x126*x75 + x127*x75 - x128*x42 - x13*  &
                  x344 - x13*x351 - x13*x360 - x130*x146 + x132*x81 + x133*x83 &
                   - x135*x146 - x135*x308 + x137*x81 + x137*x87 + x138*x83 -  &
                  x145*x42 - x145*x47 - x147*x355 + x149*x300 - x150*x332 -    &
                  x156*x231 - x156*x234 - x157*x333 - x157*x334 + x175*x190 -  &
                  x177*x246 - x177*x247 + x177*x248 - x177*x250 - x177*x251 +  &
                  x177*x252 - x179*x9 - x180*x82 + x187*x42 + x187*x47 + x190* &
                  x314 - x195*x261 - x20*x344 - x20*x351 - x20*x360 - x200*x261&
                   - x206*x236 - x21*x344 - x21*x351 - x211*x236 - x221*x229 - &
                  x223*x299 - x225*x229 - x227*x260 - x228*x260 + x229*x345 -  &
                  x229*x353 + x229*x362 + x23*x344 + x23*x351 - x236*x274 -    &
                  x237*x255 - x237*x256 + x24*x344 + x24*x347 + x24*x351 + x24*&
                  x352 - x243*x356 - x245*x94 - x245*x98 - x249*x92 - x253*x92 &
                   - x275*x368 - x275*x369 - x277*x368 - x277*x369 + x282*x361 &
                   - x282*x371 + x283*x361 - x283*x371 - x284*x371 - x286*x72  &
                   - x286*x75 - x293*x367 - x293*x372 - x296*x63 - x297*x63 -  &
                  x298*x63 + x31*x33 + x310*x5 + x311*x5 + x312*x51 + x313*x51 &
                   + x32*x33 + x322*x86 + x330*x363 - x330*x367 - x330*x372 +  &
                  x331*x363 - x331*x367 - x331*x368 - x331*x372 - x34*x74 - x34&
                  *x77 + x343*x49 - x343*x82 - x344*x69 - x344*x75 - x344*x76  &
                   + x347*x66 - x347*x69 - x347*x71 - x347*x73 + x349*x6 - x351&
                  *x69 - x351*x76 + x352*x66 - x352*x71 - x352*x72 - x352*x73  &
                   - x352*x75 - x354*x69 - x354*x75 - x356*x357 - x359*x6 -    &
                  x360*x69 - x360*x75 - x366*x69 - x366*x75 - x37*x74 - x37*x77&
                   + x41*x74 + x41*x77 - x42*x70 + x43*x75 + x48*x75
        wout(3) = P1(0)*x148 + P1(0)*x153 - P1(0)*x262 + P1(1)*co(23)*x14 - P1(&
                  1)*x309 + P1(1)*x325 - P1(2)*x350 - P1(3)*x212 - P1(3)*x213  &
                   - P1(3)*x22 + P1(3)*x3 - P2(3)*x21*x65 + P2(3)*x3 + P2(3)*x4&
                   - co(21)*x375 + co(23)*x375 + co(24)*x207 + co(24)*x208 - co&
                  (24)*x209 + w1(3)*x304 - w1(3)*x328*x73 - w2(3)*x267 - w2(3)*&
                  x287 - w2(3)*x288 + x0*x310 + x0*x349 - x0*x359 + x101*x15 - &
                  x102*x14 + x102*x15 + x104*x133 + x104*x138 - x112*x215 -    &
                  x112*x259 + x112*x59 + x112*x64 + x113*x364 + x113*x365 +    &
                  x116*x56 - x119*x96 + x121*x291 + x124*x56 + x126*x236 + x127&
                  *x236 + x128*x205 + x128*x210 - x13*x290 + x13*x373 - x13*   &
                  x376 + x130*x240 - x131*x221 - x131*x225 + x131*x345 - x131* &
                  x353 + x131*x362 + x135*x240 + x135*x242 - x141*x227 - x141* &
                  x228 - x142*x195 - x142*x200 + x145*x205 + x145*x210 + x151* &
                  x299 + x159*x177 + x163*x177 - x164*x177 + x167*x177 + x171* &
                  x177 - x172*x177 + x175*x38 + x180*x88 - x187*x205 - x187*   &
                  x210 - x20*x290 + x20*x373 - x20*x376 + x201*x31 + x201*x32  &
                   + x202*x74 + x202*x77 + x203*x74 + x203*x77 - x204*x74 -    &
                  x204*x77 + x205*x70 - x206*x76 - x21*x290 + x21*x373 + x210* &
                  x70 - x211*x76 - x217*x231 - x217*x234 - x218*x333 - x218*   &
                  x334 - x222*x332 + x23*x290 - x23*x373 + x23*x376 - x230*x81 &
                   - x233*x81 - x233*x87 - x235*x62 + x237*x43 + x237*x48 + x24&
                  *x274 + x24*x290 - x24*x373 + x241*x355 + x243*x374 - x249*  &
                  x50 - x253*x50 + x254*x29 + x254*x30 - x255*x76 - x256*x76 - &
                  x257*x84 - x258*x84 - x264*x62 + x265*x92 + x265*x97 + x274* &
                  x66 - x274*x69 - x274*x75 - x275*x385 - x275*x386 - x277*x385&
                   - x277*x386 + x282*x379 - x282*x382 - x282*x387 + x283*x379 &
                   - x283*x382 - x283*x387 - x284*x382 - x284*x387 - x290*x69  &
                   - x290*x75 + x293*x380 - x293*x384 - x293*x386 + x296*x55 + &
                  x296*x61 + x297*x61 - x307*x86 + x312*x93 + x313*x93 + x314* &
                  x38 - x314*x39 - x316*x5 - x326*x5 - x328*x386 + x330*x380 - &
                  x330*x384 - x330*x386 + x331*x380 - x331*x384 - x331*x386 -  &
                  x339*x89 - x343*x89 + x357*x374 + x373*x69 + x373*x75 + x373*&
                  x76 - x376*x75 + x377*x66 - x377*x69 - x377*x71 - x377*x72 - &
                  x377*x73 - x378*x65 - x378*x68 + x381*x49 - x381*x82 - x383* &
                  x95 - x383*x99
      case(VVV9)
!       P(1,2)*P(2,3)*P(3,1)*c0
!       P(1,3)*P(2,1)*P(3,2)*c1
!       Metric(1,2)*P(-1,2)*P(-1,3)*P(3,1)*c2
!       Metric(2,3)*P(-1,1)*P(-1,2)*P(1,3)*c3
!       Metric(2,3)*P(-1,1)*P(-1,3)*P(1,2)*c4
!       Metric(1,3)*P(-1,2)*P(-1,3)*P(2,1)*c5
!       Metric(1,3)*P(-1,1)*P(-1,2)*P(2,3)*c6
!       Metric(1,2)*P(-1,1)*P(-1,3)*P(3,2)*c7
!       -Epsilon(-1,-2,-3,1)*Metric(2,3)*P(-1,1)*P(-2,2)*P(-3,3)*c8
!       Epsilon(-1,-2,-3,3)*Metric(1,2)*P(-1,1)*P(-2,2)*P(-3,3)*c9
!       Epsilon(-1,-2,-3,2)*Metric(1,3)*P(-1,1)*P(-2,2)*P(-3,3)*c10
!       Epsilon(-1,-2,1,3)*P(-1,2)*P(-2,3)*P(2,1)*c11
!       Epsilon(-1,-2,1,2)*P(-1,2)*P(-2,3)*P(3,1)*c12
!       Epsilon(-1,1,2,3)*P(-1,1)*P(-2,2)*P(-2,3)*c13
!       Epsilon(-2,1,2,3)*P(-1,1)*P(-1,3)*P(-2,2)*c14
!       Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,3)*P(1,2)*c15
!       Epsilon(-1,-2,1,2)*P(-1,1)*P(-2,3)*P(3,2)*c16
!       Epsilon(-1,-2,2,3)*P(-1,1)*P(-2,2)*P(1,3)*c17
!       Epsilon(-1,-2,1,3)*P(-1,1)*P(-2,2)*P(2,3)*c18
!       Epsilon(-2,1,2,3)*P(-1,1)*P(-1,2)*P(-2,3)*c19
        if (last) VB_last = .true.
        x0 = P1(1)**2
        x1 = w1(2)*w2(3) - w1(3)*w2(2)
        x2 = w1(1)*w2(2) - w1(2)*w2(1)
        x3 = w1(1)*w2(3) - w1(3)*w2(1)
        x4 = P2(1)*x1 - P2(2)*x3 + P2(3)*x2
        x5 = co(14)*x4
        x6 = P1(2)**2
        x7 = P1(3)**2
        x8 = P1(0)**2
        x9 = P1(0)*P2(0)
        x10 = P1(1)*x1
        x11 = P1(3)*x2
        x12 = P1(2)*x3
        x13 = x10 + x11 - x12
        x14 = co(12)*x13
        x15 = co(12)*x4
        x16 = co(16)*x13
        x17 = co(16)*x4
        x18 = P1(0)*P2(2)
        x19 = P1(0)*x3
        x20 = w1(0)*w2(1) - w1(1)*w2(0)
        x21 = P1(3)*x20
        x22 = w1(0)*w2(3) - w1(3)*w2(0)
        x23 = P1(1)*x22
        x24 = x19 + x21 - x23
        x25 = co(12)*x24
        x26 = P2(0)*x3 - P2(1)*x22 + P2(3)*x20
        x27 = co(12)*x26
        x28 = P1(0)*w1(0)
        x29 = P1(2)*w2(3)
        x30 = P1(3)*w2(2)
        x31 = x29 - x30
        x32 = P1(1)*w2(2)
        x33 = P1(2)*w2(1)
        x34 = x32 - x33
        x35 = P1(1)*w2(3)
        x36 = P1(3)*w2(1)
        x37 = x35 - x36
        x38 = co(10)*(P2(1)*x31 - P2(2)*x37 + P2(3)*x34)
        x39 = P2(2)*w2(3) - P2(3)*w2(2)
        x40 = P2(1)*w2(2) - P2(2)*w2(1)
        x41 = P2(1)*w2(3) - P2(3)*w2(1)
        x42 = co(10)*(P2(1)*x39 - P2(2)*x41 + P2(3)*x40)
        x43 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x44 = co(2)*x43
        x45 = P2(0)**2
        x46 = P1(0)*x45
        x47 = co(7)*x43
        x48 = P1(1)*P2(1)
        x49 = P1(1)*P2(1)*co(19)
        x50 = P2(1)**2
        x51 = P2(2)**2
        x52 = P2(3)**2
        x53 = co(13)*(-x45 + x50 + x51 + x52)
        x54 = P1(2)*P2(2)
        x55 = P1(3)*P2(3)
        x56 = co(13)*(x48 + x54 + x55 - x9)
        x57 = P2(2)*w1(2)
        x58 = P2(3)*w1(3)
        x59 = P2(0)*w1(0)
        x60 = P2(1)*w1(1) + x57 + x58 - x59
        x61 = P1(1)*co(15)*x60
        x62 = P1(1)*w1(1)
        x63 = P1(2)*w1(2)
        x64 = P1(3)*w1(3)
        x65 = -x28 + x62 + x63 + x64
        x66 = P1(1)*co(17)
        x67 = P1(1)*co(17)*x60
        x68 = P2(3)*w1(2)
        x69 = P2(2)*w1(3) - x68
        x70 = P1(1)*w2(1)
        x71 = P1(2)*w2(2)
        x72 = P1(3)*w2(3)
        x73 = P1(0)*w2(0)
        x74 = x70 + x71 + x72 - x73
        x75 = co(18)*x69*x74
        x76 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x77 = co(18)*x69*x76
        x78 = P1(1)*w2(0)
        x79 = P1(2)*w1(3)
        x80 = P1(3)*w1(2)
        x81 = x79 - x80
        x82 = P2(0)*x81
        x83 = P1(0)*w1(2)
        x84 = P1(2)*w1(0)
        x85 = x83 - x84
        x86 = P2(3)*x85
        x87 = P1(0)*w1(3)
        x88 = P1(3)*w1(0)
        x89 = x87 - x88
        x90 = P2(2)*x89
        x91 = co(8)*(x82 + x86 - x90)
        x92 = P2(0)*x69
        x93 = P2(2)*w1(0)
        x94 = P2(0)*w1(2) - x93
        x95 = P2(3)*x94
        x96 = P2(3)*w1(0)
        x97 = P2(0)*w1(3) - x96
        x98 = P2(2)*x97
        x99 = co(8)*(x92 + x95 - x98)
        x100 = P1(2)*P2(0)
        x101 = co(16)*x24
        x102 = co(16)*x26
        x103 = P1(2)*P2(2)*co(19)
        x104 = P1(0)*w2(1)
        x105 = x104 - x78
        x106 = P1(0)*w2(3)
        x107 = -P1(3)*w2(0) + x106
        x108 = co(10)*(P2(0)*x37 - P2(1)*x107 + P2(3)*x105)
        x109 = P2(0)*w2(1) - P2(1)*w2(0)
        x110 = P2(0)*w2(3) - P2(3)*w2(0)
        x111 = co(10)*(P2(0)*x41 - P2(1)*x110 + P2(3)*x109)
        x112 = P1(1)*P2(3)
        x113 = P1(3)*P2(1)
        x114 = x112 - x113
        x115 = P1(2)*co(9)*x43
        x116 = P1(3)*P2(3)*co(19)
        x117 = P1(3)*co(15)*x60
        x118 = co(15)*x60
        x119 = P1(3)*x40
        x120 = co(17)*x65
        x121 = co(17)*x60
        x122 = P2(1)*w1(2)
        x123 = P2(2)*w1(1)
        x124 = x122 - x123
        x125 = co(18)*x124*x74
        x126 = co(18)*x124*x76
        x127 = P1(1)*w1(2)
        x128 = P1(2)*w1(1)
        x129 = x127 - x128
        x130 = P2(0)*x129
        x131 = P1(0)*w1(1)
        x132 = P1(1)*w1(0)
        x133 = x131 - x132
        x134 = P2(2)*x133
        x135 = P2(1)*x85
        x136 = x130 + x134 - x135
        x137 = P1(3)*co(8)*w2(0)
        x138 = P2(0)*x124
        x139 = P2(0)*w1(1)
        x140 = -P2(1)*w1(0) + x139
        x141 = P2(2)*x140
        x142 = P2(1)*x94
        x143 = x138 + x141 - x142
        x144 = P2(0)*x8
        x145 = P2(1)*x81
        x146 = co(11)*x74
        x147 = P2(1)*x69
        x148 = P2(3)*x129
        x149 = P2(3)*x124
        x150 = co(1)*w1(0)*x74
        x151 = co(4)*x60*x8
        x152 = co(5)*w1(0)*x74
        x153 = P1(0)*P2(0)*co(19)
        x154 = P1(0)*P2(1)
        x155 = P1(0)*x1
        x156 = w1(0)*w2(2) - w1(2)*w2(0)
        x157 = P1(3)*x156
        x158 = P1(2)*x22
        x159 = x155 + x157 - x158
        x160 = co(12)*x159
        x161 = P2(0)*x1 - P2(2)*x22 + P2(3)*x156
        x162 = co(12)*x161
        x163 = P1(0)*P2(3)
        x164 = P1(0)*x2
        x165 = P1(2)*x20
        x166 = P1(1)*x156
        x167 = x164 + x165 - x166
        x168 = co(12)*x167
        x169 = P2(0)*x2 - P2(1)*x156 + P2(2)*x20
        x170 = co(12)*x169
        x171 = co(2)*x43*x50
        x172 = co(2)*x43*x51
        x173 = P1(0)*co(2)*x43
        x174 = P1(1)*w1(3)
        x175 = P1(3)*w1(1)
        x176 = x174 - x175
        x177 = P2(2)*x176
        x178 = co(8)*(x145 + x148 - x177)
        x179 = P2(3)*w1(1)
        x180 = P2(1)*w1(3) - x179
        x181 = P2(2)*x180
        x182 = co(8)*(x147 + x149 - x181)
        x183 = P1(1)*P2(0)
        x184 = co(16)*x159
        x185 = co(16)*x161
        x186 = P1(0)*w2(2)
        x187 = P1(2)*w2(0)
        x188 = x186 - x187
        x189 = co(10)*(P2(0)*x31 - P2(2)*x107 + P2(3)*x188)
        x190 = P2(0)*w2(2) - P2(2)*w2(0)
        x191 = co(10)*(P2(0)*x39 - P2(2)*x110 + P2(3)*x190)
        x192 = P1(2)*P2(3)
        x193 = P1(3)*P2(2)
        x194 = co(9)*x43*(x192 - x193)
        x195 = co(15)*x37*x60
        x196 = P1(2)*co(15)*x60
        x197 = P1(2)*co(17)
        x198 = P1(2)*co(17)*x60
        x199 = co(18)*x74
        x200 = P1(2)*x180
        x201 = co(18)*x76
        x202 = P2(0)*x176
        x203 = P2(3)*x133
        x204 = P2(1)*x89
        x205 = co(8)*(x202 + x203 - x204)
        x206 = P2(0)*x180
        x207 = P2(3)*x140
        x208 = P2(1)*x97
        x209 = co(8)*(x206 + x207 - x208)
        x210 = P1(3)*P2(0)
        x211 = co(16)*x167
        x212 = co(16)*x169
        x213 = co(10)*(P2(0)*x34 - P2(1)*x188 + P2(2)*x105)
        x214 = co(10)*(P2(0)*x40 - P2(1)*x190 + P2(2)*x109)
        x215 = P1(1)*P2(2)
        x216 = P1(2)*P2(1)
        x217 = x215 - x216
        x218 = P1(3)*co(9)*x43
        x219 = P2(0)*co(7)*x43
        x220 = co(4)*w2(0)*x60
        x221 = co(4)*x60*x7
        x222 = w1(0)*x74
        x223 = P1(0)*P2(0)*co(0)
        x224 = w1(0)*x76
        x225 = P1(0)*P2(0)*co(3)*x65
        x226 = P1(0)*P2(0)*co(3)*x60
        x227 = P1(0)*P2(0)*co(6)
        x228 = P1(3)*co(2)*x43
        x229 = co(0)*w1(1)*x74
        x230 = co(0)*w1(1)*x76
        x231 = co(0)*x74
        x232 = P1(0)*P2(2)*w1(2)
        x233 = co(0)*x76
        x234 = P1(0)*P2(3)*w1(3)
        x235 = P2(0)*co(1)*x74
        x236 = P1(1)*P2(1)*w2(0)
        x237 = co(3)*x65
        x238 = co(3)*x60
        x239 = co(4)*x60
        x240 = P1(1)*P2(1)*co(6)
        x241 = co(1)*w1(2)*x74
        x242 = P1(2)*P2(2)*co(3)*x65
        x243 = P1(2)*P2(2)*co(3)*x60
        x244 = P1(2)*P2(2)*co(6)
        x245 = P2(3)*co(7)*x43
        x246 = P1(3)*P2(3)*w2(0)
        x247 = co(5)*x74
        x248 = P1(3)*P2(3)*co(6)*w1(0)
        x249 = P2(1)*co(1)*x74
        x250 = co(14)*x161
        x251 = P1(0)*co(15)*x60
        x252 = P1(0)*x39
        x253 = co(19)*x159
        x254 = P1(1)*co(2)*x43
        x255 = x163 - x210
        x256 = x190*x65
        x257 = P1(3)*co(17)
        x258 = P1(3)*co(17)*x60
        x259 = co(18)*x74*x94
        x260 = co(18)*x76*x94
        x261 = co(8)*x136
        x262 = co(8)*x143
        x263 = P2(1)*co(7)*x43
        x264 = co(4)*w2(1)*x60
        x265 = co(5)*w1(1)*x74
        x266 = P1(1)*x50
        x267 = x110*x65
        x268 = co(18)*x74*x97
        x269 = co(18)*x76*x97
        x270 = -x100 + x18
        x271 = co(1)*w1(1)*x74
        x272 = P1(0)*P2(0)*co(6)*x74
        x273 = w1(1)*x76
        x274 = P1(1)*P2(1)*w2(1)
        x275 = P1(1)*P2(1)*co(6)*x74
        x276 = P1(1)*P2(2)*w1(2)
        x277 = P1(1)*P2(3)*w1(3)
        x278 = P1(2)*co(1)*x74
        x279 = P1(2)*P2(2)*co(6)*x74
        x280 = P1(3)*P2(3)*w2(1)
        x281 = P1(3)*P2(3)*w1(1)
        x282 = co(6)*x74
        x283 = co(6)*x76
        x284 = P2(2)*co(1)*x74
        x285 = co(14)*x26
        x286 = P1(0)*co(9)*x43
        x287 = P1(2)*co(2)*x43
        x288 = co(9)*x43*(x154 - x183)
        x289 = P2(2)*co(7)*x43
        x290 = co(5)*w1(2)*x74
        x291 = P1(0)*x41
        x292 = P1(0)*x180
        x293 = co(19)*x26
        x294 = P1(1)*co(9)*x43
        x295 = x109*x65
        x296 = P1(3)*x140
        x297 = P2(2)*x6
        x298 = co(4)*w2(2)*x60
        x299 = P1(0)*P2(0)*w2(2)
        x300 = P2(0)*co(4)*x60
        x301 = P1(2)*P2(0)*w1(0)
        x302 = co(3)*w2(2)*x65
        x303 = P1(1)*P2(1)*w1(2)
        x304 = P1(2)*P2(1)*w1(1)
        x305 = P1(2)*P2(2)*w1(2)
        x306 = P1(2)*P2(3)*w1(3)
        x307 = P2(2)*co(1)*w1(3)*x74
        x308 = P1(3)*P2(3)*w2(2)
        x309 = P1(3)*P2(3)*w1(2)
        x310 = co(14)*x169
        x311 = P1(0)*x40
        x312 = P1(2)*x140
        x313 = co(4)*w2(3)*x60
        x314 = co(5)*w1(3)*x74
        x315 = P1(3)*x52
        x316 = co(1)*x74
        x317 = P1(0)*P2(0)*w2(3)
        x318 = P1(0)*P2(0)*w1(3)
        x319 = P1(3)*P2(0)*w1(0)
        x320 = P1(1)*P2(1)*w2(3)
        x321 = P1(2)*P2(2)*w1(3)
        x322 = P1(3)*P2(1)*w1(1)
        x323 = P1(3)*P2(2)*w1(2)
        x324 = P1(3)*P2(3)*w1(3)
        x325 = P1(3)*P2(3)*w2(3)
        wout(0) = -P1(0)*x171 - P1(0)*x172 - P1(1)*x194 + P1(1)*x75 + P1(1)*x77&
                   - P1(2)*x195 - P1(3)*P2(3)*w1(0)*x247 + P1(3)*x125 + P1(3)* &
                  x126 + w2(0)*x151 - w2(0)*x221 + w2(0)*x225 + w2(0)*x226 - w2&
                  (0)*x242 - w2(0)*x243 - x0*x219 - x0*x220 + x0*x5 + x10*x53  &
                   + x10*x56 + x100*x101 + x100*x102 - x100*x241 + x103*x13 +  &
                  x103*x4 + x108*x84 + x11*x53 + x11*x56 + x111*x84 + x114*x115&
                   + x116*x13 + x116*x4 + x117*x34 + x118*x119 + x119*x120 +   &
                  x119*x121 - x12*x53 - x12*x56 - x13*x153 + x13*x49 - x132*   &
                  x189 - x132*x191 + x136*x137 + x137*x143 - x139*x249 + x14*x9&
                   + x144*x44 + x144*x47 + x145*x146 + x146*x147 + x146*x148 + &
                  x146*x149 - x146*x177 - x146*x181 + x15*x9 + x150*x45 + x150*&
                  x9 + x152*x45 - x152*x48 - x152*x50 - x152*x51 - x152*x52 -  &
                  x152*x54 + x152*x9 - x153*x4 - x154*x160 - x154*x162 - x154* &
                  x229 - x154*x230 + x16*x9 - x163*x168 - x163*x170 - x163*x228&
                   + x17*x9 - x173*x48 - x173*x52 - x173*x54 - x178*x73 + x18* &
                  x25 + x18*x27 - x182*x73 - x183*x184 - x183*x185 - x187*x205 &
                   - x187*x209 - x196*x41 - x197*x41*x65 - x198*x41 - x199*x200&
                   - x200*x201 - x210*x211 - x210*x212 - x210*x245 - x213*x88  &
                   - x214*x88 - x217*x218 - x219*x48 - x219*x54 - x219*x6 -    &
                  x219*x7 - x220*x54 - x220*x6 + x220*x9 + x222*x223 + x222*   &
                  x227 - x222*x240 - x222*x244 + x223*x224 + x224*x227 - x224* &
                  x240 - x224*x244 - x231*x232 - x231*x234 - x232*x233 - x233* &
                  x234 - x235*x57 - x235*x58 - x235*x62 - x235*x64 - x236*x237 &
                   - x236*x238 - x236*x239 - x237*x246 - x238*x246 - x239*x246 &
                   - x248*x74 - x248*x76 + x28*x38 + x28*x42 + x31*x61 + x39*  &
                  x61 + x39*x65*x66 + x39*x67 + x4*x49 + x44*x46 + x46*x47 +   &
                  x48*x5 + x5*x54 + x5*x55 + x5*x6 + x5*x7 - x5*x8 - x5*x9 +   &
                  x78*x91 + x78*x99
        wout(1) = -P1(0)*x194 + P1(0)*x75 + P1(0)*x77 + P1(1)*P2(0)*co(0)*x222 &
                   + P1(1)*P2(0)*w1(0)*x233 - P1(1)*x172 - P1(2)*x268 - P1(2)* &
                  x269 + P1(3)*x259 + P1(3)*x260 - P2(1)*x0*x44 + w1(1)*x272 - &
                  w1(1)*x275 - w1(1)*x279 + w2(1)*x225 + w2(1)*x226 - w2(1)*   &
                  x242 - w2(1)*x243 + x0*x250 - x0*x263 - x0*x264 + x101*x216  &
                   + x102*x216 + x103*x161 - x104*x178 - x104*x182 - x107*x196 &
                   + x108*x128 - x110*x196 - x110*x198 + x111*x128 - x112*x168 &
                   - x112*x170 - x113*x211 - x113*x212 - x113*x245 + x115*x255 &
                   + x116*x161 + x117*x188 + x117*x190 + x120*x252 + x121*x252 &
                   - x122*x278 - x122*x284 + x131*x38 + x131*x42 + x14*x183 +  &
                  x146*x82 + x146*x86 - x146*x90 + x146*x92 + x146*x95 - x146* &
                  x98 + x15*x183 - x153*x161 + x154*x16 + x154*x17 + x155*x53  &
                   + x155*x56 + x157*x53 + x157*x56 - x158*x53 - x158*x56 -    &
                  x160*x48 + x161*x49 - x162*x48 - x175*x213 - x175*x214 - x184&
                  *x48 - x185*x48 - x189*x62 + x190*x258 - x191*x62 - x197*x267&
                   - x205*x33 - x209*x33 + x215*x25 + x215*x27 - x218*x270 +   &
                  x227*x273 - x229*x48 - x230*x48 - x231*x276 - x231*x277 -    &
                  x233*x276 - x233*x277 - x237*x274 - x237*x280 - x238*x274 -  &
                  x238*x280 - x239*x274 - x239*x280 - x240*x273 - x244*x273 -  &
                  x247*x281 + x249*x28 - x249*x58 + x249*x59 - x249*x64 + x250*&
                  x48 + x250*x54 + x250*x55 + x250*x6 + x250*x7 - x250*x8 -    &
                  x250*x9 + x251*x31 + x251*x39 + x253*x48 + x253*x54 + x253*  &
                  x55 - x253*x9 + x254*x45 - x254*x52 - x254*x54 - x254*x55 +  &
                  x254*x9 + x256*x257 + x261*x36 + x262*x36 - x263*x54 - x263* &
                  x6 - x263*x7 + x263*x8 + x263*x9 - x264*x54 - x264*x6 - x264*&
                  x7 + x264*x8 + x264*x9 + x265*x45 - x265*x48 - x265*x50 -    &
                  x265*x51 - x265*x52 - x265*x54 + x265*x9 - x266*x44 - x266*  &
                  x47 - x271*x48 - x271*x50 - x281*x282 - x281*x283 + x70*x91  &
                   + x70*x99
        wout(2) = P1(0)*P2(0)*w1(2)*x283 - P1(0)*x195 - P1(1)*P2(1)*w2(2)*x238 &
                   + P1(1)*x268 + P1(1)*x269 - P1(2)*x172 - P1(2)*x47*x51 + P1(&
                  3)*x288 - P1(3)*x307 - P2(3)*x307 + w1(2)*x272 - w1(2)*x279  &
                   + w2(2)*x151 - w2(2)*x221 - w2(2)*x243 - x0*x285 - x0*x289  &
                   - x0*x298 + x100*x14 + x100*x15 + x101*x54 + x102*x54 - x103&
                  *x24 - x105*x117 + x107*x61 + x108*x63 - x109*x117 - x109*   &
                  x258 + x110*x61 + x110*x67 + x111*x63 + x114*x286 - x116*x24 &
                   - x116*x26 - x120*x291 - x121*x291 - x123*x249 - x127*x189  &
                   - x127*x191 - x146*x202 - x146*x203 + x146*x204 - x146*x206 &
                   - x146*x207 + x146*x208 + x153*x24 + x153*x26 + x16*x18 -   &
                  x160*x216 - x162*x216 - x168*x192 + x17*x18 - x170*x192 -    &
                  x178*x186 - x182*x186 - x184*x215 - x185*x215 + x186*x300 -  &
                  x19*x53 - x19*x56 - x192*x228 - x193*x211 - x193*x212 - x199*&
                  x292 - x199*x296 - x201*x292 - x201*x296 - x205*x71 - x209*  &
                  x71 - x21*x53 - x21*x56 - x213*x80 - x214*x80 + x23*x53 + x23&
                  *x56 + x231*x301 - x231*x304 - x231*x305 - x231*x306 + x233* &
                  x301 - x233*x304 - x233*x305 - x233*x306 + x235*x93 + x237*  &
                  x299 - x237*x308 + x238*x299 - x238*x308 - x239*x308 - x24*  &
                  x49 - x241*x51 - x241*x54 - x247*x303 - x247*x309 + x25*x54  &
                   - x251*x41 - x255*x294 - x257*x295 + x261*x30 + x262*x30 +  &
                  x267*x66 + x27*x54 + x28*x284 - x282*x303 - x282*x309 - x283*&
                  x303 - x283*x305 - x283*x309 - x284*x62 - x285*x48 - x285*x54&
                   - x285*x55 - x285*x6 - x285*x7 + x285*x8 + x285*x9 + x287*  &
                  x45 - x287*x48 - x287*x50 - x287*x52 + x287*x9 - x289*x48 -  &
                  x289*x55 - x289*x7 + x289*x8 + x289*x9 + x290*x45 - x290*x50 &
                   - x290*x51 - x290*x52 - x290*x54 + x290*x9 - x293*x48 - x293&
                  *x54 - x297*x44 - x297*x47 - x298*x48 - x298*x54 - x298*x6 - &
                  x302*x48 - x302*x54 + x32*x91 + x32*x99 + x38*x83 + x42*x83
        wout(3) = P1(0)*P2(3)*w1(0)*x316 + P1(0)*x125 + P1(0)*x126 - P1(1)*P2(3&
                  )*w1(1)*x316 - P1(1)*x259 - P1(1)*x260 - P1(2)*x288 - P1(3)* &
                  x171 - P1(3)*x172 - P2(3)*x44*x7 - w1(3)*x240*x76 - w1(3)*   &
                  x275 - w1(3)*x316*x52 - w2(3)*x221 - w2(3)*x242 - w2(3)*x243 &
                   - x0*x245 + x0*x310 - x0*x313 + x101*x192 + x102*x192 + x103&
                  *x167 + x103*x169 + x105*x196 - x106*x178 - x106*x182 + x106*&
                  x300 + x108*x79 + x109*x196 + x109*x198 + x111*x79 - x112*   &
                  x184 - x112*x185 - x113*x160 - x113*x162 + x116*x167 + x116* &
                  x169 + x118*x311 + x120*x311 + x121*x311 + x130*x146 + x134* &
                  x146 - x135*x146 + x138*x146 + x14*x210 + x141*x146 - x142*  &
                  x146 + x15*x210 - x153*x167 - x153*x169 + x16*x163 + x163*x17&
                   + x164*x53 + x164*x56 + x165*x53 + x165*x56 - x166*x53 -    &
                  x166*x56 + x167*x49 - x168*x55 + x169*x49 - x170*x55 - x174* &
                  x189 - x174*x191 - x179*x249 - x188*x61 - x190*x61 - x190*x67&
                   + x193*x25 + x193*x27 + x197*x295 + x199*x312 + x201*x312 - &
                  x205*x29 - x209*x29 - x211*x55 - x212*x55 - x213*x64 - x214* &
                  x64 - x217*x286 + x228*x45 - x228*x48 - x228*x54 + x228*x9 + &
                  x231*x319 - x231*x322 - x231*x323 - x231*x324 + x233*x319 -  &
                  x233*x322 - x233*x323 - x233*x324 + x235*x96 + x237*x317 -   &
                  x237*x320 - x237*x325 + x238*x317 - x238*x320 - x238*x325 -  &
                  x239*x320 - x239*x325 - x245*x48 - x245*x54 - x245*x6 - x245*&
                  x7 + x245*x8 + x245*x9 + x247*x318 - x247*x321 - x247*x324 + &
                  x251*x34 - x256*x66 + x261*x72 + x262*x72 + x270*x294 - x278*&
                  x68 + x282*x318 - x282*x321 - x282*x324 + x283*x318 - x283*  &
                  x321 - x283*x324 - x284*x68 + x310*x48 + x310*x54 + x310*x55 &
                   + x310*x6 + x310*x7 - x310*x8 - x310*x9 - x313*x54 - x313*x6&
                   + x313*x8 + x314*x45 - x314*x48 - x314*x50 - x314*x51 - x314&
                  *x52 - x315*x44 - x315*x47 - x316*x324 + x35*x91 + x35*x99 + &
                  x38*x87 + x42*x87
      end select 
    end subroutine treeVVV
end module tcVVV
